var isExit = false;
var PMPMobileApp = angular.module('PMPMobile', ['ionic', 'PMPMobile.common',
	'PMPMobile.controller', 'PMPMobile.directive', 'PMPMobile.services',
	'PMPMobile.filters', 'PMPMobile.global'
]);
angular.module("PMPMobile.common", []);
angular.module("PMPMobile.controller", []);
angular.module("PMPMobile.directive", []);
angular.module("PMPMobile.services", []);
angular.module("PMPMobile.filters", []);
angular.module("PMPMobile.global", []);

PMPMobileApp
	.config(
		function($compileProvider) {
			$compileProvider
				.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|tel):/);
		})
	.config(
		function($httpProvider) {
			$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
		});

PMPMobileApp
	.config([
		'$stateProvider',
		'$urlRouterProvider',
		function($stateProvider, $urlRouterProvider) {
			$stateProvider
				.state(
					'Confirmed', {
						url: '/confirmed',
						templateUrl: 'views/bill/confirmed/bill-confirmed.html',
						controller: 'BillConfirmedController'
					})
				.state(
					'Commission', {
						url: '/commission/:info',
						templateUrl: 'views/bill/confirmed/commission-feedback.html',
						controller: 'CommissionFeedbackController'
					})
				.state(
					'History', {
						url: '/history',
						templateUrl: 'views/bill/history/history-bill.html',
						controller: 'HistoryBillController'
					})
				.state(
					'Invoice', {
						url: '/invoice/:sige',
						templateUrl: 'views/bill/invoice/invoice-management.html',
						controller: 'InvoiceManagementController'
					})
				.state(
					'FillInvoice', {
						url: '/fillinvoice/:info',
						templateUrl: 'views/bill/invoice/fill-invoice.html',
						controller: 'FillInvoiceController'
					})
				.state(
					'Prepayment', {
						url: '/prepayment/:type',
						templateUrl: 'views/bill/prepayment/prepayment-management.html',
						controller: 'PrepaymentManagementController'
					})
				.state(
					'AddInvoiceDetails', {
						url: '/addinvoicedetails/:data',
						templateUrl: 'views/bill/invoice/add-invoice-details.html',
						controller: 'AddInvoiceDetailsController'
					})
				.state(
					'ConfirmedDetail', {
						url: '/confirmedDetail/:data',
						templateUrl: 'views/bill/confirmed/bill-confirmed-detail.html',
						controller: 'BillConfirmedDetailController'
					})
				.state('BillStatus', {
					url: '/billStatus/:billId/:serviceType',
					templateUrl: 'views/common/bill-status.html',
					controller: 'BillStatusController'
				})
				.state(
					'BillProblemFeedback', {
						url: '/billProblemFeedback/:billId/:serviceType/:billNo',
						templateUrl: 'views/bill/confirmed/bill-problem-feedback.html',
						controller: 'BillProblemFeedbackController'
					})
				.state(
					'BatchApproval', {
						url: '/batchApproval',
						templateUrl: 'views/bill/confirmed/batch-approval.html',
						controller: 'BatchApprovalController'
					})
				.state(
					'EditPrepayment', {
						url: '/editPrepayment/:type',
						templateUrl: 'views/bill/prepayment/edit-prepayment.html',
						controller: 'EditPrepaymentController'
					})
				.state(
					'DetailPrepayment', {
						url: '/detailPrepayment',
						templateUrl: 'views/bill/prepayment/detail-prepayment.html',
						controller: 'DetailPrepaymentController'
					})
				.state(
					'PersonageBillDetails', {
						url: '/personageBillDetails/:data',
						templateUrl: 'views/bill/confirmed/personage-bill-details.html',
						controller: 'PersonageBillDetailsController'
					})

			.state(
				'billconfirmedagreement', {
					url: '/billConfirmedAgreement/:data',
					templateUrl: 'views/bill/confirmed/bill-confirmed-agreement.html',
					controller: 'BillConfirmedAgreementController'
				})
			$urlRouterProvider.otherwise('/confirmed');
		}
	]);

function toggleSuccess() {
	console.log('toggle callback ok');
}

function toggleError(errMsg) {
	console.log(errMsg);
}
PMPMobileApp
	.run([
		"GlobalInterceptorHandler",
		"$rootScope",
		'$ionicPlatform',
		'$location',
		'$timeout',
		'$ionicPopup',
		'$ionicModal',
		function(GlobalInterceptorHandler, $rootScope, $ionicPlatform,
			$location, $timeout, $ionicPopup) {
			GlobalInterceptorHandler
				.registerResponseHandling($rootScope);
			$ionicPlatform
				.registerBackButtonAction(
					function(e) {
						function showConfirm() {
							var confirmPopup = $ionicPopup
								.confirm({
									template: '退出将不保存发票，您是否确定退出?',
									buttons: [{
										text: '是',
										type: 'button-positive',
										onTap: function(e) {
											$rootScope.$viewHistory.backView
												.go();
										}
									}, {
										text: '否',
										type: 'button-positive'
									}]
								});
						}
						console.log("监听到返回键");
						console.log("当前地址", $location.path());
						/* 先捕获异常，禁止使用ionic中自带的处理机制，根据不同的页面的后缀，进行不同的页面的跳转处理 */
						e.preventDefault();
						// 如果是模块首页 按返回键回到平台
						if ($location.path() == "/confirmed" || $location.path() == "/invoice/add" || $location.path() == "/invoice/detail" || $location.path() == "/prepayment/new" || $location.path() == "/history") {
							var exec = cordova.require("cordova/exec");
							exec(toggleSuccess, toggleError,
								'TogglePlugin', 'toggle', [-3]);

						} else if ($location.path().indexOf("/addinvoicedetails") > -1) {//发票页面事件拦截
							if ($location.path().indexOf('\"sige\":\"detail\"') > -1) {//发票详情页面直接返回上一页
								$rootScope.$viewHistory.backView.go();
							} else {//如果是添加和编辑弹出提示框
								showConfirm();
							}

						} else {
							// 其他状态自行按历史返回
							$rootScope.$viewHistory.backView.go();
						}
						return false;
					}, 101);
		}
	]);