angular.module('PMPMobile.controller').controller('BatchApprovalController', ["$scope", "$rootScope", "$ionicModal", "$timeout", "$ionicPopup", "$ionicScrollDelegate", "ConfirmedApiServices", "DetailDisposeServices", "FooterServices",
	function($scope, $rootScope, $ionicModal, $timeout, $ionicPopup, $ionicScrollDelegate, ConfirmedApiServices, DetailDisposeServices, FooterServices) {
		$scope.title = "批量审批";
		FooterServices.hide();
		$scope.batchDatas = [];
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.openModalSubmit = function() {
			$scope.modal.show();
		};
		$scope.closeModal = function() {
			$scope.modal.hide();
		};
		$scope.openModal = function() {
			$scope.modalShow = "0";
			$scope.openModalSubmit();
		};

		function CheckAvailable(size) {
			$scope.noMoreItemsAvailable = size == $scope.batchDatas.length;
		}

		function getBillStatusConfirmed(type) {
			ConfirmedApiServices.getBillStatusConfirmed($scope.pageObj).then(function(res) {
				console.log(res);
				if (res.Flag == 1) {
					for (var i = 0; i < res.Result.length; i++) {
						res.Result[i].showkey = objtoarray(res.Result[i].show);
						res.Result[i].show2key = objtoarray(res.Result[i].show2);
						$scope.batchDatas.push(res.Result[i]);
					}
					CheckAvailable(res.totalCount);
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					if (type == "refresh") {
						if (res.Result.length > 0) {
							$scope.refresherData = "已经为您更新" + res.Result.length + "条数据";
							$(".refresher-data").show();
							$timeout(function() {
								$(".refresher-data").hide();
							}, 2000);
						}
					} else if (type == "loadMore") {
						if (res.Result.length > 0) {
							$scope.infiniteData = "已经为您加载" + res.Result.length + "条数据";
							$(".infinite-data").show();
							$timeout(function() {
								$(".infinite-data").hide();
							}, 2000);
						}
					}
					NoData(res.Result.length,"您当前选择的条件没有数据");
				} else {
					$ionicPopup.alert({
						template: "<p >" + res.Result.errmsg + "</p>"
					});
				}
			});
		}

		$scope.selectAll = function() {
			console.log("全选");
			for (var i = 0; i < $scope.batchDatas.length; i++) {
				$scope.batchDatas[i].isSelect = true;
			}
		};
		$scope.clearAll = function() {
			console.log("清空全选");
			for (var i = 0; i < $scope.batchDatas.length; i++) {
				$scope.batchDatas[i].isSelect = false;
			}
		};
		$scope.approvalSubmit = function() {
			console.log("提交");
			var batchArray = [];
			for (var i = 0; i < $scope.batchDatas.length; i++) {
				if ($scope.batchDatas[i].isSelect) {
					var item = {};
					item.billId = $scope.batchDatas[i].hide.billId;
					item.serviceType = $scope.batchDatas[i].hide.serviceType;
					batchArray.push(item);
				}
			}
			if (batchArray.length > 0) {
				var batchCon = "batchCon=" + JSON.stringify(batchArray);
				ConfirmedApiServices.billConfirm(batchCon).then(function(res) {
					console.log(res);
					if (res.Flag == 1) {
						$scope.openModal();
						window.setTimeout(function() {
							for (var i = 0; i < batchArray.length; i++) {
								$("#" + batchArray[i].billId + "item").hide();
								$ionicScrollDelegate.resize();
							}
							$scope.closeModal();
						}, 1000);
					} else {
						$ionicPopup.alert({
							template: "<p >" + res.Result.errmsg + "</p>"
						});
					}
				});
			} else {
				$ionicPopup.alert({
					title: "<p  class='network-error'>请至少选择一张账单！</p>"
				});
			}
		};
		/*接收时间选择器的值*/
		$scope.$on("batchbilltimeReceiver", function(event, data) {
			$scope.pageObj.countDate = data.data == "全部时间" ? "" : data.data;
			$scope.batchDatas = [];
			getBillStatusConfirmed("refresh");
		});

		/*初始化列表数据*/
		function init() {
			initPager($scope);
			if ($scope.pageObj.countDate == null) {
				$scope.pageObj.countDate = "";
			}
			$scope.batchDatas = [];
			getBillStatusConfirmed();
		}

		init();

		/*上拉刷新*/
		$scope.onRefresh = function() {
			initPager($scope);
			if ($scope.pageObj.countDate == null) {
				$scope.pageObj.countDate = "";
			}
			$scope.batchDatas = [];
			getBillStatusConfirmed("refresh");
		};

		/*下拉加载更多*/
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) {
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) {
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');

				return;
			} else {
				$scope.isFirstIn = true;
				$scope.pageObj.page++;
				getBillStatusConfirmed("loadMore");
			}
		};
	}
]);