angular.module('PMPMobile.controller').controller('BillConfirmedAgreementController', ["$scope", "$location", "$stateParams", 'FooterServices', 'ConfirmedApiServices', '$ionicScrollDelegate',
	function($scope, $location, $stateParams, FooterServices, ConfirmedApiServices, $ionicScrollDelegate) {
		$scope.title = "协议组详情";
		FooterServices.hide();
		$scope.clientHeight = (document.documentElement.clientHeight * 0.4) + 'px';
		$scope.currentTable = "基准服务费";
		$scope.businessType = [{
			"name": "基准服务费",
			"url": "views/bill/confirmed/reference-charge-details.html",
			"isSelected": true,
			"index": 2
		}, {
			"name": "持续服务奖",
			"url": "views/bill/confirmed/sustained-service.html",
			"isSelected": false,
			"index": 3
		}, {
			"name": "包干服务费",
			"url": "views/bill/confirmed/local-charge-details.html",
			"isSelected": false,
			"index": 4
		}, {
			"name": "临时路线服务费",
			"url": "views/bill/confirmed/temp-route-charge-details.html",
			"isSelected": false,
			"index": 5
		}, {
			"name": "异地审验油路费",
			"url": "views/bill/confirmed/circuit-fee.html",
			"isSelected": false,
			"index": 6
		}, {
			"name": "奖惩明细",
			"url": "views/bill/confirmed/reward-punishment-details.html",
			"isSelected": false,
			"index": 0
		}];
		$scope.chooseTable = function() {
			$scope.popShow = true;
		}
		$scope.closeModal = function() {
			$scope.popShow = false;
		}
		$scope.selectType = function(item) {
			_.each($scope.businessType, function(item) {
				item.isSelected = false;
			})
			item.isSelected = true;
			$scope.currentTable = item.name;
			$scope.currentTab = item.url;
			$scope.tableIndex = item.index;
			$scope.popShow = false;
		}
		$("#xuanfu").hide();
		$("#xuanfuReward").hide();
		$("#xuanfuSearchTable").hide();
		$scope.isFirstIn = true;
		$scope.noMoreItemsAvailable = false;
		var myGroup;
		var groupNum = 0;
		$scope.onscroll = function() {
			boundingClient();
		};

		function boundingClient() {

			//			if (GetByid("detail-tabs-div").getBoundingClientRect().top < 45) {
			//				$("#xuanfu").show();
			//			} else if (GetByid("detail-tabs-div").getBoundingClientRect().top > 45) {
			//				$("#xuanfu").hide();
			//			}
			if (GetByid("searchTable") != null) {
				if (GetByid("searchTable").getBoundingClientRect().top < 90) {
					console.log("高度低于90");
					var tableData = [];
					var gridObj = $.fn.bsgrid.init('xuanfuSearchTable', {
						localData: tableData,
						stripeRows: true,
						pageSizeSelect: true,
						pageAll: true,
						rowSelectedColor: false,
						isProcessLockScreen: false,
						displayPagingToolbarOnlyMultiPages: true
					});
					$("#xuanfuSearchTable").show();
					$scope.showTable = true;
				} else if (GetByid("searchTable").getBoundingClientRect().top > 90) {
					console.log("高度高于90");
					$("#xuanfuSearchTable").hide();
					$scope.showTable = false;

				}
			}
			if (myGroup != null) {
				if (myGroup[0].isShow && GetByid(myGroup[0].key).getBoundingClientRect().top < 90) {
					GetByid("rewardName").innerText = myGroup[0].typeName;
					$("#xuanfuReward").show();
					groupNum = 0;
				} else {
					$("#xuanfuReward").hide();
				}
				if (myGroup[1].isShow && GetByid(myGroup[1].key).getBoundingClientRect().top < 90) {
					GetByid("rewardName").innerText = myGroup[1].typeName;
					$("#xuanfuReward").show();
					groupNum = 1;
				}
				if (myGroup[2].isShow && GetByid(myGroup[2].key).getBoundingClientRect().top < 90) {
					GetByid("rewardName").innerText = myGroup[2].typeName;
					$("#xuanfuReward").show();
					groupNum = 2;
				}
			}
		}
		$scope.$on("RewardPunishmentDetails", function(event, group) {
			myGroup = group;
		});
		$scope.toggleGroup = function() {
			myGroup[groupNum].isShow = false;
			$ionicScrollDelegate.resize();
			setTimeout(function() {
				boundingClient();
			}, 200);
		};
		$scope.tabs = [{
			name: '账单明细',
			url: 'views/bill/confirmed/table-details.html',
		}, {
			name: '奖惩明细',
			url: 'views/bill/confirmed/reward-punishment-details.html'
		}];
		$scope.onClickTab = function(tab) {
			$scope.currentTab = tab.url;
			myGroup = null;
			if (tab.name == "账单明细") {
				$scope.noMoreItemsAvailable = false;
				$scope.tableIndex = 1;
			} else {
				$scope.noMoreItemsAvailable = true;
			}
			$ionicScrollDelegate.resize();
			$("#xuanfu").hide();
			$("#xuanfuReward").hide();
			$("#xuanfuSearchTable").hide();
		}
		$scope.isActiveTab = function(tabUrl) {
			return tabUrl == $scope.currentTab;
		}
		init();

		function init() {
			$scope.bill = JSON.parse($stateParams.data);
			var serviceType = $scope.bill.serviceType;
			console.log("路由参数：", $scope.bill);
			//判断是否有公路运输服务
			if (serviceType == '430' || serviceType == '432' || serviceType == '436') {
				$scope.currentTab = 'views/bill/confirmed/reference-charge-details.html';
				$scope.isHaulage = true;
				$scope.tableIndex = 2;
			} else {
				$scope.currentTab = 'views/bill/confirmed/table-details.html';
				$scope.isHaulage = false;
				$scope.tableIndex = 1;
			}
			//			$scope.bill = {
			//				"PRO_TEAM_NO": "20151202",
			//				"invoiceAmount": "6000",
			//				"afterInvoiceDeductions": "500",
			//				"settlementServiceFee": "5500"
			//			};
			setTimeout(function() {
				var tableData = [];
				var gridObj = $.fn.bsgrid.init('xuanfuSearchTable', {
					localData: tableData,
					stripeRows: true,
					pageSizeSelect: true,
					pageAll: true,
					rowSelectedColor: false,
					isProcessLockScreen: false,
					displayPagingToolbarOnlyMultiPages: true
				});
			}, 100);
		};
		/*下拉加载更多*/
		$scope.loadMore = function() {
			$timeout(function() {
				var tableScope = DetailDisposeServices.getTableScope();
				if (tableScope.localData.length < tableScope.dataListSize) {
					if ($scope.noMoreItemsAvailable) {
						$scope.$broadcast('scroll.infiniteScrollComplete');
						return;
					}
					if ($scope.isFirstIn) {
						$scope.isFirstIn = false;
						$scope.$broadcast('scroll.infiniteScrollComplete');
						return;
					} else {
						$scope.isFirstIn = true;
						DetailDisposeServices.getTableScope().updateTable();
						$scope.$broadcast('scroll.infiniteScrollComplete');
					}
				} else {
					$scope.noMoreItemsAvailable = true;
				}
			}, 500);
		};
		//		$scope.isFirstIn=true;
		//		$scope.noMoreItemsAvailable = false;
		//上拉加载更多
		//		$scope.freshTable = function() {
		//			
		//			if ($scope.noMoreItemsAvailable) {
		//				$scope.$broadcast('scroll.infiniteScrollComplete');
		//				return;
		//			}
		//			if ($scope.isFirstIn) {
		//				$scope.isFirstIn = false;
		//				$scope.$broadcast('scroll.infiniteScrollComplete');
		//				return;
		//			} else {
		//				console.log("加载更多");
		//				$scope.isFirstIn = true;
		//				$scope.$broadcast('freshTable', '');
		//				$scope.$broadcast('scroll.infiniteScrollComplete');
		//			}
		//
		//		};
		//接受是否还有数据的广播
		//		$scope.$on("loadMoreFlag", function(event, data) {
		//			console.log("接受数据");
		//			$scope.noMoreItemsAvailable=data;
		//		});
	}
]);