angular.module('PMPMobile.controller').controller('BillConfirmedDetailController', ['$rootScope', "$scope", "$location", "$stateParams", 'FooterServices', 'ConfirmedApiServices', '$ionicModal', '$timeout', '$ionicPopup', 'DetailDisposeServices', '$ionicScrollDelegate',
	function($rootScope, $scope, $location, $stateParams, FooterServices, ConfirmedApiServices, $ionicModal, $timeout, $ionicPopup, DetailDisposeServices, $ionicScrollDelegate) {
		$scope.title = "账单详情";
		FooterServices.hide();
		init();

		function init() {
			$scope.bill = JSON.parse($stateParams.data);
			//$scope.bill.commissionStatus = '3';
			switch($scope.bill.commissionStatus){
				case '2':
					$scope.commissionBtnName = '佣金反馈';
					break;
				case '3':
					$scope.commissionBtnName = '修改佣金';
					break;
				default:
					$scope.commissionBtnName = '';
					break;
			}
			console.log($scope.bill);
			$scope.supplier = JSON.parse(window.localStorage.getItem("supplier"));
			switch ($scope.bill.billStatus) {
				case "待确认":
					$scope.bill.billStatusClass = "to-be-confirmed";
					break;
				case "有异议":
					$scope.bill.billStatusClass = "objection";
					break;
				case "问题确认有误":
					$scope.bill.billStatusClass = "confirmed-mistake";
					break;
				case "归档":
					$scope.bill.billStatusClass = "archive";
					break;
				default:
					$scope.bill.billStatusClass = "to-be-confirmed";
			}
		};

		$scope.backToList = function(){
			$location.path('/confirmed');
		}

		$scope.openModalSubmit = function() {
			$scope.modal.show();
		};
		$scope.closeModal = function() {
			$scope.modal.hide();
		};
		$scope.openModal = function() {
			$scope.modalShow = "1";
			$scope.openModalSubmit();
		};
		$scope.confirmBill = function(flag) {
			if (flag) {
				var batchArray = [];
				var item = {};
				item.billId = $scope.bill.billId;
				item.serviceType = $scope.bill.serviceType;
				batchArray.push(item);
				var data = "batchCon=" + JSON.stringify(batchArray);
				ConfirmedApiServices.billConfirm(data).then(function(res) {
					console.log(res);
					if (res.Flag == 1) {
						$scope.modalShow = "0";
						window.setTimeout(function() {
							$location.path('/confirmed');
							$scope.closeModal();
						}, 1000);
					} else {
						$ionicPopup.alert({
							template: "<p>" + res.Result.errmsg + "</p>"
						});
					}
				});
			} else {
				$scope.closeModal();
			}
		};
		/*确认账单*/
		$scope.confirmed = function() {
			if($scope.bill.commissionStatus == '2'){
				$ionicPopup.alert({
					template: "<p>您尚未反馈佣金，请先反馈佣金，再确认账单！</p>"
				});
			}else{
				if (typeof($scope.modal) == "undefined") {
					$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
						scope: $scope,
						animation: 'slide-in-up'
					}).then(function(modal) {
						$scope.modal = modal;
					});
				}
				setTimeout(function() {
					$scope.openModal();
				}, 100);
			}
			
		};
		/*从账单详情进佣金反馈页面*/
		$scope.goCommissionFromDetail = function(){
			var data = {
				"agreemenNo":$scope.bill.agreemenNo,
				"agreemenId":$scope.bill.agreemenId,
				"billId":$scope.bill.billId,
				"billNo":$scope.bill.billNo,
				"billStatus":$scope.bill.billStatus,
				"countDate":$scope.bill.countDate,
				"serviceType":$scope.bill.serviceType,
				"serviceTypeCN":$scope.bill.serviceTypeCN,
				"tobeconfirmed":$scope.bill.tobeconfirmed,
				"invoiceAmount":$scope.bill.invoiceAmount,
				"afterInvoiceDeductions":$scope.bill.afterInvoiceDeductions,
				"settlementServiceFee":$scope.bill.settlementServiceFee,
				"reason":$scope.bill.reason,
				"areaCode":$scope.bill.areaCode,
				"commissionStatus":$scope.bill.commissionStatus,
				"entranceType":'detail'
			};
			console.log("router params: ",data);
			$location.path("/commission/" + JSON.stringify(data));
		};
		/*问题反馈*/
		$scope.questionFeedback = function() {
			$location.path('/billProblemFeedback/' + $scope.bill.billId + "/" + $scope.bill.serviceType + "/" + $scope.bill.billNo);
		};

		$scope.examineProblem = function() {
			if (typeof($scope.modal) == "undefined") {
				$ionicModal.fromTemplateUrl('views/bill/confirmed/bill-problem.html', {
					scope: $scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					$scope.modal = modal;
				});
			}
			setTimeout(function() {
				$scope.openModalSubmit();
			}, 100);
		}

		$scope.showmore = function(item) {
			if (item.pulldown == '展开内容') {
				item.pulldown = '收起内容';
			} else {
				item.pulldown = '展开内容';
			}
			$('#' + item.show1.PRO_TEAM_NO).toggle();
			$ionicScrollDelegate.resize();
		};
		$scope.goIntoDetail = function(item) {
			console.log(item);
			item.hide.serviceType = $scope.bill.serviceType;
			item.hide.PRO_TEAM_NO = item.show1.PRO_TEAM_NO;
			item.hide.invoiceAmount = $scope.bill.invoiceAmount;
			item.hide.afterInvoiceDeductions = $scope.bill.afterInvoiceDeductions;
			item.hide.settlementServiceFee = $scope.bill.settlementServiceFee;
			$location.path('billConfirmedAgreement/' + JSON.stringify(item.hide));
		};
		$scope.items = [];
		ConfirmedApiServices.getProtocolList($scope.bill.billId, $scope.bill.serviceType).then(function(res) {
			console.log(res);
			$scope.items = res.Result;
			for(var i=0;i<$scope.items.length;i++){
				$scope.items[i].pulldown = "展开内容";
				$scope.items[i].show1Key = objtoarray($scope.items[i].show1);
				$scope.items[i].show1Key.splice(0,1);
				$scope.items[i].show2Key = objtoarray($scope.items[i].show2);
			}
		});
	}
]);