angular.module('PMPMobile.controller').controller('BillProblemFeedbackController', ['$rootScope', "$scope", "$stateParams", "$location", "$ionicPopup", "ConfirmedApiServices",
	function($rootScope, $scope, $stateParams, $location, $ionicPopup, ConfirmedApiServices) {
		$scope.clientHeight = (document.documentElement.clientHeight - 350) + 'px';
		$scope.title = "问题反馈";
		$scope.supplier = JSON.parse(window.localStorage.getItem("supplier")).supplierName;
		$scope.name = $stateParams.billNo;
		$scope.contactname = "";
		$scope.contactPhone = "";
		$scope.feedBack = "";
		//		billId/:serviceType/:
		$scope.nameAlert = function() {
			checkName();
		};
		$scope.phoneAlert = function() {
			checkPhone();
		};
		$scope.phoneFocus = function() {
			checkName();
		}
		$scope.feedbackFocus = function() {
			checkName();
			checkPhone();
		}

		function checkName() {
			if ($("#contactName").val().length == 0) {
				$("#contactName").attr("placeholder", "联系人不能为空");
				return false;
			}
			return true;
		}

		function checkPhone() {
			if ($("#contactPhone").val().length == 0) {
				$("#contactPhone").attr("placeholder", "联系电话不能为空");
				return false;
			}
			return true;
		}

		function checkFeedback() {
			if ($("#feedback").val().length == 0) {
				return false;
			}
			return true;
		}
		$scope.complete = function() {
				var obj = {};
				obj.contacts = $("#contactName").val();
				obj.phone = $("#contactPhone").val();
				obj.remarks = $("#feedback").val();
				obj.billId = $stateParams.billId;
				obj.serviceType = $stateParams.serviceType;
				if (checkName() && checkPhone() && checkFeedback()) {
					re = /^1\d{10}$/;
					if (!re.test(obj.phone)) {
						$ionicPopup.alert({
							title: "<p  class='network-error'>手机号码填写有误</p>"
						});
						return;
					}
					var dataStr = "billId=" + obj.billId + "&contacts=" + obj.contacts + "&remarks=" + obj.remarks + "&phone=" + obj.phone + "&serviceType=" + obj.serviceType;
					ConfirmedApiServices.handleProblemFeedback(dataStr).then(function(res) {
						console.log(res);
						if (res.Flag == 1) {
							$location.path("/confirmed");
						} else {
							$ionicPopup.alert({
								template: "<p >" + res.Result.errmsg + "</p>"
							});
						}
					});
				} else {
					$ionicPopup.alert({
						title: "<p  class='network-error'>填写有误</p>"
					});
				}
			}
			//textarea 输入字数的限制
		ready();

		function ready() {
			$("#feedback").bind("click", showNum)
				.bind("keyup", showNum);
		};

		function showNum() {
			var num = this.value.length;
			$("#BillChangeNum").html(num);
		};

		$scope.isSubmitDisable = function() {
			if ($("#contactName").val().length != 0 &&
				$("#contactPhone").val().length != 0 &&
				$("#feedback").val().length != 0) {
				return false;
			} else {
				return true;
			}
		}
	}
]);