angular.module('PMPMobile.controller').controller('CommissionFeedbackController', ['$rootScope', "$scope", "$location", "$stateParams", 'FooterServices', 'ConfirmedApiServices', '$ionicModal', '$timeout', '$ionicPopup', 'DetailDisposeServices', '$ionicScrollDelegate',
	function($rootScope, $scope, $location, $stateParams, FooterServices, ConfirmedApiServices, $ionicModal, $timeout, $ionicPopup, DetailDisposeServices, $ionicScrollDelegate) {
		FooterServices.hide();
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modalConfirm = modal;
		});
		//页面关闭时销毁弹出框
		$scope.$on('$destroy', function() {
			$scope.modalConfirm.remove();
		});
		//类型为4的提示信息标志
		$scope.tipSign = "";
		$scope.clientHeight = (document.documentElement.clientHeight * 0.4) + 'px';
		$scope.title = "佣金反馈";
		//获取路由数据
		$scope.info = JSON.parse($stateParams.info);
		console.log("路由数据：", $scope.info);
		//获取入口类型 list、detail 
		var entranceType = $scope.info.entranceType;
		//获取佣金反馈状态 1,2,3
		var commissionStatus = $scope.info.commissionStatus;
		//获取合同Id
		var agreemenId = $scope.info.agreemenId;
		//获取服务类型
		var serviceType = $scope.info.serviceType;
		//获取账单日期
		var countDate = $scope.info.countDate;
		//获取业务区
		var areaCode = $scope.info.areaCode;
		//存储佣金数据
		$scope.commissionData = [];
		//佣金数据副本
		var commissionCopy = [];
		//存储浮动比例
		var payRate = 0;
		//存储所有原因
		$scope.allReason = [];
		//当前正在填写的项
		var fillIndex = -1;
		//存储一个佣金对象
		var fillItem = {};
		init();

		function init() {
			//获取请求结果
			console.log("请求佣金数据的参数为：");
			console.log("合同Id：", agreemenId);
			console.log("服务类型：", serviceType);
			console.log("合同日期：", countDate);
			console.log("佣金状态：", commissionStatus);
			console.log("业务区：", areaCode);
			console.log("------------------------------------------------------");
			ConfirmedApiServices.getCommissionData(agreemenId, serviceType, countDate, commissionStatus, areaCode).then(function(res) {
				if (res.Flag == 1) {
					$scope.commissionData = res.Result.data; //获取雇员佣金数据
					commissionCopy = angular.copy($scope.commissionData);
					$scope.allReason = res.Result.allReason; //获取所有异常原因
					payRate = res.Result.payRate; //获取佣金浮动比例
					console.log("所有雇员佣金数据为：", $scope.commissionData);
				}
			})

		}
		//获取佣金对象
		function getFillItem() {
			return fillItem;
		}
		//设置佣金对象
		function setFillItem(obj) {
			fillItem = obj;
		}
			//获取所有雇员编号 异常原因 实发佣金  佣金是否异常
		$scope.getDataStr = function() {
				var dataArr = [];
				_.each($scope.commissionData, function(obj) {
					var dataObj = {};
					dataObj.empNo = obj.empNo;
					dataObj.excReasonCode = obj.excReasonCode;
					dataObj.payActual = obj.payActual;
					dataObj.payError = obj.payError;
					dataArr.push(dataObj);
				})
				return JSON.stringify(dataArr);
			}
			//弹出原因选择框
		$scope.chooseReason = function(item, index) {
				//保存当前正在填写的项
				fillIndex = index;
				console.log("当前填写的佣金项为：" + fillIndex);
				//将原因选择框对应当前填写项上异常原因 置为已选状态
				if (!(item.excReason == '')) {
					//原因不为空 匹配异常原因 将其置为选中状态
					_.each($scope.allReason, function(obj) {
						if (obj.name == item.excReason) {
							obj.isSelected = true;
						}

					})
				}
				$scope.popShow = true;
			}
			//选择原因
		$scope.selectReason = function(obj) {
				//将选择的原因填入指定佣金项 
				$scope.commissionData[fillIndex].excReason = obj.name;
				$scope.commissionData[fillIndex].excReasonCode = obj.code;
				$scope.closeModal();
			}
			//关闭原因选择框 并将所有原因项置为未选中状态
		$scope.closeModal = function() {
				_.each($scope.allReason, function(item) {
					item.isSelected = false;
				})
				$scope.popShow = false;
			}
			//类型为4的提示框确认按钮
		$scope.hide = function() {
				switch ($scope.tipSign) {
					case 'blankPay': //佣金未填
						$scope.modalConfirm.hide();
						var hintClass = 'payActual' + getFillItem().empNo;
						$("." + hintClass).children().first().css("border", '1px solid red');
						$timeout(function() {
							$("." + hintClass).children().first().css("border", "none");
						}, 1000);
						break;
					case 'blankReason': //佣金异常未选择原因
						$scope.modalConfirm.hide();
						var hintClass = 'excReason' + getFillItem().empNo;
						$("." + hintClass).css("border", '1px solid red');
						$timeout(function() {
							$("." + hintClass).css("border", "none");
						}, 1000);
						break;

					default:
						break;

				}
			}
			//输入金额只能是非负数
		$scope.clearNaN = function(item) {
//				var num = item.payActual;
//				var hasMoreDot = num.indexOf('..') > 0;
//				var reg = /^[0-9]{0}([0-9]|[.])+$/;
//				var checkRes = reg.test(String(num));
//				item.payActual = (num != '.') && !hasMoreDot && checkRes ? num : "";
//				console.log("校验非法字符");
//				console.log("校验结果：", checkRes);
			}
			//填写时 校验实发佣金是否异常
		$scope.checkPayActual = function(item) {
				var num = item.payActual;
				//var hasMoreDot = String(num).indexOf('..') > 0;
				var hasMoreDot=String(num).split('.').length>2;
				var reg = /^[0-9]{0}([0-9]|[.])+$/;
				var checkRes = reg.test(String(num));
				item.payActual = (num != '.') && !hasMoreDot && checkRes ? num : "";
				console.log("校验非法字符");
				console.log("校验结果：", checkRes);
				console.log("您正在修改雇员编号为 " + item.empNo + " 的实发佣金");
				console.log("雇员佣金参考值：", item.paySuggest);
				console.log("佣金浮动比例：", payRate);
				console.log("正常佣金范围：", (item.paySuggest - item.paySuggest * payRate) + "----" + (item.paySuggest + item.paySuggest * payRate));
				console.log("填写的实发佣金：", num);
				console.log("------------------------------------------------------");
				if (item.payActual == '') {
					//填写的实发佣金为空  置佣金异常为0  将异常原因置空
					item.payError = 0;
					item.excReason = "";
					return false;
				} else if (num >= item.paySuggest - item.paySuggest * payRate && num <= item.paySuggest + item.paySuggest * payRate) {
					//填写的实发佣金正常时 置佣金异常为0 将异常原因置空
					item.payError = 0;
					item.excReason = "";
					return false;
				} else {
					//填写的实发佣金异常 置佣金异常为1  提示选择原因
					item.payError = 1;
					return true;
				}
			}
			// 校验所有雇员佣金数据中实发佣金是否填写
		$scope.checkBlankPay = function() {
				for (var i = 0; i < $scope.commissionData.length; i++) {
					var item = $scope.commissionData[i];
					console.log("当前佣金数据：", item);
					if (item.payActual.toString() == '') {
						//实发佣金未填, 给出提示框
						console.log("雇员编号为" + item.empNo + "的实发佣金未填");
						var hintClass = 'payActual' + item.empNo;
						$("." + hintClass).children().first().focus();
						setFillItem(item);
						$scope.modalShow = 4;
						$scope.remind = "无法确认，有实发佣金未填的项!";
						$scope.modalConfirm.show();
						$scope.tipSign = "blankPay";
						return false;
						break;
					}

				}
				return true;

			}
			// 校验所有雇员 佣金数据中实发佣金是异常时 是否已选择原因
		$scope.checkExcReason = function() {
				for (var i = 0; i < $scope.commissionData.length; i++) {
					var item = $scope.commissionData[i];
					if ($scope.checkPayActual(item) && item.excReason == '') {
						//佣金异常且未选择原因, 给出提示框
						console.log("雇员编号为" + item.empNo + "的佣金异常且未选择原因");
						var hintClass = 'excReason' + item.empNo;
						$("." + hintClass).focus();
						setFillItem(item);
						$scope.modalShow = 4;
						$scope.remind = "无法确认，有佣金异常未选择原因的项!";
						$scope.modalConfirm.show();
						$scope.tipSign = "blankReason";
						return false;
						break;
					}

				}
				return true;
			}
			//确认佣金
		$scope.confirm = function() {
				if ($scope.checkBlankPay() && $scope.checkExcReason()) { //校验佣金未填和异常原因未选择
					//请求确认佣金
					var dataStr = $scope.getDataStr();
					console.log("请求确认佣金的参数为：");
					console.log("合同Id：", agreemenId);
					console.log("服务类型：", serviceType);
					console.log("合同日期：", countDate);
					console.log("佣金状态：", commissionStatus);
					console.log("业务区：", areaCode);
					console.log("佣金数据：", dataStr);
					console.log("------------------------------------------------------");
					ConfirmedApiServices.confirmCommission(agreemenId, serviceType, countDate, areaCode, dataStr).then(function(res) {
						if (res.Flag == 1) {
							console.log("确认成功返回结果：", res);
							$scope.info.commissionStatus = res.Result.commissionStatus; //刷新佣金状态
							$scope.modalShow = 6;
							$scope.alertMsg = "确认成功!";
							$scope.modalConfirm.show();
							$timeout(function() {
								$scope.modalConfirm.hide();
								//确认成功后返回
								if (entranceType == 'list') {
									$location.path("/confirmed");
								} else if (entranceType == 'detail') {
									$location.path("/confirmedDetail/" + JSON.stringify($scope.info));
								}
							}, 1000);
						} else {
							$ionicPopup.alert({
								template: "<p >" + res.Result.errmsg + "</p>"
							});
						}
					})

				}
			}
			//返回
		$scope.back = function() {
			switch (entranceType) { //根据入口判断返回路径
				case 'list':
					$location.path("/confirmed");
					break;
				case 'detail':
					$location.path("/confirmedDetail/" + JSON.stringify($scope.info));
					break;
				default:
					break;
			}
		}
	}
]);