angular.module("PMPMobile.directive").directive('confirmedList', ['$rootScope', '$ionicModal', '$location', '$ionicPopup', '$ionicScrollDelegate', 'ConfirmedApiServices',
	function($rootScope, $ionicModal, $location,$ionicPopup,$ionicScrollDelegate, ConfirmedApiServices) {
		return {
			restrict: 'E',
			replace: true,
			scope: {
				data: '=',
				isall: '='
			},
			templateUrl: 'views/bill/confirmed/bill-confirmed-item.html',
			link: function(scope) {
				//scope.data.hide.commissionStatus = '3';
				
				scope.data.tobeconfirmed = scope.data.hide.billStatusCN == '待确认' ? true : false;
				scope.data.pulldown = '查看更多';
				scope.isbatch = scope.isall ? "all" : "";
				scope.data.hide.billStatusCN = scope.data.hide.billStatus == "04"?"审批中":scope.data.hide.billStatusCN;
				switch (scope.data.hide.billStatus){
					case "02":
					    scope.data.statusColor ="to-be-confirmed";
						break;
					case "04":
						scope.data.statusColor = "pending";
						break;
					case "05":
						scope.data.statusColor = "objection";
						break;
					case "06":
						scope.data.statusColor = "confirmed-mistake";
						break;
					case "07":
						scope.data.statusColor = "pending";
						break;
					case "08":
						scope.data.statusColor = "archive";
						break;
					case "09":
						scope.data.statusColor = "withdraw";
						break;
					case "10":
						scope.data.statusColor = "reject";
						break;
					case "11":
						scope.data.statusColor = "ecp-confirmed-mistake";
						break;
					default:
						scope.data.statusColor = "to-be-confirmed";
						break;
				}
				$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.modal = modal;
				});
				scope.openModalSubmit = function() {
					scope.modal.show();
				};
				scope.closeModal = function() {
					scope.modal.hide();
				};
				scope.openModal = function() {
					scope.modalShow = "1";
					scope.openModalSubmit();
				};
				scope.confirmBill = function(flag) {
					if (flag) {
						var batchArray = [];
						var item = {};
						item.billId = scope.data.hide.billId;
						item.serviceType = scope.data.hide.serviceType;
						batchArray.push(item);
						var data = "batchCon="+JSON.stringify(batchArray);
						ConfirmedApiServices.billConfirm(data).then(function(res){
								console.log(res);
								if(res.Flag==1){
									scope.modalShow = "0";
									window.setTimeout(function(){
										$("#"+scope.data.hide.billId+"item" ).hide();
										scope.closeModal();
									},1000);
								}else{
									scope.closeModal();
									$ionicPopup.alert({
										template: "<p >" + res.Result.errmsg + "</p>"
									});
								}
						});
					} else {
						scope.closeModal();
					}
				};
				scope.changeStatus = function() {
					scope.data.isSelect = !scope.data.isSelect;
				};
				scope.showmore = function() {
					if (scope.data.pulldown == '查看更多') {
						scope.data.pulldown = '收起内容';
					} else {
						scope.data.pulldown = '查看更多';
					}
					$('#' + scope.data.hide.billId).toggle();
					$ionicScrollDelegate.resize();
				};
				scope.confirm = function() {
					scope.openModal();
				};
				scope.canNotConfirm = function(){
					//switch(scope.data.hide.commissionStatus){
						//case '2':
							$ionicPopup.alert({
								template: "<p>您尚未反馈佣金，请先反馈佣金，再确认账单！</p>"
							});
						//	break;
						// case '3':
						// 	$ionicPopup.alert({
						// 		template: "<p>您有部分佣金尚未，请填写完毕，再确认账单！</p>"
						// 	});
						// 	break;
						//default:
						//	break;
					//}
				};
				scope.goIntoDetail = function() {
					var data = {
						"agreemenNo":scope.data.hide.AGREEMEN_NO,
						"agreemenId":scope.data.hide.AGREEMEN_ID,
						"billId":scope.data.hide.billId,
						"billNo":scope.data.show.billNo,
						"billStatus":scope.data.hide.billStatusCN,
						"countDate":scope.data.show.countDate,
						"serviceType":scope.data.hide.serviceType,
						"serviceTypeCN":scope.data.show.serviceTypeCN,
						"tobeconfirmed":scope.data.tobeconfirmed,
						"invoiceAmount":scope.data.show.invoiceAmount,
						"afterInvoiceDeductions":scope.data.show.afterInvoiceDeductions,
						"settlementServiceFee":scope.data.show.settlementServiceFee,
						"reason":scope.data.show2.reason,
						"areaCode":scope.data.show2.areaCode,
						"commissionStatus":scope.data.hide.commissionStatus,
					};
					$location.path("/confirmedDetail/" + JSON.stringify(data));
				};

				scope.goCommissionFromList = function(){
					var data = {
						"agreemenNo":scope.data.hide.AGREEMEN_NO,
						//"billId":scope.data.hide.billId,
						// "billNo":scope.data.show.billNo,
						// "billStatus":scope.data.hide.billStatusCN,
						 "countDate":scope.data.show.countDate,
						 "serviceType":scope.data.hide.serviceType,
						 "agreemenId":scope.data.hide.AGREEMEN_ID,
						 "areaCode":scope.data.show2.areaCode,
						// "serviceTypeCN":scope.data.show.serviceTypeCN,
						// "tobeconfirmed":scope.data.tobeconfirmed,
						// "invoiceAmount":scope.data.show.invoiceAmount,
						// "afterInvoiceDeductions":scope.data.show.afterInvoiceDeductions,
						// "settlementServiceFee":scope.data.show.settlementServiceFee,
						// "reason":scope.data.show2.reason,
						 "commissionStatus":scope.data.hide.commissionStatus,
						"entranceType":'list'
					};
					console.log("router params: ",data);
					$location.path("/commission/" + JSON.stringify(data));
				};
			}
		};
	}
]);