angular.module('PMPMobile.services').factory('ConfirmedApiServices', ["$http", "Global", "$q",
	function($http, Global, $q) {
		var getPromise = function(p) {
			var defer = $q.defer();
			p.success(function(response) {
				return defer.resolve(response);
			}).error(function() {
				return defer.reject();
			});
			return defer.promise;
		};
		return {
			/*根据时间获取待确认账单*/
			getBillConfirmed: function(obj) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/list.ht?billStatus=02,05,06&page=' + obj.page + '&pageSize=' + obj.pageSize + '&countDate=' + obj.countDate;
				return getPromise($http.get(url));
			},
			handleProblemFeedback: function(obj) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/questionFb.ht';
				return getPromise($http.post(url, obj));
			},
			/*获取总计*/
			getTotal: function(billId, serviceType) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/count.ht?billId=' + billId + '&serviceType=' + serviceType;
				return getPromise($http.get(url));
			},
			/*获取批量待确认账单*/
			getBatchBillConfirmed: function() {
				var array = [];
				for (var i = 0; i < 5; i++) {
					var obj = {};
					obj.billStatus = "待确认";
					var show = {};
					show.countDate = '2015-06';
					show.serviceType = '客户服务';
					show.billNo = 420156156156 + i;
					show.payStatus = '未付款';
					show.invoiceAmount = 200 + i;
					show.afterInvoiceDeductions = 150;
					show.settlementServiceFee = 500000;
					obj.show = show;
					var show2 = {};
					show2.lifnr = 1000017666;
					show2.operationDepCode = '上海区部';
					show2.areaCode = '上海';
					obj.show2 = show2;
					var hide = {};
					hide.billId = 966556 + i;
					obj.hide = hide;
					array.push(obj);
				}
				for (var j = 0; j < array.length; j++) {
					array[j].showkey = objtoarray(array[j].show);
					array[j].show2key = objtoarray(array[j].show2);
				}
				return array;
			},
			getRewardPunishment: function(sign, billId, serviceType) {
				var url = "";
				switch (sign) {
					//扣款
					case "deduct":
						url = Global.apiPath + '/pmp/app/busData/deductList.ht?billTeamId=' + billId + '&serviceType=' + serviceType;
						break;
						//补贴
					case "subsidy":
						url = Global.apiPath + '/pmp/app/busData/subsidyList.ht?billTeamId=' + billId + '&serviceType=' + serviceType;
						break;
						//奖励
					case "rewards":
						url = Global.apiPath + '/pmp/app/busData/rewardList.ht?billTeamId=' + billId + '&serviceType=' + serviceType;
						break;
				}
				return getPromise($http.get(url));
			},
			/*账单明细*/
			getBillDetail: function(billTeamId, account, page, pageSize) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/detail.ht?billTeamId=' + billTeamId + '&ACCOUNT_MODEL_CODE=' + account + '&page=' + page + '&pageSize=' + pageSize;
				return getPromise($http.get(url));
			},
			/*账单确认*/
			billConfirm: function(data) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/confirm.ht';
				return getPromise($http.post(url, data));
			},
			/*根据时间获取待确认状态的账单*/
			getBillStatusConfirmed: function(obj) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/list.ht?billStatus=02&page=' + obj.page + '&pageSize=' + obj.pageSize + '&countDate=' + obj.countDate;
				return getPromise($http.get(url));
			},
			/*协议组列表*/
			getProtocolList: function(billId, serviceType) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/teamList.ht?serviceType=' + serviceType + '&billId=' + billId;
				return getPromise($http.get(url));
			},
			/*基准服务费*/
			getReferenceChargeDetails: function(billTeamId, serviceType, page, pageSize) {
				var url = Global.apiPath + '/pmp/app/busData/getBaseFee.ht?billTeamId=' + billTeamId + '&serviceType=' + serviceType +'&page='+page+'&pageSize='+pageSize;
				return getPromise($http.get(url));
				// return {
				// 	"Flag": "1",
				// 	"Result": [{
				// 		"a": "4210254",
				// 		"b": "鄂A-0214",
				// 		"c": "200.0",
				// 		"d": "2",
				// 		"e": "￥20.0",
				// 		"f": "￥20.0"
				// 	}, {
				// 		"a": "4210254",
				// 		"b": "鄂A-0214",
				// 		"c": "200.0",
				// 		"d": "2",
				// 		"e": "￥20.0",
				// 		"f": "￥20.0"
				// 	}, {
				// 		"a": "4210254",
				// 		"b": "鄂A-0214",
				// 		"c": "200.0",
				// 		"d": "2",
				// 		"e": "￥20.0",
				// 		"f": "￥20.0"
				// 	}]
				// };
			},
			/*包干服务费*/
			getLocalChargeDetails: function(billTeamId, serviceType, page, pageSize) {
				var url = Global.apiPath + '/pmp/app/busData/getBgFee.ht?billTeamId=' + billTeamId + '&serviceType=' + serviceType +'&page='+page+'&pageSize='+pageSize;
				return getPromise($http.get(url));
				// return {
				// 	"Flag": "1",
				// 	"Result": [{
				// 		"a": "4210254",
				// 		"b": "鄂A-0214",
				// 		"c": "200.0",
				// 		"d": "2",
				// 		"e": "￥20.0",
				// 		"f": "￥20.0"
				// 	}, {
				// 		"a": "4210254",
				// 		"b": "鄂A-0214",
				// 		"c": "200.0",
				// 		"d": "2",
				// 		"e": "￥20.0",
				// 		"f": "￥20.0"
				// 	}, {
				// 		"a": "4210254",
				// 		"b": "鄂A-0214",
				// 		"c": "200.0",
				// 		"d": "2",
				// 		"e": "￥20.0"
				// 	}]
				// };
			},
			/*临时路线服务费*/
			getTempRouteChargeDetails: function(billTeamId, serviceType, page, pageSize) {
				var url = Global.apiPath + '/pmp/app/busData/getTempLineFee.ht?billTeamId=' + billTeamId + '&serviceType=' + serviceType +'&page='+page+'&pageSize='+pageSize;
				return getPromise($http.get(url));
				// return {
				// 	"Flag": "1",
				// 	"Result": [{
				// 		"a": "4210254",
				// 		"b": "鄂A-0214",
				// 		"c": "科技园",
				// 		"d": "万基",
				// 		"e": "40",
				// 		"f": "￥400",
				// 		"g": "45",
				// 		"h": "￥25",
				// 		"i": "￥25"
				// 	}]
				// };
			},
			//异地审验油路费
			getCircuitFeeDetails: function(billTeamId,serviceType, page, pageSize) {
				var url = Global.apiPath + '/pmp/app/busData/getCheckFee.ht?billTeamId=' + billTeamId+ '&serviceType=' + serviceType + '&page=' + page + '&pageSize=' + pageSize;
				return getPromise($http.get(url));
			},
			//持续服务奖
			getServiceRewardDetails: function(billTeamId,serviceType, page, pageSize) {
				var url = Global.apiPath + '/pmp/app/busData/getStartBusFund.ht?billTeamId=' + billTeamId+ '&serviceType=' + serviceType + '&page=' + page + '&pageSize=' + pageSize;
				return getPromise($http.get(url));
			},
			//获取佣金反馈数据
			getCommissionData: function(agreemenId, serviceType, countDate, commissionStatus, areaCode) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/commissionList.ht?agreemenId=' + agreemenId + '&serviceType=' + serviceType + '&countDate=' + countDate + '&commissionStatus=' + commissionStatus + '&areaCode=' + areaCode;
				return getPromise($http.get(url));
				//造假数据
				//				var res = {};
				//				res.flag = 1;
				//				res.commissionStatus = 2; //佣金状态 1表示没有佣金 2表示未填佣金 3表示填完佣金
				//				res.payRate = 0.1; //容差比例
				//				res.allReason = [{ //所有原因
				//					"name": "考情内部再分配",
				//					"isSelected": false
				//				}, {
				//					"name": "出勤率不足",
				//					"isSelected": false
				//				}, {
				//					"name": "未转及提",
				//					"isSelected": false
				//				}, {
				//					"name": "其他扣款",
				//					"isSelected": false
				//				}, {
				//					"name": "奖励/奖金",
				//					"isSelected": false
				//				}];
				//				res.Result = []; //雇员佣金结果
				//				var item = {};
				//				item.empNo = 0; //雇员编号
				//				item.paySuggest = 1000; //佣金参考值
				//				item.empName = "李忠"; //雇员姓名
				//				item.payActual = 300; //实发佣金
				//				item.payError = 1; //佣金是否异常
				//				item.excReason = "考情内部再分配"; //异常原因
				//				res.Result.push(item);
				//
				//				var item = {};
				//				item.empNo = 1; //雇员编号
				//				item.paySuggest = 2000; //佣金参考值
				//				item.empName = "张洋"; //雇员姓名
				//				item.payActual = 100; //实发佣金
				//				item.payError = 1; //佣金是否异常
				//				item.excReason = "出勤率不足"; //异常原因
				//				res.Result.push(item);
				//				return res;
			},
			//佣金确认
			confirmCommission: function(agreemenId, serviceType, countDate, areaCode, dataStr) {
				var url = Global.apiPath + '/pmp/app/bill/billCount/commissionSave.ht?agreemenId=' + agreemenId + '&serviceType=' + serviceType + '&countDate=' + countDate + '&areaCode=' + areaCode + '&dataStr=' + dataStr;
				return getPromise($http.get(url));
				//				var res = {};
				//				res.flag = 1;
				//				res.commissionStatus = 3;
				//				return res;
			}
		};
	}
]);