angular.module('PMPMobile.controller', ['swiperRepeat']).controller('AddInvoiceDetailsController', ["$scope", "$stateParams", "FooterServices", "$ionicModal", "AddInvoiceApiServices", "$ionicPopup", "$location",
	function($scope, $stateParams, FooterServices, $ionicModal, AddInvoiceApiServices, $ionicPopup, $location) {
		FooterServices.hide();
	
		$scope.swiperItems = [];
		$scope.swiperLists = [];
		$scope.totalTaxMoney = 0;
		var data = JSON.parse($stateParams.data);
		console.log("router param in add invoice page :",data);
		//待审核和驳回状态可删除
		if(data.sige != 'detail' && (data.invoiceStatus == '01' || data.invoiceStatus == '03')){
			$scope.ifDel = true;
		}else{
			$scope.ifDel = false;
		}
		
		//初始化发票基本信息项
		$scope.item = {
			"taxType": "02",//发票类型
			"isUse": "0",//是否可抵用
			"taxRateItem": ""//税率
		};
		$scope.invoiceNum = data.billNo;
		var sige = data.sige;
		var isFill = data.isFill;
		var invoiceMoney = 0;
		//供应商容差
		var allowance = parseFloat(JSON.parse(window.localStorage.getItem("supplier")).allowance);
		//获取发票剩余金额
		$scope.invoiceAmount = (data.invoiceAmount - data.allInvoiceAmount).toFixed(2);
		// if(sige == "add"){
		// 	$scope.invoiceAmount = (data.invoiceAmount - data.allInvoiceAmount).toFixed(2);
		// }else if(sige == "update" || sige == "detail"){
		// 	countTotalTaxMoney();
		// 	$scope.invoiceAmount = (data.invoiceAmount - data.allInvoiceAmount + parseFloat($scope.totalTaxMoney)).toFixed(2)
		// }
		$scope.explain = "发票是否已全部录入？";
		$scope.ok = "是";
		$scope.no = "否";
		var errorPage = -1;
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modalConfirm = modal;
		});
		$ionicModal.fromTemplateUrl('views/common/drop-down.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.$on('$destroy', function() {
			if ($scope.modal) {
				$scope.modalConfirm.remove();
			}
		});
		$scope.back = function() {
			if(sige == 'add' || sige == 'update'){
				$scope.modalShow = 5;
				$scope.explain = "退出将不保存发票，您是否确定退出?";
				$scope.modalConfirm.show();
			}else{
				$location.path('/invoice/' + sige);
			}
		};
		$scope.isRevoke = function(param){
			$scope.modalConfirm.hide();
			if(param){
				$location.path('/invoice/' + sige);
			}
		};
		var myJson = {
			"billNo": $scope.invoiceNum,
			"billId": data.billId,
			"operationDepCode": data.operationDepCode,
			"operationDepName": data.operationDepName,
			"areaCode": data.areaCode,
			"areaName": data.areaName,
			"networkCode": data.networkCode,
			"networkName": data.networkName,
			// "countDate": data.countDate,
			"isBatch": "",
			"serviceType": data.serviceType
		};
		$scope.isBatch = function(batch) {
			if (batch) {
				myJson.isBatch = "0";
			} else {
				myJson.isBatch = "1";
			}
			$scope.hide();
			for (var i = 0; i < $scope.swiperLists.length; i++) {
				var swiper = $scope.swiperLists[i];
				swiper.taxType = $scope.item.taxType;
				swiper.isUse = $scope.item.isUse;
				swiper.taxRateItem = $scope.item.taxRateItem;
			}
			myJson.invoiceDetail = $scope.swiperLists;
			switch (sige) {
				case 'add':
					AddInvoiceApiServices.addInvoice('json=' + JSON.stringify(myJson)).then(function(res) {
						invoiceRes(res);
					});
					break;
				case 'update':
					AddInvoiceApiServices.updateInvoice('json=' + JSON.stringify(myJson)).then(function(res) {
						console.log("myJson:",JSON.stringify(myJson));
						invoiceRes(res);
					});
					break;
			}
		};
		//计算显示在header的开票合计
		function countTotalTaxMoney(){
			$scope.totalTaxMoney = 0;
			for(swiperItemsIndex in $scope.swiperItems){
				if($scope.swiperLists[$scope.swiperItems[swiperItemsIndex]].taxMoney != "" && $scope.swiperLists[$scope.swiperItems[swiperItemsIndex]].taxMoney != undefined){
					$scope.totalTaxMoney = parseFloat(parseFloat($scope.totalTaxMoney) + parseFloat($scope.swiperLists[$scope.swiperItems[swiperItemsIndex]].taxMoney)).toFixed(2);
				}				
			}
		}

		function invoiceRes(res) {
			if (res.Flag == '1') {
				$scope.modalShow = 0;
				$scope.modalConfirm.show();
				window.setTimeout(function() {
					$location.path('/invoice/' + sige);
					$scope.modalConfirm.hide();
				}, 1000);
			} else {
				$ionicPopup.alert({
					template: "<p>" + res.Result.errmsg + "</p>"
				});
			}
		};
		//提交
		$scope.submit = function() {
			if($scope.swiperItems.length > 0){
				switch (required()) {
					case 0:
						if ($scope.item.taxType == "01" && $scope.item.isUse == "1" && $scope.item.taxRateItem == "") {
							$ionicPopup.alert({
								template: "<p>您的税率为空，请填写!</p>"
							});
						} else {
							// if (invoiceMoney > (Number($scope.invoiceAmount) - allowance) && invoiceMoney < (Number($scope.invoiceAmount) + allowance) && invoiceMoney != 0) {
							// 	$scope.isBatch(true);
							// } else {
								$scope.modalShow = 3;
								$scope.explain = "发票是否已全部录入？";
								$scope.modalConfirm.show();
							// }
						}
						break;
					case 1:
						fillInError();
						break;
					case 2:
						moneyError();
						break;
				}
			}			
		};
		$scope.hide = function() {
			$scope.modalConfirm.hide();
		};

		//set从FillInvoicePage回来的数据
		$scope.setFillInvoiceData = function(){
			$scope.swiperLists = AddInvoiceApiServices.getAllInvoice();
			console.log('所有发票',$scope.swiperLists);
			for (var i = 0; i < $scope.swiperLists.length; i++) {
				$scope.swiperItems.push(i);
				if ($scope.swiperLists[i].inTax == "0") {
					$scope.swiperLists[i].inTax = '';
				}
				$scope.item.taxType = $scope.swiperLists[0].taxType;
				$scope.item.isUse = $scope.swiperLists[0].isUse;
				$scope.item.taxRateItem = $scope.swiperLists[0].taxRateItem;
				countTotalTaxMoney();
			}
			if (sige == 'update' || sige == 'detail') {
				$scope.invoiceNum = data.billNo;
				myJson.billNo = data.billNo;
				myJson.batchNo = data.batchNo;
				myJson.billId = data.billId;
				myJson.serviceType = data.serviceType;
				myJson.invoiceId = data.invoiceId;
				myJson.operationDepCode = data.operationDepCode;
				myJson.operationDepName = data.operationDepName;
				myJson.areaCode = data.areaCode;
				myJson.areaName = data.areaName;
				myJson.networkCode = data.networkCode;
				myJson.networkName = data.networkName;				
			}
			if(sige == "update"){	//若为编辑发票页面时，可开票金额（可编辑的金额），要加上本页面内所有发票的开票合计
				$scope.invoiceAmount = (data.invoiceAmount - data.allInvoiceAmount + parseFloat($scope.totalTaxMoney)).toFixed(2);
			}
			
		}
		init();

		function init() {
			switch (sige) {
				case 'add':
				console.log('所有发票', AddInvoiceApiServices.getAllInvoice());
					$scope.title = "添加发票";
					$scope.editDetailShow = true;
					if(isFill){
						$scope.setFillInvoiceData();
					}
					break;
				case 'update':
					$scope.title = "编辑发票";
					$scope.editDetailShow = true;
					if(isFill){	//若是从fillInvoice页面回来，则从service的get方法里取发票明细数据
						$scope.setFillInvoiceData();
					}else{	//若是从列表页进入本页面，则向后台请求数据库数据
						updata();
					}					
					break;
				case 'detail':
					$scope.title = "查看发票";
					$scope.editDetailShow = false;
					if(isFill){
						$scope.setFillInvoiceData();
					}else{
						updata();
					}	
					break;
			}
		};

		function updata() {
			AddInvoiceApiServices.jumpEditInvoice(data.invoiceId).then(function(res) {
				console.log(res);
				if (res.Flag == '1') {
					$scope.invoiceNum = res.Result.invoice.billNo;
					myJson.billNo = res.Result.invoice.billNo;
					$scope.swiperLists = res.Result.invoiceDetail;
					myJson.batchNo = res.Result.invoice.batchNo;
					myJson.billId = res.Result.invoice.billId;
					myJson.serviceType = res.Result.invoice.serviceType;
					myJson.invoiceId = res.Result.invoice.invoiceId;
					myJson.operationDepCode = res.Result.invoice.operationDepCode;
					myJson.operationDepName = res.Result.invoice.operationDepName;
					myJson.areaCode = res.Result.invoice.areaCode;
					myJson.areaName = res.Result.invoice.areaName;
					myJson.networkCode = res.Result.invoice.networkCode;
					myJson.networkName = res.Result.invoice.networkName;
					for (var i = 0; i < $scope.swiperLists.length; i++) {
						$scope.swiperItems.push(i);
						if ($scope.swiperLists[i].inTax == "0") {
							$scope.swiperLists[i].inTax = '';
						}
					}
					$scope.item.taxType = $scope.swiperLists[0].taxType;
					$scope.item.isUse = $scope.swiperLists[0].isUse;
					$scope.item.taxRateItem = $scope.swiperLists[0].taxRateItem;
					countTotalTaxMoney();
					if(sige == 'update'){
						$scope.invoiceAmount = (data.invoiceAmount - data.allInvoiceAmount + parseFloat($scope.totalTaxMoney)).toFixed(2);
					}
					
				}
			});
		}
		$scope.change = function(id, name) {
			$("#" + id).css("border", "");
			var swiper = $scope.swiperLists[$scope.number];
			var split = swiper[name].split(".");
			if (split.length > 1 && split[1].length > 1) {
				swiper[name] = parseFloat(swiper[name]).toFixed(2);
			}
			switch (name) {
				case 'taxMoney':
					swiper.inTax = (swiper.taxMoney * ($scope.item.taxRateItem / 100) / (1 + $scope.item.taxRateItem / 100)).toFixed(2);
					countTotalTaxMoney();
					break;
				case 'inTax':
					if (parseFloat(swiper.inTax) > parseFloat(swiper.taxMoney)) {//进项税不能大于开票金额
						swiper.inTax = "0.00";
						$ionicPopup.alert({
							template: "<p>您当前的进项税有误!</p>"
						});
					}
					break;
			}
		};
		$scope.pageShow = false;
		$scope.$watch('selected', function(item) {
			$scope.number = item;
		});
		//上一条数据
		$scope.previous = function() {
			if ($scope.number > 0) {
				$scope.selected = $scope.number - 1;
			}
		};
		//下一条数据
		$scope.next = function() {
			if ($scope.number < $scope.swiperItems.length - 1) {
				$scope.selected = $scope.number + 1;
			}
		};
		//页数跳转
		$scope.pageSelect = function(page) {
			$scope.selected = page;
			$scope.pageShow = false;
		};
		//页数选择显示
		$scope.pageSelectShow = function() {
			$scope.pageShow = !$scope.pageShow;
		};
		//删除本页数据
		function removeData() {
			$scope.swiperLists[$scope.number] = GetBillDetails();
		};
		//删除页数
		function removeSwiper() {
			if ($scope.swiperItems.length > 1) {
				if ($scope.number == $scope.swiperItems.length - 1) {
					$scope.selected = $scope.swiperItems.length - 2;
				}
				$scope.swiperLists.splice($scope.number, 1);
				$scope.swiperItems.splice($scope.swiperItems.length - 1, 1);
			} else {
				$ionicPopup.alert({
					template: "<p >当前发票只剩一页，无法删除!</p>"
				});
			}
		};
		//添加页数
		function addSwiper() {
			switch (required()) {
				case 0:
					$scope.swiperLists.push(GetBillDetails());
					$scope.swiperItems.push($scope.swiperItems.length);
					$scope.selected = $scope.swiperLists.length - 1;
					break;
				case 1:
					fillInError();
					break;
				case 2:
					moneyError();
					break;
			}
		};
		$scope.swiperOperation = function(swiper) {
			switch (swiper) {
				case 0:
					removeSwiper();
					break;
				case 1:
					addSwiper();
					break;
				case 2:
					removeData();
					break;
			}
		};
		$scope.invoiceRemarkChange = function() {
			if (typeof($("#changeNum" + $scope.number).val()) != "undefined") {
				var num = $("#changeNum" + $scope.number).val().length;
				$("#change" + $scope.number).html(num);
			}
		};

		function moneyError() {
			$scope.modalShow = 4;
			$scope.remind = "您所填发票中金额超出可开票金额,可开票金额" + data.invoiceAmount + ",已开金额" + data.allInvoiceAmount + ",请核对后提交。";
			$scope.modalConfirm.show();
		};

		function fillInError() {
			$scope.modalShow = 4;
			$scope.remind = "您所填发票中包含必填项为空或为0,请核对后提交。";
			$scope.modalConfirm.show();
			$scope.selected = errorPage;
			errorPage = -1;
		};

		function required() {
			invoiceMoney = 0;
			var errorNum = 0;
			var data = $scope.swiperLists;
			console.log('required before submit, swiperLists: ',$scope.swiperLists);
			for (var i = 0; i < data.length; i++) {
				invoiceMoney += parseFloat(data[i].taxMoney);//所有开票金额之和
				if (data[i].invoiceNo == "") {//发票编号为空
					$("#required" + i + "invoiceNo").css("border", "1px solid #f00");
					errorNum = 1;
				}
				if (data[i].taxMoney == "" || parseFloat(data[i].taxMoney) == '0') {//开票金额为空
					$("#required" + i + "taxMoney").css("border", "1px solid #f00");
					errorNum = 1;
				}
				if (errorPage == -1 && errorNum == 1) {
					errorPage = i;
				}
			}
			if (invoiceMoney > (Number($scope.invoiceAmount) + allowance)) {//开票总额大于容差金额+发票剩余金额
				errorNum = 2;
			}
			return errorNum;
		}
		var choiceData = "";
		//下拉数据和显示
		$scope.openModal = function(data) {
			switch (data) {
				case "taxType":
					$scope.downData = InvoiceType();
					break;
				case "isUse":
					$scope.downData = YesNo();
					break;
				case "taxRateItem":
					$scope.downData = TaxRate();
					break;
			}
			$scope.modal.show();
			choiceData = data;
		};
		$scope.closeModal = function() {
			$scope.modal.hide();
		};
		//点击下拉数据
		$scope.dropDown = function(data) {
			$scope.item[choiceData] = data.key;
			$scope.closeModal();
			if (choiceData == "taxRateItem") {
				updataSwiper();
			}
			if (choiceData == "taxType") {
				if (data.key != "01") {
					$scope.item.isUse = "0";
					$scope.item.taxRateItem = "";
					updataSwiper();
				} else {
					$scope.item.isUse = "1";
				}
			}
			if(choiceData == "isUse"){
				if(data.key == "0"){
					$scope.item.isUse = "0";
					$scope.item.taxRateItem = "";
					updataSwiper();
				}else{
					$scope.item.isUse = "1";
				}
			}
		};

		function updataSwiper() {
			for (var i = 0; i < $scope.swiperLists.length; i++) {
				var swiper = $scope.swiperLists[i];
				swiper.taxType = $scope.item.taxType;
				swiper.isUse = $scope.item.isUse;
				swiper.taxRateItem = $scope.item.taxRateItem;
				swiper.inTax = (swiper.taxMoney * ($scope.item.taxRateItem / 100) / (1 + $scope.item.taxRateItem / 100)).toFixed(2);
			}
		}
		var deleteMaItemIndex = '';
		var deleteMaItemType = '';
		$scope.deleteMaItem = function(index, type){
			deleteMaItemIndex = index;
			deleteMaItemType = type;
			$scope.modalShow = 2;
			$scope.deleteAlert = "您是否确定删除此张发票?";
			$scope.modalConfirm.show();
		};
		$scope.deleteInvoice = function(){
			if(deleteMaItemType == 'local'){
				$scope.swiperLists.splice(deleteMaItemIndex,1);
				$scope.swiperItems.splice($scope.swiperLists.length,1);
				countTotalTaxMoney();
				$scope.modalConfirm.hide();
			}else if(deleteMaItemType == 'net'){
				$scope.modalConfirm.hide();
				AddInvoiceApiServices.deleteInvoice(myJson.invoiceId).then(function(res) {
					if (res.Flag == '1') {
						$scope.modalShow = 6;
						$scope.alertMsg = "您已成功删除此张发票！";
						$scope.modalConfirm.show();
						window.setTimeout(function() {
							$location.path('/invoice/' + sige);
							$scope.modalConfirm.hide();
						}, 1000);
					}else{
						$ionicPopup.alert({
							template: "<p>" + res.Result.errmsg + "</p>"
						});
					}
				});
			}
			
		};
		$scope.cancelInvoice = function(){
			$scope.modalConfirm.hide();
		};

		//组织跳转到fillinvoice page的router params
		$scope.organizeParam = function(){
			if (sige == 'update' || sige == 'detail') {
				data.areaCode = myJson.areaCode;
				data.areaName = myJson.areaName;
				data.batchNo = myJson.batchNo;
				data.billId = myJson.billId;
				data.billNo = myJson.billNo;
				data.isBatch = myJson.isBatch;
				data.networkCode = myJson.networkCode;
				data.networkName = myJson.networkName;
				data.operationDepCode = myJson.operationDepCode;
				data.operationDepName = myJson.operationDepName;
			}
		};

		//点击“添加发票”
		$scope.goFillInvoice = function(){
			if(parseFloat($scope.totalTaxMoney) >= parseFloat($scope.invoiceAmount)){
				$ionicPopup.alert({
					template: "<p>您所填发票中金额超出可开票金额，不可再添加发票！</p>"
				});
			}else{
				if ($scope.item.taxType == "01" && $scope.item.isUse == "1" && $scope.item.taxRateItem == "") {
					$ionicPopup.alert({
						template: "<p>您的税率为空，请填写!</p>"
					});
				}else{
					//set invoiceDetails to fillinvoice page here.
					$scope.organizeParam();
					data.pageType = 'add';
					if($scope.swiperLists.length > 0){	//有发票明细数据时
						AddInvoiceApiServices.setAllInvoice($scope.swiperLists);
					}else{	//没发票明细数据时
						$scope.swiperLists.push({"taxType":$scope.item.taxType,"isUse":$scope.item.isUse,"taxRateItem":$scope.item.taxRateItem})
						AddInvoiceApiServices.setAllInvoice($scope.swiperLists);
					}
					console.log("to fill $scope.swiperLists: ",JSON.stringify(AddInvoiceApiServices.getAllInvoice()));
					console.log("to fill json data: ",JSON.stringify(data));
					AddInvoiceApiServices.setEditInvoice([]);
					$location.path('/fillinvoice/' + JSON.stringify(data));
				}
			}
		};
		//点击发票明细项
		$scope.goFillSingle = function(index){
			if ($scope.item.taxType == "01" && $scope.item.isUse == "1" && $scope.item.taxRateItem == "") {
				$ionicPopup.alert({
					template: "<p>您的税率为空，请填写!</p>"
				});
			}else{
				$scope.organizeParam();
				switch(sige){
					case 'detail':
						data.pageType = 'detail';
						break;
					case 'add':
					case 'update':
						data.pageType = 'edit';
						break;
					default:
						break;
				}
				var tempArr = [];
				tempArr.push($scope.swiperLists[index]);
				AddInvoiceApiServices.setAllInvoice($scope.swiperLists);
				AddInvoiceApiServices.setEditInvoice(tempArr);
				console.log("detail tempArr:",tempArr);
				$location.path('/fillinvoice/' + JSON.stringify(data));
			}
		};
	}
]);