angular.module('PMPMobile.controller').controller('FillInvoiceController', ["$scope", "$timeout",
	"$stateParams", "FooterServices", "$ionicModal", "AddInvoiceApiServices", "$ionicPopup", "$location",
	function($scope, $timeout, $stateParams, FooterServices, $ionicModal, AddInvoiceApiServices, $ionicPopup, $location) {
		FooterServices.hide();
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modalConfirm = modal;
		});
		//页面关闭时销毁弹出框
		$scope.$on('$destroy', function() {
			$scope.modalConfirm.remove();
		});
		//获取页面路由数据 包括账单相关信息
		$scope.info = JSON.parse($stateParams.info);
		console.log("路由数据", $scope.info);
		$scope.info.isFill = true;
		//获取容差金额
		var allowance = parseFloat(JSON.parse(window.localStorage.getItem("supplier")).allowance);
		//获取发票剩余金额
		$scope.surplusMoney = $scope.info.sige == 'add' || $scope.info.sige == 'detail' ? ($scope.info.invoiceAmount - $scope.info.allInvoiceAmount).toFixed(2) : ($scope.info.invoiceAmount - $scope.info.allInvoiceAmount + getInitTotal()).toFixed(2);
		console.log("可开发票金额", $scope.surplusMoney);
		console.log("容差金额", allowance);
		//计算开票合计
		$scope.totalAmount = 0;
		//发票id和发票子项id
		$scope.invoiceIds = {
				"invoiceDetailId": "",
				"invoiceId": ""
			}
			//发票类型等简要信息
		$scope.invoiceGist = {
			"taxType": "",
			"isUse": "",
			"taxRateItem": ""
		};
		//填写内容
		$scope.fillData = {
			"inTax": "", //进税项
			"invoiceNo": "", //发票号
			"taxMoney": "", //开票金额
			"invoiceRemark": "" //发票相关内容
		};
		//类型为4的提示信息标志
		$scope.tipSign = "";
		//类型为3和8的提示信息标志
		$scope.okSign = "";
		//字数随内容改变
		$scope.invoiceRemarkChange = function() {
				if (typeof($("#invoiceRemark").val()) != "undefined") {
					var num = $("#invoiceRemark").val().length;
					$("#changeNum").html(num);
				}
			}
			//初始化页面
		function init() {
			switch ($scope.info.pageType) {
				case 'add':
					$scope.title = "添加发票";
					$scope.isDetail = false;
					//获取所有发票
					var allInvoice = AddInvoiceApiServices.getAllInvoice();
					console.log("已添加的所有发票为：", allInvoice);
					//初始化发票简要信息
					$scope.invoiceGist.taxType = allInvoice[0].taxType;
					$scope.invoiceGist.isUse = allInvoice[0].isUse;
					$scope.invoiceGist.taxRateItem = allInvoice[0].taxRateItem;
					countTotalAmount();
					break;
				case 'edit':
					$scope.title = "编辑发票";
					$scope.isDetail = false;
					//获取编辑的发票
					var editInvoice = AddInvoiceApiServices.getEditInvoice();
					//保存当前在编辑的发票信息
					$scope.currentEdit = editInvoice;
					console.log("修改已添加的发票：", editInvoice);
					//初始化发票信息
					$scope.invoiceGist.taxType = editInvoice[0].taxType;
					$scope.invoiceGist.isUse = editInvoice[0].isUse;
					$scope.invoiceGist.taxRateItem = editInvoice[0].taxRateItem;
					$scope.fillData.inTax = editInvoice[0].inTax;
					$scope.fillData.invoiceNo = editInvoice[0].invoiceNo;
					$scope.fillData.taxMoney = editInvoice[0].taxMoney;
					$scope.fillData.invoiceRemark = editInvoice[0].invoiceRemark;
					//获取发票id和发票子项id
					$scope.invoiceIds.invoiceDetailId = editInvoice[0].invoiceDetailId;
					$scope.invoiceIds.invoiceId = editInvoice[0].invoiceId;
					countTotalAmount();
					break;
				case 'detail':
					$scope.title = "发票详情";
					$scope.isDetail = true;
					//获取选择的发票
					var detailInvoice = AddInvoiceApiServices.getEditInvoice();
					//当前选择的发票信息
					$scope.currentEdit = detailInvoice;
					//初始化发票信息
					$scope.invoiceGist.taxType = detailInvoice[0].taxType;
					$scope.invoiceGist.isUse = detailInvoice[0].isUse;
					$scope.invoiceGist.taxRateItem = detailInvoice[0].taxRateItem;
					$scope.fillData.inTax = detailInvoice[0].inTax;
					$scope.fillData.invoiceNo = detailInvoice[0].invoiceNo;
					$scope.fillData.taxMoney = detailInvoice[0].taxMoney;
					$scope.fillData.invoiceRemark = detailInvoice[0].invoiceRemark;
					countTotalAmount();
					break;
				default:
					break;
			}
		}
		init();
		//全部校验 空、开票金额为0、超出可开票金额、发票号重复
		function checkAll() {
			if (blankCheck()) {
				return false;
			} else if (zeroAmount()) {
				return false;
			} else if (overAmount()) {
				$scope.modalShow = 4;
				$scope.remind = "您所填发票中金额超出可开票金额,可开票总额" + $scope.info.invoiceAmount +
					",已开金额" + $scope.info.allInvoiceAmount + ",请核对后填写。";
				$scope.modalConfirm.show();
				$scope.tipSign = "wrongAmount";
				return false;
			} else if (mutiInvoiceNo()) {
				$scope.modalShow = 4;
				$scope.remind = "发票号" + $scope.fillData.invoiceNo + "不能重复!";
				$scope.modalConfirm.show();
				$scope.tipSign = "wrongNo";
				$scope.solveBug = true;
				return false;
			} else {
				return true;
			}
		}
		//输入金额只能是非负数
		$scope.clearNaN = function(value, sign) {
				var num = value;
				var reg = /^[0-9]{0}([0-9]|[.])+$/;
				var checkRes = reg.test(String(num));
				console.log("校验的值", num);
				switch (sign) {
					case 'taxMoney':
						console.log("开票金额有误校验结果", checkRes);
						$scope.fillData.taxMoney = checkRes ? num : ($scope.info.pageType == 'add' ? '' : (num == '' ? '' : $scope.currentEdit[0].taxMoney));
						countTotalAmount();
						break;
					case 'inTax':
						console.log("进项税有误校验结果", checkRes);
						$scope.fillData.inTax = checkRes ? num : ($scope.info.pageType == 'add' ? '' : (num == '' ? '' : $scope.currentEdit[0].inTax));
						break;
					default:
						break;
				}
			}
			//发票号重复校验
		function mutiInvoiceNo() {
			//获取所有发票
			var allInvoice = AddInvoiceApiServices.getAllInvoice();
			if ($scope.info.pageType == 'add') {
				for (var i = 0; i < allInvoice.length; i++) {
					if (allInvoice[i].invoiceNo == $scope.fillData.invoiceNo) { //遍历发票号
						return true;
						break;
					}
				}
			} else if ($scope.info.pageType == 'edit') {
				for (var i = 0; i < allInvoice.length; i++) {
					if (allInvoice[i].invoiceNo == $scope.fillData.invoiceNo && allInvoice[i].invoiceNo != $scope.currentEdit[0].invoiceNo) { //遍历发票号
						return true;
						break;
					}
				}

			}
			return false;
		}
		//开票金额为零校验
		function zeroAmount() {
			if ($scope.fillData.taxMoney == 0) {
				$scope.modalShow = 4;
				$scope.remind = "开票金额不能为0!";
				$scope.fillData.taxMoney = $scope.info.pageType == 'edit' ? $scope.currentEdit[0].taxMoney : $scope.fillData.taxMoney;
				$scope.modalConfirm.show();
				$scope.tipSign = "wrongAmount";
				return true;
			} else {
				return false;
			}
		}
		//有无进税项校验
		function hasInTax() {
			if ($scope.invoiceGist.isUse == '1') {
				return true;
			} else {
				return false;
			}
		}
		//空校验
		function blankCheck() {
			if (hasInTax() && $scope.fillData.inTax == '') { //进税项为空
				$scope.modalShow = 4;
				$scope.remind = "进税项不能为空!";
				$scope.modalConfirm.show();
				$scope.tipSign = "blankInTax";
				return true;
			} else if ($scope.fillData.invoiceNo == '') { //发票号为空
				$scope.modalShow = 4;
				$scope.remind = "发票号不能为空!";
				$scope.modalConfirm.show();
				$scope.tipSign = "blankInvoiceNo";
				return true;
			} else if ($scope.fillData.taxMoney == '') { //开票金额为空
				$scope.modalShow = 4;
				$scope.remind = "开票金额不能为空!";
				$scope.modalConfirm.show();
				$scope.tipSign = "blankAmount";
				return true;
			} else {
				return false;
			}
		}
		//获取初始开票合计
		function getInitTotal() {
			//获取所有发票
			var allInvoice = AddInvoiceApiServices.getAllInvoice();
			var sum = 0;
			for (var i = 0; i < allInvoice.length; i++) {
				var taxMoneyObj = allInvoice[i].taxMoney == '' || allInvoice[i].taxMoney == null ? 0 : parseFloat(allInvoice[i].taxMoney);
				sum = sum + taxMoneyObj;
			}
			return sum;
		}
		//计算开票合计
		function countTotalAmount() {
			$scope.totalAmount = 0;
			//获取所有发票
			var allInvoice = AddInvoiceApiServices.getAllInvoice();
			console.log("已有的发票", allInvoice);
			var taxMoney = $scope.fillData.taxMoney == '' || isNaN($scope.fillData.taxMoney) ? 0 : parseFloat($scope.fillData.taxMoney);
			var sum = 0;
			if ($scope.info.pageType == 'add') { //添加状态
				for (var i = 0; i < allInvoice.length; i++) {
					var taxMoneyObj = allInvoice[i].taxMoney == '' || allInvoice[i].taxMoney == null ? 0 : parseFloat(allInvoice[i].taxMoney);
					sum = sum + taxMoneyObj;
				}
			} else { //编辑或详情状态
				for (var i = 0; i < allInvoice.length; i++) {
					if (allInvoice[i].invoiceNo != $scope.currentEdit[0].invoiceNo) {
						console.log("已添加发票中没有此发票号");
						var taxMoneyObj = allInvoice[i].taxMoney == '' || allInvoice[i].taxMoney == null ? 0 : parseFloat(allInvoice[i].taxMoney);
						sum = sum + taxMoneyObj;
					}
				}
			}
			$scope.totalAmount = parseFloat(parseFloat(taxMoney) + parseFloat(sum)).toFixed(2);
			console.log("开票合计", $scope.totalAmount);
		}
		//填写开票金额时计算默认进项税 开票合计
		$scope.changeAmount = function(value) {
				var reg = /^[0-9]{0}([0-9]|[.])+$/;
				var taxMoney = value;
				if (hasInTax()) { //有进项税
					if (reg.test(String(taxMoney)) && taxMoney != '') { //输入的开票金额合法 且不为空
						countTotalAmount();
						$scope.fillData.inTax = (taxMoney * ($scope.invoiceGist.taxRateItem / 100) / (1 + $scope.invoiceGist.taxRateItem / 100)).toFixed(2);
					} else {
						$scope.fillData.inTax = '';
					}
				} else { //无进项税
					countTotalAmount();
				}

			}
			//开票合计超出可开票金额
		function overAmount() {
			console.log("此时开票合计", $scope.totalAmount);
			if (parseFloat($scope.totalAmount) > parseFloat($scope.surplusMoney) + parseFloat(allowance)) {
				return true;
			} else {
				return false;
			}
		}
		//进项税超出开票金额
		function overMoney() {
			if (parseFloat($scope.fillData.inTax) > parseFloat($scope.fillData.taxMoney)) {
				return true;
			} else {
				return false;
			}
		}
		//所填进项税、开票金额校验
		$scope.wrongAmount = function(sign) {
				switch (sign) {
					case 'taxMoney':
						if (overAmount()) { //开票合计超出可开票金额
							$scope.modalShow = 4;
							$scope.remind = "您所填发票中金额超出可开票金额,可开票总额" + $scope.info.invoiceAmount +
								",已开金额" + $scope.info.allInvoiceAmount + ",请核对后填写。";
							$scope.modalConfirm.show();
							$scope.tipSign = "wrongAmount";
							$scope.solveBug = true;
						}
						break;
					case 'inTax':
						if (overMoney()) { //进项税大于开票金额
							$scope.modalShow = 4;
							$scope.remind = "进项税不能大于开票金额!";
							$scope.modalConfirm.show();
							$scope.tipSign = "wrongInTax";
							$scope.solveBug = true;
						}
						break;
					default:
						break;
				}

			}
			//生成一个发票对象
		function invoiceObj() {
			var obj = {};
			for (pro in $scope.invoiceGist) {
				obj[pro] = $scope.invoiceGist[pro];
			}
			for (pro in $scope.fillData) {
				obj[pro] = $scope.fillData[pro];
			}
			if ($scope.info.pageType == 'edit') { //编辑发票时加上发票id和发票子项id
				for (pro in $scope.invoiceIds) {
					obj[pro] = $scope.invoiceIds[pro];
				}
			}
			return obj;
		}
		//删除编辑的发票
		function cutEditInvoice() {
			//获取所有发票
			var allInvoice = AddInvoiceApiServices.getAllInvoice();
			for (var i = 0; i < allInvoice.length; i++) {
				if (allInvoice[i].invoiceNo == $scope.currentEdit[0].invoiceNo) { //遍历发票号
					//移除发票
					allInvoice.splice(i, 1);
					AddInvoiceApiServices.setAllInvoice(allInvoice);
					return true;
					break;
				}
			}
		}
		//删除空发票
		function cutBlankInvoice() {
			//获取所有发票
			var allInvoice = AddInvoiceApiServices.getAllInvoice();
			for (var i = 0; i < allInvoice.length; i++) {
				if (allInvoice[i].invoiceNo == "" || allInvoice[i].invoiceNo == null) { //发票号判空
					//移除发票
					allInvoice.splice(i, 1);
					AddInvoiceApiServices.setAllInvoice(allInvoice);
					return true;
					break;
				}
			}

		}
		//类型为4的模态框确定按钮
		$scope.hide = function() {
			switch ($scope.tipSign) {
				case 'wrongAmount':
					$scope.modalConfirm.hide();
					$timeout(function() {
						$scope.solveBug = false;
					}, 500);
					break;
				case 'wrongInTax':
					$scope.fillData.inTax = "0.00";
					$scope.modalConfirm.hide();
					$timeout(function() {
						$scope.solveBug = false;
					}, 500);
					break;
				case 'wrongNo':
					$scope.fillData.invoiceNo = $scope.info.pageType == 'add' ? $scope.fillData.invoiceNo : $scope.currentEdit[0].invoiceNo;
					$scope.modalConfirm.hide();
					$timeout(function() {
						$scope.solveBug = false;
					}, 500);
					break;
				case 'blankInTax':
					$scope.modalConfirm.hide();
					$timeout(function() {
						$("#inTax").focus();
					}, 500);
					break;
				case 'blankInvoiceNo':
					$scope.modalConfirm.hide();
					$timeout(function() {
						$("#invoiceNo").focus();
					}, 500);
					break;
				case 'blankAmount':
					$scope.modalConfirm.hide();
					$timeout(function() {
						$("#taxMoney").focus();
					}, 500);
					break;
				case 'overAmount':
					$scope.modalConfirm.hide();
					//回到列表页
					$location.path('/addinvoicedetails/' + JSON.stringify($scope.info));
					break;
				default:
					$scope.modalConfirm.hide();
					break;
			}
		}
		$scope.back = function() {
				cutBlankInvoice();
				//返回列表页
				$location.path('/addinvoicedetails/' + JSON.stringify($scope.info));
			}
			//删除发表信息
		$scope.deleteInvoice = function() {
				$scope.modalShow = 8;
				$scope.explain = "您确定要删除本张发票？";
				$scope.ok = "是";
				$scope.no = "否";
				$scope.modalConfirm.show();
				$scope.okSign = "delInvoice";
				$scope.solveBug = true;
			}
			//删除发票的提示按钮
		$scope.isConfirm = function(flag, event) {
			if (flag) { //点击是
				$scope.modalConfirm.hide();
				switch ($scope.okSign) {
					case 'delInvoice':
						if ($scope.info.pageType == 'add' && cutBlankInvoice()) { //添加时删除
							$scope.modalShow = 6;
							$scope.alertMsg = "删除成功!";
							$scope.modalConfirm.show();
							$timeout(function() {
								$scope.modalConfirm.hide();
								//返回列表页
								$location.path('/addinvoicedetails/' + JSON.stringify($scope.info));
							}, 1000);
						} else if ($scope.info.sige == 'update' && $scope.info.pageType == 'add') { //编辑状态的添加发票时删除
							$scope.modalShow = 6;
							$scope.alertMsg = "删除成功!";
							$scope.modalConfirm.show();
							$timeout(function() {
								$scope.modalConfirm.hide();
								//返回列表页
								$location.path('/addinvoicedetails/' + JSON.stringify($scope.info));
							}, 1000);
						} else if ($scope.info.pageType == 'edit' && cutEditInvoice()) { //编辑时删除
							$scope.modalShow = 6;
							$scope.alertMsg = "删除成功!";
							$scope.modalConfirm.show();
							$timeout(function() {
								$scope.modalConfirm.hide();
								//返回列表页
								$location.path('/addinvoicedetails/' + JSON.stringify($scope.info));
							}, 1000);
						}
						break;
					case 'editSuccess':
						//返回列表页
						$location.path('/addinvoicedetails/' + JSON.stringify($scope.info));
						break;
					default:
						break;
				}
			} else { //点击否
				$scope.modalConfirm.hide();
				$timeout(function() {
					$scope.solveBug = false;
				}, 500);
			}
		}
		$scope.isBatch = function(flag) {
				if (flag) {
					$scope.modalConfirm.hide();
					switch ($scope.okSign) {
						case 'nextInvoice':
							//继续添加发票
							$scope.clearInvoice();
							$timeout(function() {
								$scope.solveBug = false;
							}, 500);
							break;
						default:
							break;
					}

				} else {
					$scope.modalConfirm.hide();
					if ($scope.okSign == 'nextInvoice') {
						//返回列表页
						$location.path('/addinvoicedetails/' + JSON.stringify($scope.info));
					}
				}
			}
			//清空发票信息
		$scope.clearInvoice = function() {
				for (obj in $scope.fillData) {
					$scope.fillData[obj] = "";
				}
			}
			//保存发票信息
		$scope.saveInvoice = function() {
			switch ($scope.info.pageType) {
				case 'add':
					if (checkAll()) {
						//保存当前发票 判定能否添加下一条发票
						cutBlankInvoice();
						//获取所有发票
						var allInvoice = AddInvoiceApiServices.getAllInvoice();
						allInvoice.push(invoiceObj());
						AddInvoiceApiServices.setAllInvoice(allInvoice);
						if (!overAmount()) { //保存后判断所有发票金额是否超过上限  没有则提示继续添加发票
							$scope.modalShow = 3;
							$scope.explain = "保存成功,是否继续添加发票?";
							$scope.ok = "是";
							$scope.no = "否";
							$scope.modalConfirm.show();
							$scope.okSign = "nextInvoice";
							$scope.solveBug = true;
						} else {
							$scope.modalShow = 4;
							$scope.remind = "保存成功,当前发票已达到可开票金额上限!";
							$scope.modalConfirm.show();
							$scope.tipSign = "overAmount";
						}
					}
					break;
				case 'edit':
					if (checkAll()) {
						//保存当前发票 判定能否添加下一条发票
						cutEditInvoice();
						//获取所有发票
						var allInvoice = AddInvoiceApiServices.getAllInvoice();
						allInvoice.push(invoiceObj());
						AddInvoiceApiServices.setAllInvoice(allInvoice);
						$scope.modalShow = 8;
						$scope.explain = "保存成功，返回发票列表?";
						$scope.ok = "是";
						$scope.no = "否";
						$scope.modalConfirm.show();
						$scope.okSign = "editSuccess";
						$scope.solveBug = true;
					}
					break;
				default:
					break;
			}

		}
	}
]);