angular.module("PMPMobile.directive").directive('addInvoiceList', ['$rootScope', '$ionicModal', 'DetailDisposeServices', '$location', 'AddInvoiceApiServices',
	function($rootScope, $ionicModal, DetailDisposeServices, $location, AddInvoiceApiServices) {
		return {
			restrict: 'E',
			replace: true,
			scope: {
				data: '=',
				titleStatus: '='
			},
			templateUrl: 'views/bill/invoice/invoice-list-directive.html',
			link: function(scope) {
				scope.invoicing = "可开发票";
				scope.data = scope.data;
				scope.sign = scope.titleStatus
				scope.operating = scope.titleStatus;
				switch (scope.data.hide.invoiceStatusCN) {
					case "驳回":
						scope.data.statusColor="turn-down";
						scope.reject=true;
						break;
					case "待审核":
					    scope.data.statusColor="penging";
					    scope.detail=true;
					    scope.pendingAudit = true;
						break;
					case "已审核":
					    scope.data.statusColor="audited";
					    scope.detail=true;
						break;
				}
				scope.addInvoice = function(sige) {
					scope.data.hide.sige = sige;
					if(scope.data.show.invoiceAmount){
						scope.data.hide.invoiceAmount = scope.data.show.invoiceAmount;
					}else{
						scope.data.hide.invoiceAmount = scope.data.hide.invoiceAmount;
					}
					// scope.data.hide.countDate = scope.data.show.countDate;
					$location.path('/addinvoicedetails/' + JSON.stringify(scope.data.hide));
				};
				$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.modal = modal;
				});
				scope.openModalSubmit = function() {
					scope.modal.show();
				};
				scope.closeModal = function() {
					scope.modal.hide();
				};
				scope.openModal = function() {
					scope.modalShow = "2";
					scope.deleteAlert="您确定要删除这张发票？";
					scope.openModalSubmit();
				};
				scope.delete = function() {
					scope.openModal();
				};
				scope.deleteInvoice = function() {
					AddInvoiceApiServices.deleteInvoice(scope.data.hide.invoiceId).then(function(res) {
						if (res.Flag == '1') {
							GetByid("invoice-list" + scope.data.hide.invoiceId).remove();
							scope.modal.hide();
						}
					});

				}
				scope.cancelInvoice = function() {
					scope.closeModal();
				}

			}
		}
	}
]);