angular.module('PMPMobile.services').factory('AddInvoiceApiServices', ["$http", "Global", "$q",
	function($http, Global, $q) {
		var getPromise = function(p) {
			var defer = $q.defer();
			p.success(function(response) {
				return defer.resolve(response);
			}).error(function() {
				return defer.reject();
			});
			return defer.promise;
		};
		var allInvoice = [];
		var editInvoice = [];
		return {
			/* 选择账单（发票）*/
			getAddInvoice: function(obj) {
				var url = Global.apiPath + '/pmp/app/invoice/invoice/billCount.ht?billNo=' + '&countDate=' + obj.countDate + '&page=' + obj.page + '&pageSize=' + obj.pageSize;
				return getPromise($http.get(url));
			},
			/* 发票列表（查询）*/
			getOpenInvoice: function(obj) {
				//				var url = Global.apiPath + '/pmp/app/invoice/invoice/list.ht';
				var url = Global.apiPath + '/pmp/app/invoice/invoice/list.ht?recordDate=' + obj.recordDate + '&paymentStatus=' + obj.paymentStatus + '&page=' + obj.page + '&pageSize=' + obj.pageSize;
				return getPromise($http.get(url));
			},
			/* 发票删除 */
			deleteInvoice: function(invoiceId) {
				var url = Global.apiPath + '/pmp/app/invoice/invoice/del.ht?invoiceId=' + invoiceId;
				return getPromise($http.get(url));
			},
			/* 发票添加*/
			addInvoice: function(obj) {
				var url = Global.apiPath + '/pmp/app/invoice/invoice/save.ht';
				return getPromise($http.post(url, obj));
			},
			/*跳转到发票编辑页面*/
			jumpEditInvoice: function(invoiceId) {
				var url = Global.apiPath + '/pmp/app/invoice/invoice/update.ht?invoiceId=' + invoiceId;
				return getPromise($http.get(url));
			},
			/*修改发票*/
			updateInvoice: function(obj) {
				var url = Global.apiPath + '/pmp/app/invoice/invoice/updateInvoice.ht';
				return getPromise($http.post(url, obj));
			},
			/*修改所有的发票*/
			setAllInvoice: function(arr) {
				allInvoice = arr;
			},
			/*获取所有的发票*/
			getAllInvoice: function() {
				return allInvoice;
			},
			/*修改编辑的发票*/
			setEditInvoice: function(arr) {
				editInvoice = arr;
			},
			/*获取编辑的发票*/
			getEditInvoice: function() {
				return editInvoice;
			}
		};
	}
]);