angular.module('PMPMobile.controller').controller('EditPrepaymentController', ['$rootScope', "$scope", "$stateParams", "$location", "$ionicPopup", "DetailDisposeServices", "FooterServices", "PrepaymentManagementApiServices",
	function($rootScope, $scope, $stateParams, $location, $ionicPopup, DetailDisposeServices, FooterServices, PrepaymentManagementApiServices) {
		$scope.margin = 300;
		$scope.clientHeight = (document.documentElement.clientHeight - 350) + 'px';
		FooterServices.hide();
		$scope.edit = {
			amount: "",
			phone: ""
		};
		init();

		function init() {
			$scope.data = DetailDisposeServices.getEditAdvancesMsg();
			console.log($scope.data);
			if ($stateParams.type == "add") {
				$scope.billNo = $scope.data.show.billNo;
				//apAmount预付款申请比例0.9
				$scope.apAmount = ((parseFloat($scope.data.show.settlementServiceFee) - parseFloat($scope.data.show.yinvoiceAmount) - parseFloat($scope.data.hide.liveInvAmount)) * 0.9).toFixed(2);;
				$scope.title = "新增预付款";
			} else if ($stateParams.type == "edit") {
				$scope.billNo = $scope.data.hide.billNo;
				$scope.apAmount = $scope.data.hide.apAmount;
				$scope.title = "编辑预付款";
				$scope.edit.amount = $scope.data.show.applyMoneyStr;
				$scope.edit.phone = $scope.data.hide.telephone;
				$("#edit-prepayment-amount").val($scope.data.show.applyMoneyStr);
				$("#edit-prepayment-phone").val($scope.data.hide.telephone);
				$("#edit-prepayment-reason").val($scope.data.hide.applyReason);
			}
			ready();
		}

		$scope.change = function() {
			var val = $("#edit-prepayment-amount").val();
			var split = val.split(".");
			if (split.length > 1 && split[1].length > 1) {
				val = parseFloat(val).toFixed(2);
				$("#edit-prepayment-amount").val(val);
			}
		};

		function checkAmount() {
			if ($scope.edit.amount == "" || $scope.edit.amount == null) {
				$("#edit-prepayment-amount").attr("placeholder", "请填写金额");
				return false;
			}
			return true;
		}

		function checkPhone() {
			if ($scope.edit.phone == "" || $scope.edit.phone == null) {
				$("#edit-prepayment-phone").attr("placeholder", "请填写联系电话");
				return false;
			}
			return true;
		}

		function checkReason() {
			if ($("#edit-prepayment-reason").val().length == 0) {
				return false;
			}
			return true;
		}
		$scope.reasonFocus = function() {
			checkAmount();
			checkPhone();
		};


		$scope.complete = function() {
			if (checkAmount() && checkPhone() && checkReason()) {
				if (!isNaN($("#edit-prepayment-amount").val()) &&
					parseFloat($("#edit-prepayment-amount").val()) <= parseFloat($scope.apAmount)) {
					re = /^1\d{10}$/;
					if (!re.test($scope.edit.phone)) {
						$ionicPopup.alert({
							title: "<p  class='network-error'>手机号码填写有误</p>"
						});
						return;
					}
					if ($stateParams.type == "edit") {
						//apAmount(申请限额),applyMoney(申请金额),telephone(联系方式),applyReason(申请原因),advancePaymentId(预付款id)
						var obj = {};
						obj.apAmount = $scope.apAmount;
						obj.applyMoney = $scope.edit.amount;
						obj.telephone = $scope.edit.phone;
						obj.applyReason = $("#edit-prepayment-reason").val();
						obj.advancePaymentId = $scope.data.hide.advancePaymentId;
						var dataStr = 'apAmount=' + obj.apAmount + '&applyMoney=' + obj.applyMoney + '&telephone=' + obj.telephone + '&applyReason=' + obj.applyReason + '&advancePaymentId=' + obj.advancePaymentId;
						PrepaymentManagementApiServices.editExistingAdvances(dataStr).then(function(res) {
							if (res.Flag == '1') {
								$location.path("/prepayment/finish");
							} else {
								$ionicPopup.alert({
									template: "<p >" + res.Result.errmsg + "</p>"
								});
							}
						});
					} else if ($stateParams.type == "add") {
						var obj = {};
						obj.billNo = $scope.billNo;
						obj.apAmount = $scope.apAmount;
						obj.applyMoney = $scope.edit.amount;
						obj.telephone = $scope.edit.phone;
						obj.applyReason = $("#edit-prepayment-reason").val();
						obj.billId = $scope.data.hide.billId;
						obj.agreemenId = $scope.data.hide.agreemenId;
						obj.areaCode = $scope.data.hide.areaCode;
						obj.serviceType = $scope.data.hide.serviceType;
						obj.countDate = $scope.data.hide.countDateF;
						obj.ninvoiceAmount = $scope.data.hide.ninvoiceAmount;
						obj.advancePaymentId = '';
						//billNo,apAmount,applyMoney,telephone,applyReason,
						//billId,agreemenId,areaCode,serviceType,
						//countDate,ninvoiceAmount
						//						checkTel(obj.telephone);
						var dataStr = 'billNo=' + obj.billNo + '&apAmount=' + obj.apAmount + '&applyMoney=' + obj.applyMoney + '&telephone=' + obj.telephone + '&applyReason=' + obj.applyReason + '&billId=' + obj.billId + '&agreemenId=' + obj.agreemenId + '&areaCode=' + obj.areaCode + '&serviceType=' + obj.serviceType + '&countDate=' + obj.countDate + '&ninvoiceAmount=' + obj.ninvoiceAmount + '&advancePaymentId=' + obj.advancePaymentId;
						PrepaymentManagementApiServices.addExistingAdvances(dataStr).then(function(res) {
							console.log(res);
							if (res.Flag == '1') {
								$location.path("/prepayment/finish");
							} else {
								$ionicPopup.alert({
									template: "<p >" + res.Result.errmsg + "</p>"
								});
							}
						});
					}
					return;
				} else {
					$ionicPopup.alert({
						title: "<p  class='network-error'>预付款申请超过限额</p>"
					});
				}
			} else {
				$ionicPopup.alert({
					title: "<p  class='network-error'>请填写完善</p>"
				});
			}
		};
		//textarea 输入字数的限制
		function ready() {
			$("#edit-prepayment-reason").bind("click", showNum)
				.bind("keyup", showNum);
		};

		function showNum() {
			var num = this.value.length;
			$("#changeNum").html(num);
		};
	}
]);