angular.module('PMPMobile.controller').controller('PrepaymentManagementController', ['$rootScope', "$scope", '$ionicModal', 'FooterServices', 'PrepaymentManagementApiServices', '$timeout', '$ionicPopup', '$stateParams',
	function($rootScope, $scope, $ionicModal, FooterServices, PrepaymentManagementApiServices, $timeout, $ionicPopup, $stateParams) {
		console.log($stateParams.type);
		console.log($stateParams.type == 'new');
		FooterServices.activeItemByIndex(3);
		$scope.backLogin = function() {
			var exec = cordova.require("cordova/exec");
			exec(callbackok, callbackerr, 'TogglePlugin', 'toggle', [2]);
		};

		function callbackok() {
			console.log('callback ok');
		}

		function callbackerr(errMsg) {
			console.log(errMsg);
		}
		$scope.tabs = [{
			title: '新增预付款'
		}, {
			title: '现有预付款'
		}];
		if ($stateParams.type == 'new') {
			$scope.isShow = true;
			$scope.currentTab = '新增预付款';
		} else {
			$scope.isShow = false;
			$scope.currentTab = '现有预付款';
		}

		init();

		/*获取登录信息回调函数*/
		function supplierSuccess(str){
			setLocalStorage(str);	// 存入缓存
		}
		/*获取登录信息回调函数*/
		function supplierError(errMsg){
			console.log(errMsg);
		}
		
		function init() {
			/*从插件获取登录信息*/
			var exec = cordova.require("cordova/exec");
			exec(supplierSuccess, supplierError, 'SupplierPlugin', 'supplier', []);
			
			if ($scope.isShow) {
				//新增预付款
				PrepaymentManagementApiServices.checkAdvances().then(function(res) {
					console.log(res);
					if (res.Flag == '1' && res.Result.advance == '1') {
						$scope.available = true;
						$('#newAdvancesTimer').show();
						$scope.newAdvancesTime = '';
						$scope.newDatas = [];
						initNewAdvances();
						$('#refreshIon').show();
						$('#loadMoreIon').show();
					} else {
						$scope.available = false;
						$('#newAdvancesTimer').hide();
						$('#refreshIon').hide();
						$('#loadMoreIon').hide();
						$scope.newDatas = [1];
					}
				});
			} else {
				//现有预付款
				$scope.billTime = '';
				$scope.existingAdvancesTime = '';
				$scope.existDatas = [];
				initExistingAdvances();
				$('#refreshIon').show();
				$('#loadMoreIon').show();
				$scope.available = true;
			}
			$scope.isFirstIn = true;;
		}

		$scope.onClickTab = function(tab) {
			if ($scope.currentTab != tab.title) {
				$scope.currentTab = tab.title;
				$scope.isShow = !$scope.isShow;
				init();
			}
		}
		$scope.isActiveTab = function(tabTitle) {
			return tabTitle == $scope.currentTab;
		}

		/*新增预付款 接收时间选择器的值*/
		$scope.$on("newAdvancestimeReceiver", function(event, data) {
			if (data.data == "全部时间") {
				$scope.newAdvancesTime = "";
			} else {
				$scope.newAdvancesTime = data.data;
			}
			initPager($scope);
			$scope.newDatas = [];
			getNewListData("refresh");
		});
		/*现有预付款 接收时间选择器的值*/
		$scope.$on("billtimeReceiver", function(event, data) {
			if (data.data == '全部账单时间') {
				$scope.billTime = '';
			} else {
				$scope.billTime = data.data;
			}
			initPager($scope);
			$scope.existDatas = [];
			getExistListData("refresh");
		});
		$scope.$on("existingAdvancestimeReceiver", function(event, data) {
			if (data.data == '全部预付款申请日期') {
				$scope.existingAdvancesTime = '';
			} else {
				$scope.existingAdvancesTime = data.data;
			}
			initPager($scope);
			$scope.existDatas = [];
			getExistListData("refresh");
		});

		/*初始化列表数据*/
		function initNewAdvances() {
				initPager($scope);
				getNewListData();
			}
			/*初始化列表数据*/

		function initExistingAdvances() {
			initPager($scope);
			getExistListData();
		}

		function getNewListData(type) {
			PrepaymentManagementApiServices.getNewAdvances($scope.newAdvancesTime, $scope.pageObj.pageSize, $scope.pageObj.page).then(function(res) {
				if (res.Flag == '1') {
					var datas = res.Result;
					for (var i = 0; i < datas.length; i++) {
						datas[i].title = datas[i].hide.countDate;
						datas[i].shows = objtoarray(datas[i].show);
						$scope.newDatas.push(datas[i]);
					}
					$scope.noMoreItemsAvailable = res.totalCount == $scope.newDatas.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					refreshData(type, res);
				} else {
					$ionicPopup.alert({
						template: "<p >" + res.Result.errmsg + "</p>"
					});
				}
			});
		}

		function getExistListData(type) {
			PrepaymentManagementApiServices.getExistingAdvances($scope.billTime, $scope.existingAdvancesTime, $scope.pageObj.pageSize, $scope.pageObj.page).then(function(res) {
				if (res.Flag == '1') {
					var datas = res.Result;
					for (var i = 0; i < datas.length; i++) {
						datas[i].title = datas[i].hide.checkStatusCN;
						if (datas[i].hide.checkStatus == '03' || datas[i].hide.checkStatus == '01') {
							datas[i].isEdit = true;
						} else {
							datas[i].isEdit = false;
						}
						if (datas[i].hide.checkStatus == '05') {
							datas[i].canCheck = true;
						} else {
							datas[i].canCheck = false;
						}
						datas[i].shows = objtoarray(datas[i].show);
						$scope.existDatas.push(datas[i]);
					}
					$scope.noMoreItemsAvailable = res.totalCount == $scope.existDatas.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					refreshData(type, res);
				} else {
					$ionicPopup.alert({
						template: "<p >" + res.Result.errmsg + "</p>"
					});
				}
			});
		}

		function refreshData(type, res) {
				if (type == "refresh") {
					if (res.Result.length > 0) {
						$scope.refresherData = "已经为您更新" + res.Result.length + "条数据";
						$(".refresher-data").show();
						$timeout(function() {
							$(".refresher-data").hide();
						}, 2000);
					}

				} else if (type == "loadMore") {
					if (res.Result.length > 0) {
						$scope.infiniteData = "已经为您加载" + res.Result.length + "条数据";
						$(".infinite-data").show();
						$timeout(function() {
							$(".infinite-data").hide();
						}, 2000);
					}
				}
				NoData(res.Result.length,"您当前选择的条件没有数据");
			}
			/*下拉刷新*/
		$scope.onRefresh = function() {
			if ($scope.available) {
				initPager($scope);
				if ($scope.isShow) {
					$scope.newDatas = [];
					getNewListData("refresh");
				} else {
					$scope.existDatas = [];
					getExistListData("refresh");
				}
			}
		};

		/*上拉加载更多*/
		$scope.loadMore = function() {
			if ($scope.available) {
				if ($scope.noMoreItemsAvailable) {
					$scope.$broadcast('scroll.infiniteScrollComplete');
					return;
				}
				if ($scope.isFirstIn) {
					$scope.isFirstIn = false;
					$scope.$broadcast('scroll.infiniteScrollComplete');

					return;
				} else {
					$scope.isFirstIn = true;
					$scope.pageObj.page++;
					if ($scope.isShow) {
						getNewListData("loadMore");
					} else {
						getExistListData("loadMore");
					}
				}
			}
		};




















	}
]);