angular.module("PMPMobile.directive").directive('existingAdvancesList', ['$rootScope', '$location', '$ionicModal', 'DetailDisposeServices', 'PrepaymentManagementApiServices',
	function($rootScope, $location, $ionicModal, DetailDisposeServices, PrepaymentManagementApiServices) {
		return {
			restrict: 'E',
			replace: true,
			scope: {
				data: '='
			},
			templateUrl: 'views/bill/prepayment/existing-advances-list.html',
			link: function(scope) {
				switch (scope.data.hide.checkStatus) {
					case "01"://待审批
					    scope.data.statusColor="penging";
						break;
					case "02"://归档
					    scope.data.statusColor="audited";
						break;
					case "03"://驳回
					    scope.data.statusColor="turn-down";
						break;
					case "04"://ECP驳回
					    scope.data.statusColor="turn-down";
						break;
					case "05"://审批中
					    scope.data.statusColor="audited";
						break;
					case "06"://ECP撤销
					    scope.data.statusColor="undo";
						break;
					case "07"://财务驳回
					    scope.data.statusColor="turn-down";
						break;
					case "08"://已红冲
					    scope.data.statusColor="turn-down";
						break;
				}

				$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.modal = modal;
				});
				scope.editPrepaymentClick = function() {
					DetailDisposeServices.setEditAdvancesMsg(scope.data);
					$location.path("/editPrepayment/edit");
				};
				scope.deletePrepaymentClick = function() {
					scope.modalShow = "2";
					scope.deleteAlert = "您确定要删除这条预付款吗？";
					scope.modal.show();
				};
				scope.detailPrepaymentClick = function() {
					DetailDisposeServices.setEditAdvancesMsg(scope.data);
					$location.path("/detailPrepayment");
				};
				scope.deleteInvoice = function() {
					console.log(scope.data);
					PrepaymentManagementApiServices.deleteExistingAdvances(scope.data.hide.advancePaymentId).then(function(res) {
						if (res.Flag == '1') {
							GetByid("existing-advances-list-div" + scope.data.hide.advancePaymentId).remove();
							scope.modal.hide();
						}

					});
				};
				scope.cancelInvoice = function() {
					scope.modal.hide();
				}
			}
		}
	}
]);