angular.module('PMPMobile.services').factory('PrepaymentManagementApiServices', ["$http", "Global", "$q",
		function($http, Global, $q) {
			var getPromise = function(p) {
				var defer = $q.defer();
				p.success(function(response) {
					return defer.resolve(response);
				}).error(function() {
					return defer.reject();
				});
				return defer.promise;
			};
			return {
				//检查是否可以新增预付款
				checkAdvances: function(){
					var url = Global.apiPath + '/pmp/app/advancePay/advancePay/checkAdd.ht';
					return getPromise($http.get(url));
				},
				//新增预付款列表
				getNewAdvances: function(countDate,pageSize,showPage){
					var url = Global.apiPath + '/pmp/app/advancePay/advancePay/billCount.ht?countDate='+countDate+'&pageSize='+pageSize+'&page='+showPage;
					return getPromise($http.get(url));
				},
				//现有预付款列表
				getExistingAdvances: function(countDate,applyDate,pageSize,showPage){
					var url = Global.apiPath + '/pmp/app/advancePay/advancePay/list.ht?countDate='+countDate+'&applyDate='+applyDate+'&pageSize='+pageSize+'&page='+showPage;
					return getPromise($http.get(url));
				},
				//删除现有预付款
				deleteExistingAdvances: function(advancePaymentId){
					var url = Global.apiPath + '/pmp/app/advancePay/advancePay/del.ht?advancePaymentId='+advancePaymentId;
					return getPromise($http.get(url));
				},
				//编辑预付款
				editExistingAdvances: function(obj){
					var url = Global.apiPath + '/pmp/app/advancePay/advancePay/save.ht';
					return getPromise($http.post(url,obj));
				},
				//新增预付款
				addExistingAdvances: function(obj){
					var url = Global.apiPath + '/pmp/app/advancePay/advancePay/save.ht';
					return getPromise($http.post(url,obj));
				}
			};
		}
	]);