var isExit = false;
var PMPMobileApp = angular.module('PMPMobile', [
	'ionic',
	'PMPMobile.common',
	'PMPMobile.controller',
	'PMPMobile.directive',
	'PMPMobile.services',
	'PMPMobile.filters',
	'PMPMobile.global'
]);
angular.module("PMPMobile.common", []);
angular.module("PMPMobile.controller", []);
angular.module("PMPMobile.directive", []);
angular.module("PMPMobile.services", []);
angular.module("PMPMobile.filters", []);
angular.module("PMPMobile.global", []);


PMPMobileApp.config(function($compileProvider) {
	$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|tel):/);
}).config(function($httpProvider) {
	$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
});


PMPMobileApp.config(['$stateProvider', '$urlRouterProvider',
	function($stateProvider, $urlRouterProvider) {
		$stateProvider
			.state('Myinfo', {
				url: '/myinfo',
				templateUrl: 'views/bulletin/latest/myinfo.html',
				controller: 'MyinfoController'
			})
			.state('Myinstitution', {
				url: '/myinstitution',
				templateUrl: 'views/bulletin/institution/myinstitution.html',
				controller: 'MyinstitutionController'
			})
			.state('Mynews', {
				url: '/mynews',
				templateUrl: 'views/bulletin/news/mynews.html',
				controller: 'MynewsController'
			})
			.state('Mynotice', {
				url: '/mynotice',
				templateUrl: 'views/bulletin/notice/mynotice.html',
				controller: 'MynoticeController'
			})
			.state('MySearch', {
				url: '/mysearch/:tabType/:infoType',
				templateUrl: 'views/bulletin/common/myinfo-search.html',
				controller: 'MysearchController'
			})
			
			.state('MyBulletinDetail', {
				url: '/mybulletindetail/:infoType/:guid/:tbName',
				templateUrl: 'views/bulletin/common/bulletin-detail-list.html',
				controller: 'MybulletindetailController'
			})
		
		$urlRouterProvider.otherwise('/myinfo');
	}
]);

function toggleSuccess() {
	console.log('toggle callback ok');
}

function toggleError(errMsg) {
	console.log(errMsg);
}
PMPMobileApp.run(["GlobalInterceptorHandler", "$rootScope", '$ionicPlatform', '$location', '$timeout',
	function(GlobalInterceptorHandler, $rootScope, $ionicPlatform, $location, $timeout) {
		GlobalInterceptorHandler.registerResponseHandling($rootScope);
		$ionicPlatform.registerBackButtonAction(function(e) {
			console.log("监听到返回键");
			console.log("当前地址", $location.path());
			/*先捕获异常，禁止使用ionic中自带的处理机制，根据不同的页面的后缀，进行不同的页面的跳转处理*/
			e.preventDefault();
			//如果是模块首页 按返回键回到平台
			if ($location.path() == "/myinfo"||$location.path() == "/myinstitution"||$location.path() == "/mynews"||$location.path() =="/mynotice" ) {
				var exec = cordova.require("cordova/exec");
				exec(toggleSuccess, toggleError, 'TogglePlugin', 'toggle', [-3]);

			}else {
				//其他状态自行按历史返回
				$rootScope.$viewHistory.backView.go();
			}
			return false;
		}, 101);
	}
]);