angular.module('PMPMobile.controller').controller('MysearchController', ['$rootScope', "$stateParams", "$scope", "$location", '$ionicModal', '$ionicScrollDelegate', '$ionicPopup', 'FooterServices', 'LatestApiServices', 'DetailDisposeServices', '$timeout',
	function($rootScope, $stateParams, $scope, $location, $ionicModal, $ionicScrollDelegate, $ionicPopup, FooterServices, LatestApiServices, DetailDisposeServices, $timeout) {
		FooterServices.hide();
		$scope.collectionIcon = 'icon-sup-collect';
		$scope.collectionBG = 'rejected';

		initDataFun();

		function init() {

			//获取路由参数
			$scope.tabType = $stateParams.tabType; //我的信息还是我的收藏
			$scope.moduleType = $stateParams.infoType; //最新、公告、制度、资讯
			$scope.isLatest = $scope.moduleType == '0';
			console.log($scope.isLatest);
			//页码、页面大小、列表数组
			$scope.dataInfo = [];
			$scope.dataCollection = [];
			$scope.page = 1;
			$scope.pageSize = 8;
			//初次进来不加载
			$scope.noMoreItemsAvailable = true;
			$scope.isFirstIn = true;
			if ($scope.tabType == '0') { //我的信息
				$scope.show = true;
			} else if ($scope.tabType == '1') { //我的收藏
				$scope.show = false;
			}
		}


		function initDataFun(type) {
			init();
			$ionicScrollDelegate.scrollTop(true);
			if ($scope.searchWord == '' || $scope.searchWord == null) { //输入框为空

			} else { //输入框有值
				getDataList();
			}
		}

		//拉取数据列表
		function getDataList(type) {
			var postData = "titleType=" + $scope.tabType + "&infoType=" + $scope.moduleType + "&titleName=" + $scope.searchWord + "&page=" + $scope.page + "&pageSize=" + $scope.pageSize;
			console.log("提交的数据为：" + postData);
			var dataCount = 0;
			var list = [];
			if ($scope.tabType == "0") { //页面数据类型	
				console.log("我的信息");
				LatestApiServices.getBulletinDataList(postData).then(function(res) {
					if (res.Flag == 1) {
						console.log(res);
						list = res.Result;
						$scope.dataInfo = $scope.dataInfo.concat(list);
						dataCount = res.totalCount;

					}
				})

			} else if ($scope.tabType == "1") {
				LatestApiServices.getBulletinDataList(postData).then(function(res) {
					if (res.Flag == 1) {
						console.log(res);
						list = res.Result;
						$scope.dataCollection = $scope.dataCollection.concat(list);
						dataCount = res.totalCount;
					}
				})

			}
			//停止加载
			$scope.$broadcast('scroll.infiniteScrollComplete');
			//刷新数据
			refreshData(type, list.length);
		}

		//上拉加载更多
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) { //没有更多数据时
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) { //第一次进来
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.page++;
				getDataList("loadMore");
			}
		};

		function refreshData(type, length) {
			if (type == "refresh") {
				console.log("已更新");
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}
		//返回
		$scope.toBack = function() {
			//清除搜索结果
			$scope.dataInfo = [];
			$scope.dataCollection = [];
			history.back();
		}

		//收藏与取消收藏
		$scope.collectionClick = function(message, index, item) {
				var collectStatus = item.hide.activeStatus == '0' ? item.hide.activeStatus : '1';
				var postData = "guid=" + item.hide.guid + "&tbname=" + item.hide.tbName + "&activeStatus=" + collectStatus;
				var info;
				if (item.hide.activeStatus == '0') {
					LatestApiServices.collectBulletin(postData).then(function(res) {
						if (res.Flag == 1) {
							$scope.collectionBG = 'rejected';
							info = "已取消收藏此条信息！";
							$scope.infiniteData = info;
							$(".infinite-data").show();
							$timeout(function() {
								$(".infinite-data").hide();
							}, 700);
							initDataFun();
						}
					})

				} else {
					LatestApiServices.collectBulletin(postData).then(function(res) {
						if (res.Flag == 1) {
							$scope.collectionBG = 'mCollection';
							info = "已收藏此条信息！";
							$scope.infiniteData = info;
							$(".infinite-data").show();
							$timeout(function() {
								$(".infinite-data").hide();
							}, 700);
							initDataFun();
						}
					})
				}

			}
			//确认搜索
		$scope.submit = function() {
				console.log("搜索");
				$scope.dataInfo = [];
				$scope.dataCollection = [];
				getDataList();
			}
			//详情
		$scope.goDetailById = function(item) {
			setBulletinBasic(item);
			$location.path('/mybulletindetail/' + item.show.infoType + '/' + item.hide.guid + '/' + item.hide.tbName);
		}


	}




]);