angular.module('PMPMobile.controller').controller('MyinstitutionController', ['$rootScope', "$scope", "$location", '$ionicModal', '$ionicScrollDelegate', '$ionicPopup', 'FooterServices', 'LatestApiServices', 'DetailDisposeServices', '$timeout',
	function($rootScope, $scope, $location, $ionicModal, $ionicScrollDelegate, $ionicPopup, FooterServices, LatestApiServices, DetailDisposeServices, $timeout) {
		FooterServices.activeItemByIndex(1);
		$scope.tabs = [{
			title: '我的信息'
		}, {
			title: '我的收藏'
		}];
		$scope.collectionIcon = 'icon-sup-collect';
		$scope.collectionBG = 'rejected';
		$scope.currentTab = '我的信息';
		$scope.onClickTab = function(tab) {
			$ionicScrollDelegate.scrollTop(false);
			if ($scope.currentTab != tab.title) {
				$scope.currentTab = tab.title;
				$scope.show = !$scope.show;
			}
			initDataFun();
		}
		$scope.isActiveTab = function(tabTitle) {
			return tabTitle == $scope.currentTab;
		}

		//数据初始化
		initDataFun();

		function init() {
			if ($scope.currentTab == '我的信息') {
				console.log('我的信息页面');
				$scope.show = true;
				$scope.tabType = '0';
			} else if ($scope.currentTab == '我的收藏') {
				console.log('我的收藏页面');
				$scope.show = false;
				$scope.tabType = '1';
			}
			//最新模块、页码、页面大小、列表数组
			$scope.moduleType = '1';
			$scope.dataInfo = [];
			$scope.dataCollection = [];
			$scope.page = 1;
			$scope.pageSize = 8;
			$scope.noMoreItemsAvailable = true;
			$scope.isFirstIn = true;
		}

		function initDataFun(type) {
			init();
			$ionicScrollDelegate.scrollTop(true);
			getDataList(type);
		}

		//拉取数据列表
		function getDataList(type) {
			var postData = "titleType=" + $scope.tabType + "&infoType=" + $scope.moduleType + "&titleName=" + "" + "&page=" + $scope.page + "&pageSize=" + $scope.pageSize;
			var dataCount = 0;
			var list = [];
			if ($scope.currentTab == "我的信息") { //页面数据类型	
				LatestApiServices.getBulletinDataList(postData).then(function(res) {
					if (res.Flag == 1) {
						console.log(res);
						list = res.Result;
						$scope.dataInfo = $scope.dataInfo.concat(list);
						dataCount = res.totalCount;
						//停止刷新
						cancelScrollInitFunction($scope);
						//停止加载
						$scope.$broadcast('scroll.infiniteScrollComplete');
						//刷新数据
						refreshData(type, list.length);
					}
				})

			} else if ($scope.currentTab == "我的收藏") {
				LatestApiServices.getBulletinDataList(postData).then(function(res) {
					if (res.Flag == 1) {
						console.log(res);
						list = res.Result;
						$scope.dataCollection = $scope.dataCollection.concat(list);
						dataCount = res.totalCount;
						//停止刷新
						cancelScrollInitFunction($scope);
						//停止加载
						$scope.$broadcast('scroll.infiniteScrollComplete');
						//刷新数据
						refreshData(type, list.length);
					}
				})

			}


		}

		//上拉加载更多
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) { //没有更多数据时
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) { //第一次进来
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.page++;
				getDataList("loadMore");
			}
		};

		//下拉刷新
		$scope.onRefresh = function() {
			init();
			getDataList("refresh");
		};

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}


		//收藏与取消收藏
		$scope.collectionClick = function(message, index, item) {
			var collectStatus = item.hide.activeStatus == '0' ? item.hide.activeStatus : '1';
			var postData = "guid=" + item.hide.guid + "&tbname=" + item.hide.tbName + "&activeStatus=" + collectStatus;
			var info;
			if (item.hide.activeStatus == '0') {
				LatestApiServices.collectBulletin(postData).then(function(res) {
					if (res.Flag == 1) {
						$scope.collectionBG = 'rejected';
						info = "已取消收藏此条信息！";
						$scope.infiniteData = info;
						$(".infinite-data").show();
						$timeout(function() {
							$(".infinite-data").hide();
						}, 700);
						initDataFun();
					}
				})

			} else {
				LatestApiServices.collectBulletin(postData).then(function(res) {
					if (res.Flag == 1) {
						$scope.collectionBG = 'mCollection';
						info = "已收藏此条信息！";
						$scope.infiniteData = info;
						$(".infinite-data").show();
						$timeout(function() {
							$(".infinite-data").hide();
						}, 700);
						initDataFun();
					}
				})
			}

		}

		//退出到主页
		$scope.backLogin=function(){
			var exec = cordova.require("cordova/exec");
			exec(callbackok, callbackerr, 'TogglePlugin', 'toggle', [1]);
		}
		function callbackok() {
			console.log('callback ok');
		}

		function callbackerr(result) {
			console.log("error!");
		}

		//搜索
		$scope.pmpSearch = function() {
				$location.path('/mysearch/' + $scope.tabType + '/' + $scope.moduleType);
			}
			//详情
		$scope.goDetailById = function(item) {
			setBulletinBasic(item);
			$location.path('/mybulletindetail/' + item.show.infoType + '/' + item.hide.guid + '/' + item.hide.tbName);
		}

	}


]);