angular.module('PMPMobile.controller').controller('GoodsChooseController', ['$rootScope', "$scope", '$stateParams', '$ionicScrollDelegate', '$location', '$timeout', '$ionicModal', 'FooterServices', 'GoodsChooseServices',
	function($rootScope, $scope, $stateParams, $ionicScrollDelegate, $location, $timeout, $ionicModal, FooterServices, GoodsChooseServices) {
		FooterServices.hide();
		$ionicModal.fromTemplateUrl('views/common/goods-choose.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.chooseMadal = modal;
		});
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		/*页面关闭时销毁弹出框*/
		$scope.$on('$destroy', function() {
			$scope.chooseMadal.remove();
			$scope.modal.remove();
		});
		$scope.pageObj = {};
		$scope.pageObj.page = 1;
		$scope.currentTab = "";

		$scope.addNewItem = function(type, networkCode) {
			console.log(networkCode);
			console.log(type);
			if (type == 'materiels' && networkCode == "") {
				$scope.modalShow = 4;
				$scope.remind = "没有选择网点代码！";
				$scope.modal.show();
			} else {
				$scope.chooseMadal.show();
				$scope.currentTab = type;
				$scope.networkCode = networkCode;
				//数据初始化
				initDataFun();
		}

		}
		$scope.hide = function() {
			$scope.modal.hide();
		}
		$scope.changeInput = function(searchWord) {
			$scope.searchWord = searchWord;
		}

		function init() {
			if ($scope.currentTab == "materiels") { //初始化页面类型
				console.log("提供物料搜索");
				$scope.showMateriels = true;
				$scope.dataGoods = [];
			} else if ($scope.currentTab == "assets") {
				console.log("提供资产搜索");
				$scope.showMateriels = false;
				$scope.dataLabor = [];
			}
			//第一次进来
			//			$scope.isFirstIn = true;
			//			$scope.page = 1;
			//			$scope.pageSize = 8;
			//第一次进来时禁止上拉加载
			$scope.noMoreItemsAvailable = true;
			initPager($scope);
		}

		function initDataFun(type) {
			init();
			$ionicScrollDelegate.scrollTop(true);
			getDataList();
		}

		function getDataList(type) {
			var list = [];
			if ($scope.currentTab == "materiels") { //页面数据类型
				console.log("搜索的是物料");
				console.log($scope.searchWord);
				GoodsChooseServices.searchMaterielsList($scope.pageObj.pageSize, $scope.pageObj.page, $scope.searchWord == null ? "" : $scope.searchWord, $scope.networkCode).then(function(res) {
					console.log(res);
					if (res.Flag == 1) {
						list = res.Result;
						$scope.dataGoods = $scope.dataGoods.concat(list);
						$scope.noMoreItemsAvailable = $scope.dataGoods.length == res.totalCount;
						$scope.$broadcast('scroll.infiniteScrollComplete');
						$ionicScrollDelegate.resize();
						//停止刷新
						cancelScrollInitFunction($scope);
						//刷新数据
						if (list.length == 0) {
							$scope.modalShow = 4;
							$scope.remind = "没有搜到数据！";
							$scope.modal.show();
						}else{
							refreshData(type, list.length);
						}
						
					}
				});


			} else if ($scope.currentTab == "assets") {
				console.log("搜索的是资产");
				console.log($scope.searchWord);
				GoodsChooseServices.searchAssetsList($scope.pageObj.pageSize, $scope.pageObj.page, $scope.searchWord == null ? "" : $scope.searchWord).then(function(res) {
					console.log(res);
					if (res.Flag == 1) {
						list = res.Result;
						$scope.dataLabor = $scope.dataLabor.concat(list);
						$scope.noMoreItemsAvailable = $scope.dataLabor.length == res.totalCount;
						$scope.$broadcast('scroll.infiniteScrollComplete');
						$ionicScrollDelegate.resize();
						//停止刷新
						cancelScrollInitFunction($scope);
						//刷新数据
						if (list.length == 0) {
							$scope.modalShow = 4;
							$scope.remind = "没有搜到数据！";
							$scope.modal.show();
						}else{
							refreshData(type, list.length);
						}
					}
				});

			}

		}

		//上拉加载更多
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) { //没有更多数据时
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) { //第一次进来
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.pageObj.page++;
				getDataList("loadMore");
			}
		};

		//下拉刷新
		$scope.onRefresh = function() {
			//清空数据
			initPager($scope);
			$scope.dataGoods = [];
			$scope.dataLabor = [];
			getDataList("refresh");
		};

		function refreshData(type, length) {
				if (type == "refresh") {
					if (length > 0) {
						$scope.refresherData = "已经为您更新" + length + "条数据";
						$(".refresher-data").show();
						$timeout(function() {
							$(".refresher-data").hide();
						}, 700);
					}

				} else if (type == "loadMore") {
					if (length > 0) {
						$scope.infiniteData = "已经为您加载" + length + "条数据";
						$(".infinite-data").show();
						$timeout(function() {
							$(".infinite-data").hide();
						}, 700);
					}
				}
				//NoData(length);
			}
			//选择物料
		$scope.selectMateriel = function(option) {
				option.isSelected = !option.isSelected;
			}
			//选择资产
		$scope.selectAsset = function(option) {
				option.isSelected = !option.isSelected;
			}
			//全选
		$scope.listBatchSelAll = function() {
				if ($scope.currentTab == "materiels") { //页面数据类型	
					_.each($scope.dataGoods, function(item) {
						item.isSelected = true;
					})
				} else if ($scope.currentTab == "assets") {
					_.each($scope.dataLabor, function(item) {
						item.isSelected = true;
					})
				}
			}
			//清空所选
		$scope.listBatchCancelSel = function() {
				if ($scope.currentTab == "materiels") { //页面数据类型	
					_.each($scope.dataGoods, function(item) {
						item.isSelected = false;
					})
				} else if ($scope.currentTab == "assets") {
					_.each($scope.dataLabor, function(item) {
						item.isSelected = false;
					})
				}
			}
			//确认所选
		$scope.listBatchSubmit = function() {
				console.log("确认");
				if ($scope.currentTab == "materiels") { //页面数据类型		
					//广播
					var chooseList = [];
					_.each($scope.dataGoods, function(item) {
						if (item.isSelected) {
							item.isSelected=false;
							chooseList.push(item);
						}
					})
					console.log("materielsSelect emit: ", chooseList);
					$scope.$emit("materielsSelect", chooseList);
					$scope.chooseMadal.hide();
				} else if ($scope.currentTab == "assets") {
					//广播
					var chooseList = [];
					_.each($scope.dataLabor, function(item) {
						if (item.isSelected) {
							item.isSelected=false;
							chooseList.push(item);
						}
					})
					console.log("assetsSelect emit: ", chooseList);
					$scope.$emit("assetsSelect", chooseList);
					$scope.chooseMadal.hide();
				}
			}
			//确定搜索
		$scope.submit = function() {
			$scope.dataGoods = [];
			$scope.dataLabor = [];
			getDataList();
		}
		$scope.back = function() {
			$scope.dataGoods = [];
			$scope.dataLabor = [];
			$scope.searchWord = "";
			$scope.chooseMadal.hide();
		}

	}
]);