angular.module('PMPMobile.controller').controller('NetworkChooseController', ['$rootScope', "$scope", "$ionicModal", "AssetsApiServices", "MaterielsApiServices",
	function($rootScope, $scope, $ionicModal, AssetsApiServices, MaterielsApiServices) {
		$ionicModal.fromTemplateUrl('views/common/network-choose.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.netModal = modal;
		});
		var netWorkType = "";
		$scope.openNetModal = function(type) {
			$scope.netModal.show();
			netWorkType = type;
			init();
		};
		$scope.closeNetModal = function() {
			$scope.netModal.hide();
		};

		function init() {
			$scope.datas = {};
			$scope.selectIndex = -1;
			$scope.datas.keyWords = "";
			$scope.datas.items = [];
			initData();
		};
		
		
		function initData(){
			if(netWorkType == 'materiels'){
				var data = "keyWords=" + "";
				MaterielsApiServices.getMaterielsNetSearchList(data).then(function(res){
					if(res.Flag == "1"){
						$scope.datas.items = res.Result;
					}else{

					}
					
				});
			}else if(netWorkType == 'assets'){
				var data = "net=" + "";
				AssetsApiServices.getNetSearchList(data).then(function(res){
					if(res.Flag == "1"){
						$scope.datas.items = res.Result;
					}else{

					}
				});
			}
		}
		$scope.search = function() {
			$scope.selectIndex = -1;
			$scope.datas.items = [];
			if(netWorkType == 'materiels'){
				var data = "keyWords=" + $scope.datas.keyWords;
				MaterielsApiServices.getMaterielsNetSearchList(data).then(function(res){
					if(res.Flag == "1"){
						$scope.datas.items = res.Result;
					}else{

					}
					
				});
			}else if(netWorkType == 'assets'){
				var data = "net=" + $scope.datas.keyWords;
				AssetsApiServices.getNetSearchList(data).then(function(res){
					if(res.Flag == "1"){
						$scope.datas.items = res.Result;
					}else{

					}
				});
			}
			
		};
		$scope.selectNetwork = function(index, item) {
			$scope.selectIndex = index;
			$rootScope.$broadcast("netWorkReceiver", item);
			$scope.closeNetModal();
		};
	}
]);