angular.module("PMPMobile.directive").directive('datePicker', ['$rootScope',function($rootScope) {
		return {
			restrict: "A",
			scope: {
				minDate: '='
			},
			link: function(scope, element) {
				

				function getMinDate() {
					if (typeof scope.minDate === "string") {
						return new Date(scope.minDate);
					}

					return scope.minDate;
				}

				$.extend($.mobiscroll.themes['android-ics light'], {
					minWidth: 130,
					buttons: ['cancel', 'set']
				});

				element.scroller('destroy').scroller({
					preset: 'date',
					dateOrder: 'yymmdd',
					lang: "zh",
					minDate: getMinDate() || new Date(2010, 12, 30),
					maxDate: new Date(2030, 12, 30),
					theme: "android-ics light",
					mode: "scroller",
					display: "modal",
					animate: "fade"
				});

				$rootScope.$on('$stateChangeStart', function(event) {
					var inst = element.scroller('getInst');
					if (inst.isVisible()) {
						inst.hide();
						event.preventDefault();
					}
				});

			}
		};
	}]);