angular.module("PMPMobile.directive").directive('latestFooter', ['LatestApiServices',
	function(LatestApiServices) {
		return {
			restrict: 'E',
			replace: true,
			scope: {},
			template: '<div class="tabs footer-wrapper tabs-icon-top"  >' +
				'<a ng-click="activeTab($index,item.path)" class="tab-item bulletin-foot"  ng-class="{active: selexted== item.index}"   ng-repeat="item in footerItems">' +
				'<i class="icon {{item.icon}}"></i><span ng-bind="item.title"  ></span>' +
				'<b ng-show="item.reminder" class="latestTip">●</b>' +
				'</a>' +
				'</div>',
			link: function(scope, element) {
				function activeNavigatorBarByIndex(index) {
					element.find("a").removeClass("active");
					element.find("a").eq(index).addClass("active");
				}

				function removeActiveByIndex(index) {
					element.find("a").removeClass("active");
				}

				scope.activeTab = function(index, path) {
					activeNavigatorBarByIndex(index);
					scope.goTo(path);
				};

				scope.$on("removeActiveByIndex", function(event, index) {
					removeActiveByIndex(index);
				});

				scope.$on("activeNavigatorBarByIndex", function(event, index) {
					activeNavigatorBarByIndex(index);
				});

				scope.$on("hideNavigatorFooter", function() {
					element.hide();
				});

				scope.$on("showNavigatorFooter", function() {
					showRedDot();
					element.show();
				});

				function showRedDot() {
					var postData = "titleType=" + "0" + "&infoType=" + "0" + "&titleName=" + "" + "&page=" + "1" + "&pageSize=" + "8";
					LatestApiServices.getBulletinDataList(postData).then(function(res){
						if(res.Flag==1){
							if(res.Result.length>0){//我的信息中有最新数据则显示红点
								scope.footerItems[0].reminder = true;
							}else{
								scope.footerItems[0].reminder = false;
							}
						}
					})
				}
			},
			controller: ['$rootScope', '$timeout', '$scope', '$location',
				function($rootScope, $timeout, $scope, $location) {
					$scope.goTo = function(url) {
						$location.path(url === "/confirmed" ? url + "/?" : url);
					};
					$scope.footerItems = [{
						"icon": "icon-sup-new",
						"title": "最新",
						"reminder": "",
						path: "/myinfo"
					}, {
						"icon": "icon-sup-system",
						"title": "制度",
						"reminder": false,
						path: "/myinstitution"
					}, {
						"icon": "icon-sup-ann",
						"title": "公告",
						"reminder": false,
						path: "/mynotice"
					}, {
						"icon": "icon-sup-info",
						"title": "资讯",
						"reminder": false,
						path: "/mynews"
					}];

				}
			]
		};

	}
]);