angular.module("PMPMobile.directive").directive('footer', [

	function() {
		return {
			restrict: 'E',
			replace: true,
			scope: {},
			template: '<div class="tabs footer-wrapper tabs-icon-top"  >' +
				'<a ng-click="activeTab($index,item.path)" class="tab-item"  ng-class="{active: selexted== item.index}"   ng-repeat="item in footerItems">' +
				'<i class="icon {{item.icon}}"></i><span ng-bind="item.title"  ></span>' +
				'</a>' +
				'</div>',
			link: function(scope, element) {
				function activeNavigatorBarByIndex(index) {
					element.find("a").removeClass("active");
					element.find("a").eq(index).addClass("active");
				}

				function removeActiveByIndex(index) {
					element.find("a").removeClass("active");
				}

				scope.activeTab = function(index, path) {
					activeNavigatorBarByIndex(index);
					scope.goTo(path);
				};

				scope.$on("removeActiveByIndex", function(event, index) {
					removeActiveByIndex(index);
				});

				scope.$on("activeNavigatorBarByIndex", function(event, index) {
					activeNavigatorBarByIndex(index);
				});

				scope.$on("hideNavigatorFooter", function() {
					element.hide();
				});

				scope.$on("showNavigatorFooter", function() {
					element.show();
				});



			},
			controller: ['$rootScope', '$timeout', '$scope', '$location',
				function($rootScope, $timeout, $scope, $location) {
					$scope.goTo = function(url) {
						$location.path(url === "/confirmed" ? url + "/?" : url);
					};
					$scope.footerItems = [{
						"icon": "icon-pmp-tobeconfirmed",
						"title": "待确认账单",
						path: "/confirmed"
					}, {
						"icon": "icon-pmp-history",
						"title": "历史账单",
						path: "/history"
					}, {
						"icon": "icon-pmp-invoice",
						"title": "发票管理",
						path: "/invoice/add"
					}, {
						"icon": "icon-pmp-imprest",
						"title": "预付款管理",
						path: "/prepayment/new"
					}];

				}
			]
		};

	}
]);