angular.module("PMPMobile").factory('HttpInterceptor', ["$q", "$rootScope",
	function($q, $rootScope) {
		return {
			request: function(config) {
				config.msBeforeAjaxCall = new Date().getTime();
				return config || $q.when(config);
			},
			responseError: function(rejection) {
				if(JSON.stringify(rejection.config).indexOf("password")>-1){
					delete rejection.config.data;
				}
				var error = "http错误编码：" + rejection.status + "请求时间：" + (new Date().getTime() - rejection.config.msBeforeAjaxCall) + "ms。请求接口：" 
				+ JSON.stringify(rejection.config).replace(new RegExp("\"", "gm"), "");
				var exec = cordova.require("cordova/exec");
				exec(null, null, 'SendBackMsg', 'errorLog', [error]);
				/*进行网络的判断，当请求超过8秒时，提示用户网络错误*/
				if (new Date().getTime() - rejection.config.msBeforeAjaxCall > 8000) {
					$rootScope.$broadcast("NoNetWorksError", rejection);
					return $q.reject(rejection);
				} else if (rejection.status < 500) {
					$rootScope.$broadcast("DadaServerError", rejection);
					return $q.reject(rejection);
				} else {
					/*其他错误报的错，定义错误信息码为400以后的才显示错误信息框*/
					$rootScope.$broadcast("ResponseServerError", rejection);
					return $q.reject(rejection);
				}
			},
			response: function(response) {
				/*重新登录回调函数*/
				function reLoginSuccess(){
					console.log("relogin success");
				}
				
				function reLoginError(errMsg){
					console.log(errMsg);
				}
				
				if(response.config.url.indexOf("http")==0||response.config.url.indexOf("https")==0){
					if(typeof(response.data)=="string"&&response.data.indexOf("<title>登录-伙伴+</title>")>-1){
						/*if(window.ionic.Platform.isIOS()){
							window.location.href = "ios-login.html";
						}else{
							window.location.href = "android-login.html";
						}*/
						console.log("session timeout, call login");
						/*session超时，通知平台重新登录*/
						var exec = cordova.require("cordova/exec");
						exec(reLoginSuccess, reLoginError, 'ReloginPlugin', 'relogin', []);
					}
				}
				return $q.when(response);
			}

		};
	}
]).config(['$sceProvider', '$httpProvider',
	function($sceProvider, $httpProvider) {
		$sceProvider.enabled(false);
		$httpProvider.interceptors.push('HttpInterceptor');
	}
]);