angular.module('PMPMobile.controller').controller('CommunicationCreateController', ["$scope", "$ionicModal", "$ionicPopup", "CommunicationServices", "$location",
	function($scope, $ionicModal, $ionicPopup, CommunicationServices, $location) {
		$scope.title = "发起沟通"
		$scope.dahui = "";
		$ionicModal.fromTemplateUrl('views/communication/communication/communication-search-select.html', {
			scope: $scope,
			animation: 'slide-in-right'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.change = function() {
			console.log("change");
		};
		$scope.typeSelect = function() {
			$scope.modal.show();
		};
		$scope.closeModal = function() {
			$scope.modal.hide();
		};
		$scope.data = {
			"causeName": "",
			"businessName": "",
			"communicationName": "",
			"complainName": "",
			"advancedName": "",
			"communicationContent": "",
			"communicateType": "",
			"BG": "",
			"SERVICEAREAID": "",
			"isAdvance": ""
		};
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.finishModal = modal;
		});

		$scope.submit = function() {
			if ($scope.data.communicationContent != "" && $scope.notSelect) {
				var str = 'communicateType=' + $scope.data.communicateType + '&BG=' + $scope.data.BG + '&SERVICEAREAID=' + $scope.data.SERVICEAREAID + '&isManager=' + $scope.data.isAdvance + '&complaintName=' + $scope.data.complainName + '&communicateContent=' + $scope.data.communicationContent;
				CommunicationServices.createCommunication(str).then(function(res) {
					if (res.Flag == 1) {
						$scope.modalShow = "0";
						$scope.finishModal.show();
						setTimeout(function() {
							$scope.finishModal.hide();
							//$location.path("/communication");
							$location.path("/communicationDetail/" + res.communicateId + "/CANCEL");
							
						}, 700);
					} else {
						$ionicPopup.alert({
							template: "<p>提交失败</p>"
						});
					}
				});
			} else {
				if (!$scope.notSelect) {
					$ionicPopup.alert({
						template: "<p>请选择沟通的类型</p>"
					});
				} else {
					$ionicPopup.alert({
						template: "<p>请填写" + $scope.data.communicationName + "内容</p>"
					});
				}
			}
		};
		$scope.complete = function() {
			var flag = true;
			if($scope.data.communicationName == '投诉'&& $scope.data.advancedName == "是" ){
				flag = false;
			}
			if ($scope.data.causeName != "" && $scope.data.businessName != "" && $scope.data.communicationName != "" && (flag || (!flag && $scope.data.complainName))) {
				$scope.closeModal();
				$scope.notSelect = true;
			} else {
				$ionicPopup.alert({
					template: "<p>必填项为空</p>"
				});
			}
		};

		CommunicationServices.getSelectItem().then(function(res) {
			if (res.Result.Flag == "1") {
				$scope.causeArray = res.Result.bgs;
				$scope.communicationArray = res.Result.communicateTypes;
			}
		});

		var cause = "",
			business = "",
			communication = "",
			advanced = "";
		$scope.select = function(sige, item, index) {
			GetByid(sige + index).className = "icon  icon-radio";
			switch (sige) {
				case 'cause':
					if((sige + cause) != (sige + index)){
						addClassName(sige + cause);
						$scope.businessArray = item.areas;
						$scope.data.businessName = "";
						$scope.data.SERVICEAREAID = "";
						business = "";
					}					
					cause = index;
					$scope.data.causeName = item.BG_NAME;
					$scope.data.BG = item.BG;
					
					$scope.isShowCause = !$scope.isShowCause;
					break;
				case 'business':
					if((sige + business) != (sige + index)){
						addClassName(sige + business);
					}
					business = index;
					$scope.data.businessName = item.AREANAME;
					$scope.data.SERVICEAREAID = item.SERVICEAREAID;
					$scope.isShowBusiness = !$scope.isShowBusiness;
					break;
				case 'communication':
					$scope.data.isAdvance = "";
					$scope.data.complainName = "";
					if((sige + communication) != (sige + index)){
						addClassName(sige + communication);
					}
					communication = index;
					$scope.data.communicationName = item.communicateTypeName;
					$scope.data.communicateType = item.communicateType;
					$scope.isShowCommunication = !$scope.isShowCommunication;
					switch ($scope.data.communicationName) {
						case '咨询':
							$scope.data.typeClass = "icon-pmp-advisory";
							break;
						case '需求':
							$scope.data.typeClass = "icon-pmp-demand";
							break;
						case '投诉':
							$scope.data.typeClass = "icon-pmp-complaints";
							break;
						case '建议':
							$scope.data.typeClass = "icon-pmp-suggest";
							break;
						case '申诉':
							$scope.data.typeClass = "icon-pmp-appeal";
							break;
						default:
							break;
					}
					break;
				case 'advanced':
					if((sige + advanced) != (sige + index)){
						addClassName(sige + advanced);
					}
					advanced = index;
					if (index == 0) {
						$scope.data.isAdvance = '0';
					} else {
						$scope.data.isAdvance = '1';
					}
					$scope.data.advancedName = item;
					$scope.isShowAdvanced = !$scope.isShowAdvanced;
					break;
			}
		};

		function addClassName(id) {
			if (GetByid(id) != null) {
				GetByid(id).className = "icon  icon-radio-c";
			}
		}
		$scope.changeNum = 0;
		$scope.change = function() {
			$scope.changeNum = $scope.data.communicationContent.length;
		};
		$scope.isShow = function(sige, item) {
			switch (sige) {
				case 'cause':
					$scope.isShowCause = !$scope.isShowCause;
					$scope.isShowBusiness = false;
					$scope.isShowCommunication = false;
					$scope.isShowAdvanced = false;
					break;
				case 'business':
					$scope.isShowBusiness = !$scope.isShowBusiness;
					$scope.isShowCause = false;
					$scope.isShowCommunication = false;
					$scope.isShowAdvanced = false;
					break;
				case 'communication':
					$scope.isShowCommunication = !$scope.isShowCommunication;
					$scope.isShowCause = false;
					$scope.isShowBusiness = false;
					$scope.isShowAdvanced = false;
					break;
				case 'advanced':
					$scope.isShowAdvanced = !$scope.isShowAdvanced;
					$scope.isShowCause = false;
					$scope.isShowBusiness = false;
					$scope.isShowCommunication = false;
					break;
			}
		};
	}
]);