angular.module('PMPMobile.controller').controller('CommunicationDetailController', ['$scope', '$ionicScrollDelegate','$stateParams','$ionicModal','$ionicPopup','$timeout','$location','CommunicationServices',
	function($scope, $ionicScrollDelegate,$stateParams,$ionicModal,$ionicPopup,$timeout,$location, CommunicationServices) {
		$scope.title = "沟通详情";
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.communicationId = $stateParams.id;	//获取沟通id
		init();
		//初始化数据
		function init() {
			$scope.mManager = false;
			$scope.mFirstFlag = true;
			$scope.detailData = [];
			$scope.coummunicationData = {};
			$scope.cancelFlag = false;
			$scope.noMoreItemsAvailable = true;
			$scope.isShowBtn = true;	//控制是否显示右上角的按钮
			$scope.isShowInput = true;	//控制是否显示输入框
			initPager($scope);
			$scope.pageObj.pageSize = 5;
			getData();
		}
		//初始化按钮信息
		function initBtnType(type, obj){
			//接收要打开的类型参数
			switch(type){
				case 'CANCEL': //撤销沟通
					$scope.btnName = "撤销沟通";					
					break;
				case 'ING': //结束沟通
					$scope.btnName = "结束沟通";
					break;
				case '0': //评价
					$scope.isShowInput = false;
					$scope.btnName = "评价";
					break;
				case '1': //已评价
				case '2':
				case '3':
				case '4':
				case '5':
					$scope.isShowBtn = false;
					$scope.isShowInput = false;
					if($("#evaId").length > 0){	//若已插入评价，则getData时不再重复插入					
					}else{
						hasBeenEvaluated(obj);
					}				
					break;
				default:
					break; 
			}
		}
		//初始化详情页面时，若已评价，则插入评价内容
		function hasBeenEvaluated(obj){
			$scope.evaSuccessObj = {};
			$scope.evaSuccessObj.communicateDate = obj.evaluateDate;
			$scope.evaSuccessObj.communicateContent = obj.evaluate;
			switch(obj.evaluateGrade){
				case '1':
					$scope.evaSuccessObj.score = {name:'差评!', val:1, color:'lowEvaColor'};
					break;
				case '2':
					$scope.evaSuccessObj.score = {name:'差评!', val:2, color:'lowEvaColor'};
					break;
				case '3':
					$scope.evaSuccessObj.score = {name:'中评!', val:3, color:'midEvaColor'};
					break;
				case '4':
					$scope.evaSuccessObj.score = {name:'好评!', val:4, color:'highEvaColor'};
					break;
				case '5':
					$scope.evaSuccessObj.score = {name:'好评!', val:5, color:'highEvaColor'};
					break;
				default:
					break;
			}
			$('.scroll').append(appendEva($scope.evaSuccessObj));
		}

		function getData(type){
			CommunicationServices.getCommunicationDetail($scope.pageObj, $scope.communicationId).then(function(res) {
				console.log("detail res: ",res);
				if(res.Flag == '1'){				
					$scope.coummunicationData = res.Result.commincation;
					$scope.openType = $scope.coummunicationData.flag;
					initBtnType($scope.openType, res.Result.evaluate);
					ifManager();
					$scope.detailData = res.Result.details.reverse().concat($scope.detailData);
					$scope.noMoreItemsAvailable = res.Result.totalCount == $scope.detailData.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					ifFirstIn(res.Result.details.length);
				}else{
					$ionicPopup.alert({
						template: "<p >" + res.Result.errmsg + "</p>"
					});
				}
				
			});
		}
		$scope.backToList = function(){
			$location.path("/commincation");
		}
		//上拉刷新
		$scope.onRefresh = function() {
			if($scope.noMoreItemsAvailable){
				return;
			};
			$scope.pageObj.page++;
			getData();			
		};
		
		//处理高经后缀
		function ifManager(){
			if($scope.coummunicationData.complaintName.indexOf("(") > 0){
				var mIndex = $scope.coummunicationData.complaintName.indexOf("(");
				$scope.mManager = true;
				$scope.coummunicationData.complaintName = $scope.coummunicationData.complaintName.substring(0,mIndex);
			}else if($scope.coummunicationData.complaintName.indexOf("（") > 0){
				var mIndex = $scope.coummunicationData.complaintName.indexOf("（");
				$scope.mManager = true;
				$scope.coummunicationData.complaintName = $scope.coummunicationData.complaintName.substring(0,mIndex);
			}
		}
		function ifFirstIn(reflength){
			if($scope.mFirstFlag){
				$timeout(function(){
					$ionicScrollDelegate.scrollBottom(true);
				},500);
				
				$scope.mFirstFlag = false;
			}else{
				$ionicScrollDelegate.scrollTo(0, document.documentElement.clientHeight, true);
			}

		}
		$scope.send = function() {
			if ($("#communicationContent").val() != "") {
				CommunicationServices.sentCommunicationDetail($stateParams.id, $("#communicationContent").val()).then(function(res){
					if(res.Flag == '1'){
						$scope.detailData.push({
							"communicateDate": res.Result.communicateDate,
							"communicateContent": $("#communicationContent").val(),
							"communicateUser": "我"
						});
						$("#communicationContent").val("");
						$ionicScrollDelegate.scrollBottom(true);
					}else{
						$ionicPopup.alert({
							template: "<p >" + res.Result.errmsg + "</p>"
						});
					}					
				});								
			}
		}
		//接收评价框事件广播
		$scope.$on("evaluationFrameReceiver", function(event, flag, data) {
			switch(flag){
				case 'cancelSuccess':
					$location.path("/commincation");
					break;
				case 'evaSuccess':
					console.log("评价成功广播: ", data);
					$scope.evaSuccessObj = {};
					$scope.evaSuccessObj.communicateDate = data.communicateDate;
					$scope.evaSuccessObj.communicateContent = data.content;
					$scope.evaSuccessObj.score = data.score;
					// $scope.evaSuccessObj.stars = data.stars;
					$('.scroll').append(appendEva($scope.evaSuccessObj));
					$("#communicationContent").val("");
					$scope.isShowBtn = false;
					$scope.isShowInput = false;
					$ionicScrollDelegate.scrollBottom(true);
					break;
				case 'nextSuccess':
					$scope.modalShow = "4";
					$scope.remind = "您已成功结束沟通!";
					$scope.modal.show();
					$scope.isShowInput = false;
					$scope.openType = '0';
					initBtnType($scope.openType, {});
					break;
				default:
					break;
			}
		});

		$scope.hide = function(){
			$scope.modal.hide();
		};

		$scope.$on('$destroy', function() {
			$scope.modal.remove();
		});

		//详细页插入评价
		function appendEva(obj){
			var Eva = document.createElement("div");
			Eva.id = 'evaId';
			var divRow = document.createElement("div");
			divRow.setAttribute("class", "mine-detail row");
			var divLeft = document.createElement("div");
			divLeft.setAttribute("class", "col-80 mine-left");
			var pInfos = document.createElement("p");
			pInfos.setAttribute("class", "detail-infos");
			pInfos.innerHTML = "我";
			divLeft.appendChild(pInfos);
			var pDate = document.createElement("p");
			pDate.setAttribute("class", "detail-infos detail-date");
			pDate.innerHTML = obj.communicateDate;
			divLeft.appendChild(pDate);
			var pContent = document.createElement("p");
			pContent.setAttribute("class", "detail-content");
			pContent.setAttribute("style", "letter-spacing:1.2px;padding: 10px;");
			var spanScoreBar = document.createElement("span");
			//设置评价标题的颜色
			spanScoreBar.setAttribute("class", "scoreBar "+obj.score.color);
			spanScoreBar.innerHTML = obj.score.name;
			//生成星星等级数量的星星
			for(var starCont = 0; starCont < obj.score.val; starCont++){
				var spanStar = document.createElement("span");
				spanStar.setAttribute("class", "icon-sup-collect-click");
				spanStar.setAttribute("style", "color:#FF9E50;");
				spanScoreBar.appendChild(spanStar);
			}
			pContent.appendChild(spanScoreBar);
			var spanContent = document.createElement("span");
			//设置评价内容
			spanContent.innerHTML = obj.communicateContent;
			pContent.appendChild(spanContent);
			var iPopup = document.createElement("i");
			iPopup.setAttribute("class", "chat-bubble-detail");
			pContent.appendChild(iPopup);
			divLeft.appendChild(pContent);
			divRow.appendChild(divLeft);
			var divRight = document.createElement("div");
			divRight.setAttribute("class", "col-20 mine-right");
			var divIconBg = document.createElement("div");
			divIconBg.setAttribute("class", "icon-bg");
			var iIconHand = document.createElement("i");
			iIconHand.setAttribute("class", "icon-hand");
			var b = document.createElement("b");
			var iIconStart = document.createElement("i");
			iIconStart.setAttribute("class", "icon-start");
			b.appendChild(iIconStart);
			divIconBg.appendChild(iIconHand);
			divIconBg.appendChild(b);
			divRight.appendChild(divIconBg);
			divRow.appendChild(divRight);
			Eva.appendChild(divRow);
			return Eva;
		}
		
	}
])
//将返回的时间字段隐藏年份显示
.filter('dateWithoutY',function(){
	return function(strD){
		return strD.substring(strD.indexOf('-')+1);
	}
});