angular.module('PMPMobile.controller').controller('CommunicationController', ['$rootScope', "$scope", "$location", '$ionicModal', '$ionicScrollDelegate', '$ionicPopup', '$timeout', 'CommunicationServices',
	function($rootScope, $scope, $location, $ionicModal, $ionicScrollDelegate, $ionicPopup, $timeout, CommunicationServices) {
		$scope.title = "沟通"
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.backWidget = function() {
			var exec = cordova.require("cordova/exec");
			exec(callbackok, callbackerr, 'TogglePlugin', 'toggle', [-2]);
		};

		function callbackok() {
			console.log('callback ok');
		}

		function callbackerr(result) {
			console.log("error!");
		}
		/*获取登录信息回调函数*/
		function supplierSuccess(str) {
			setLocalStorage(str); // 存入缓存
		}
		/*获取登录信息回调函数*/
		function supplierError(errMsg) {
			console.log(errMsg);
		}
		var isCommunication = false;
		var noData = false;
		$scope.bouncing = "";
		/* 默认沟通中*/
		$scope.currentTab = '沟通中';
		$scope.isCommu = true;
		/* tab切换*/
		$scope.tabs = [{
			title: '沟通中'
		}, {
			title: '已结束'
		}];
		$scope.onClickTab = function(tab) {
			if ($scope.currentTab != tab.title) {
				$scope.currentTab = tab.title;
				$scope.isCommu = !$scope.isCommu;
				init();
			}
		}
		$scope.isActiveTab = function(tabTitle) {
				return tabTitle == $scope.currentTab;
			}
			//初始化数据
		function init() {
			/*从插件获取登录信息*/
			var exec = cordova.require("cordova/exec");
			exec(supplierSuccess, supplierError, 'SupplierPlugin', 'supplier', []);
			$scope.items = [];
			$scope.businessGroup = [];
			$scope.communicationType = communicationType();
			$scope.isFirstIn = true;
			$scope.noMoreItemsAvailable = true;
			isCommunication = false;
			//请求参数重置
			initPager($scope);
			$scope.pageObj.bg = ""; //事业群
			$scope.pageObj.complaintType = ""; //沟通类型
			$scope.pageObj.submitDate = ""; //发起时间
			$scope.pageObj.closeDate = ""; //结束时间	
			$scope.pageObj.comuStatus = $scope.isCommu?"0":"1";	//"0"表示沟通中   "1"表示已结束
			getData();
		}
		init();

		//判断是否请求的是所有数据 bg、沟通类型、发起时间、结束时间均为空值
		function noCommuData() {
			if ($scope.pageObj.bg == '' && $scope.pageObj.complaintType == "" && $scope.pageObj.submitDate == "" && $scope.pageObj.closeDate == "") {
				return true;
			} else {
				return false;
			}
		}
		//沟通类型图标class的添加
		function translateCommunicationStatus(item) {
			console.log(item);
			switch (item.communicateTypeName) {
				case '咨询':
					item.communicationClass = "icon-pmp-advisory";
					break;
				case '需求':
					item.communicationClass = "icon-pmp-demand";
					break;
				case '投诉':
					item.communicationClass = "icon-pmp-complaints";
					break;
				case '建议':
					item.communicationClass = "icon-pmp-suggest";
					break;
				case '申诉':
					item.communicationClass = "icon-pmp-appeal";
					break;
				default:
					break;
			}
		}
		//沟通类型遍历
		function status() {
			_.map($scope.items, function(item) {
				translateCommunicationStatus(item)
			});
		};
		//事业群遍历格式化
		function business(datas) {
			return _.map(datas, function(data) {
				return {
					typeStatus: data.BGNAME,
					isSelected: false,
					statusNum: data.BG,
				};
			});
		}
		//请求数据
		function getData(type) {
			NoData(1,"");
			console.log("请求参数", $scope.pageObj);
			CommunicationServices.getCommunicationList($scope.pageObj).then(function(res) {
				console.log("请求结果为:", res);
				if (res.Flag == '1') {
					//获取沟通列表数据 
					$scope.items = $scope.items.concat(res.Result.commincationArray);
					if (res.Result.bgs.length > 1) {
						$scope.businessGroup = business(res.Result.bgs);
						$scope.businessGroup.unshift({
							typeStatus: '全部事业群',
							isSelected: true,
							statusNum: ''
						});
					} else {
						$scope.average = true;
					}
					if (res.Result.totalCount > 0) { //当前请求有数据
						$scope.isShow = false;
						$scope.showTop = true;
						$scope.bouncing = true;
						refreshData(type, res.Result.commincationArray.length);
					} else {//当前请求没数据
						if (noCommuData() && $scope.currentTab == '沟通中') { //沟通中没有数据
							console.log("沟通中所有数据为空");
							noData = true;
							$scope.isShow = true;
							$scope.showTop = false;
							$scope.bouncing = false;
							NoData(1,"");
						} else if (noCommuData() && $scope.currentTab == '已结束' && noData) {//沟通中数据为空且已结束数据为空
							console.log("沟通中和已结束数据均为空");
							noData = true;
							$scope.isShow = true;
							$scope.showTop = false;
							$scope.bouncing = false;
							NoData(1,"");
						} else {
							console.log("有条件时数据为空");
							$scope.isShow = false;
							$scope.showTop = true;
							$scope.bouncing = true;
							refreshData(type, res.Result.commincationArray.length);
						}

					}
					status();
					$scope.noMoreItemsAvailable = res.Result.totalCount == $scope.items.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					if (isCommunication) { //选择条件后
						refreshData(type, res.Result.commincationArray.length);
						$scope.isShow = false;
						$scope.showTop = true;
					}
				}
			});
		}

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length,"您当前选择的条件没有数据");
		}
		//上拉刷新
		$scope.onRefresh = function() {
			$scope.items = [];
			initPager($scope);
			getData("refresh");
		};
		/*下拉加载更多*/
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) {
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) {
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.pageObj.page++;
				getData("loadMore");
			}
		};

		//发起沟通跳转
		$scope.initiateCummunication = function() {
				$location.path("/communicationCreate");
			}
			//接受事业群的值
		$scope.$on("businessGroupstatusReceiver", function(event, data) {
			console.log(data);
			$scope.pageObj.bg = data.data;
			$scope.items = [];
			initPager($scope);
			getData();
			isCommunication = true;
		});
		//接受沟通类型的值
		$scope.$on("communicationTypestatusReceiver", function(event, data) {
			console.log(data);
			$scope.pageObj.complaintType = data.data;
			$scope.items = [];
			initPager($scope);
			getData();
			isCommunication = true;

		});
		//接受沟通中时间选择器的值
		$scope.$on("commuicationtimeReceiver", function(event, data) {
			console.log("发起时间选择的结果：", data);
			$scope.pageObj.submitDate = data.data == "全部发起时间"?"":data.data;
			$scope.items = [];
			initPager($scope);
			getData();
			isCommunication = true;
		});
		//接受已结束时间选择器的值
		$scope.$on("commuovertimeReceiver", function(event, data) {
			console.log("结束时间选择的结果：", data);
			$scope.pageObj.submitDate = data.data == "全部结束时间"?"":data.data;
			$scope.items = [];
			initPager($scope);
			getData();
			isCommunication = true;
		});
		//接收刷新页面的广播
		$scope.$on("evaluationFrameReceiver", function(event, flag, data) {
			init();
		});
		//跳转沟通详情页面
		$scope.coummunicationDetailById = function(item) {
			console.log("路径" + "/communicationDetail/" + item.communicateId + "/" + item.flag);
			$location.path("/communicationDetail/" + item.communicateId + "/" + item.flag);
		};


	}
]);