angular.module('PMPMobile.controller').controller('evaluationFrameController', ['$rootScope', "$scope", "$ionicModal", "$ionicPopup", "$location", "CommunicationServices",
	function($rootScope, $scope, $ionicModal, $ionicPopup, $location, CommunicationServices) {
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		//初始化弹出框
		$ionicModal.fromTemplateUrl('views/communication/communication/evaluation-frame.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.evaFrameModal = modal;
		});

		//初始化'暂无评论'对象
		$scope.noneEva = {name:'暂无评价', val:0, color:''};
		$scope.eva = {
			"content" : ''
		};
		
		initScoreBoard();
		$scope.count = 0;	//评价意见textarea字数

		//初始化评分板信息
		function initScoreBoard(){
			//存储评分等级数组
			$scope.starsArr = [{name:'差评!', val:1, color:'lowEvaColor', isSelect:false},{name:'差评!', val:2, color:'lowEvaColor', isSelect:false},{name:'中评!', val:3, color:'midEvaColor', isSelect:false},{name:'好评!', val:4, color:'highEvaColor', isSelect:false},{name:'好评!', val:5, color:'highEvaColor', isSelect:false}];
			//当前选中评分状态对象,初始化为‘暂无评价’
			$scope.currScoreObj = $scope.noneEva;
			$scope.eva.content = '';	//清空评论textarea内容
			$scope.count = 0;
		}

		$scope.openEvaModal = function(id, type) {
			$scope.communicateId = id;
			switch(type)	{	//接收要打开的类型参数
				case 'CANCEL': //撤销沟通
					$scope.modalShow = "2";
					$scope.deleteAlert = "您是否需要撤销此沟通？";
					$scope.modal.show();				
					break;
				case 'ING': //结束沟通
					initScoreBoard();
					$scope.frameType = true;
					$scope.evaFrameModal.show();
					break;
				case '0': //评价
					initScoreBoard();
					$scope.frameType = false;
					$scope.evaFrameModal.show();
					break;
				default:
					break;
			}
		};
		//关闭评价框
		$scope.closeEvaModal = function() {			
			$scope.evaFrameModal.hide();
		};
		//撤销沟通-确定
		$scope.deleteInvoice = function() {
			CommunicationServices.cancelCommunicationDetail($scope.communicateId).then(function(res) {
				if (res.Flag == '1') {
					$scope.modalShow = "6";
					$scope.alertMsg = "撤销成功";
					setTimeout(function() {
						$scope.modal.hide();
						evaBroadcast('cancelSuccess', '');
					}, 700);
				}else{
					$ionicPopup.alert({
						template: "<p >" + res.Result.errmsg + "</p>"
					});
				}
			});
		}
		//撤销沟通-取消
		$scope.cancelInvoice = function() {
			$scope.modal.hide();
		}

		//点击星星
		$scope.clkStar = function(item){
			item.isSelect = !item.isSelect;
			if(item.isSelect){
				$scope.currScoreObj = item;
				for(var i = 0; i < item.val; i++){
					$scope.starsArr[i].isSelect = true;
				}
			}else{
				for(var i = $scope.starsArr.length-1; i >= item.val; i--){
					$scope.starsArr[i].isSelect = false;
				}
				if(item.val == $scope.currScoreObj.val){
					if(item.val-2 == -1){
						$scope.currScoreObj = $scope.noneEva;
					}else{
						$scope.currScoreObj = $scope.starsArr[item.val-2];
					}
				}else{
					$scope.currScoreObj = item;
					item.isSelect = !item.isSelect;
				}		
				
			}
			//console.log("currObj: ",$scope.currScoreObj);
		};

		//评价意见限制字数
		$scope.limitLength = function(){
			$scope.count = $("#evaContent").val().length;
		};

		//提交评价
		$scope.submitEva = function(){	//向后台发起请求提交评价，并结束沟通。本地沟通详细页插入评价对话框。
			//console.log("content: ",$scope.eva.content);
			//console.log("score board: ",$scope.currScoreObj);
			if($scope.currScoreObj.val == 0){
				$ionicPopup.alert({
					template: "<p >请选择评价星星的等级！</p>"
				});
			}else{
				CommunicationServices.evaluation($scope.communicateId, $scope.currScoreObj.val, $scope.eva.content, '2').then(function(res) {
					if(res.Flag == '1'){
						console.log('eva res: ',res);
						var data = {};
						data.communicateDate = res.evaluateDate;	//评价成功后后台返回的日期
						data.score = $scope.currScoreObj;
						// data.stars = [];
						// for(var num = 0; num < $scope.currScoreObj.val; num++){
						// 	data.stars.push(num);
						// }
						// console.log("star:",data.stars);
						data.content = $scope.eva.content;
						//提交成功发广播
						evaBroadcast('evaSuccess', data);
						$scope.evaFrameModal.hide();
					}else{
						$ionicPopup.alert({
							template: "<p >评价失败！</p>"
						});
						//evaBroadcast('evaFail', res.Result.errmsg);
					}
				});
			}
		};

		//下次再说btn
		$scope.nextTime = function(){	//不提交评价，但是结束沟通
			$scope.evaFrameModal.hide();
			$scope.modalShow = "3";
			$scope.explain = "您是否需要结束沟通？";
			$scope.ok = "是";
			$scope.no = "否";
			$scope.modal.show();
		};

		$scope.isBatch = function(param){
			$scope.modal.hide();			
			if(param == true){	//结束沟通，但不评价
				CommunicationServices.evaluation($scope.communicateId, '', '', '1').then(function(res) {
					if(res.Flag == '1'){
						console.log('eva res: ',res);
						evaBroadcast('nextSuccess', '');
					}else{
						//evaBroadcast('nextFail', res.Result.errmsg);
						$ionicPopup.alert({
							template: "<p >结束沟通失败！</p>"
						});
					}
				});
			}
		};

		$scope.$on('$destroy', function() {
			$scope.modal.remove();
			$scope.evaFrameModal.remove();
		});

		//是否提交成功-评论框广播
		function evaBroadcast(flag, data){	//(广播参数：'cancelSuccess'-撤销沟通成功，'evaSuccess'-提交成功, 'nextSuccess'-下次再说成功)
			$rootScope.$broadcast("evaluationFrameReceiver", flag, data);
		}
		
	}
]);