angular.module('PMPMobile.services').factory('CommunicationServices', ["$http", "Global", "$q",
		function($http, Global, $q) {
			var getPromise = function(p) {
				var defer = $q.defer();
				p.success(function(response) {
					return defer.resolve(response);
				}).error(function() {
					return defer.reject();
				});
				return defer.promise;
			};
			return {
				/*沟通列表*/
				getCommunicationList: function(obj){
					var url = Global.apiPath + '/pmp/supp/app/communicate/list.ht?BG='+ obj.bg + '&communicateType='+ obj.complaintType + '&submitDate='+ obj.submitDate + '&closeDate='+ obj.closeDate + '&complaintStatus='+ obj.comuStatus + '&page='+ obj.page + '&pageSize='+ obj.pageSize ;
					return getPromise($http.get(url));
				},
				/*沟通详细页*/
				getCommunicationDetail: function(obj,id){
					var url = Global.apiPath + '/pmp/supp/app/communicate/getCommunication.ht';
					var data = 'page='+obj.page + '&pageSize=' + obj.pageSize + '&communicateId='+ id;
					return getPromise($http.post(url, data));
				},
				/*沟通详细页-发送*/
				sentCommunicationDetail: function(id,content){
					var url = Global.apiPath + '/pmp/supp/app/communicate/insertCommunitionDetail.ht';
					var data = 'communicateId=' + id + '&communicateContent=' + content;
					return getPromise($http.post(url, data));
				},
				/*撤销沟通*/
				cancelCommunicationDetail: function(id){
					var url = Global.apiPath + '/pmp/supp/app/communicate/cancel.ht';
					var data = 'communicateId=' + id;
					return getPromise($http.post(url, data));
				},
				/*获得筛选条件*/
				getSelectItem:function(){
					var url = Global.apiPath + '/pmp/supp/app/communicate/conditionCheck.ht';
					return getPromise($http.get(url));
				},
				//发起沟通
				createCommunication:function(obj){
					var url = Global.apiPath + '/pmp/supp/app/communicate/insertCommunition.ht';
					return getPromise($http.post(url, obj));
				},
				/*评价*/
				evaluation: function(id, grade, evaluate, evaFrameType){
					var url = Global.apiPath + '/pmp/supp/app/communicate/evaluate.ht';
					var data = 'communicateId=' + id + '&communicateGrade=' + grade + '&evaluate=' + evaluate + '&next=' + evaFrameType;
					return getPromise($http.post(url, data));
				}
			};
		}
	]);