var isExit = false;
var PMPMobileApp = angular.module('PMPMobile', [
	'ionic',
	'PMPMobile.common',
	'PMPMobile.controller',
	'PMPMobile.directive',
	'PMPMobile.services',
	'PMPMobile.filters',
	'PMPMobile.global'
]);
angular.module("PMPMobile.common", []);
angular.module("PMPMobile.controller", []);
angular.module("PMPMobile.directive", []);
angular.module("PMPMobile.services", []);
angular.module("PMPMobile.filters", []);
angular.module("PMPMobile.global", []);


PMPMobileApp.config(function($compileProvider) {
	$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|tel):/);
}).config(function($httpProvider) {
	$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
});


PMPMobileApp.config(['$stateProvider', '$urlRouterProvider',
	function($stateProvider, $urlRouterProvider) {
		$stateProvider
			.state('Evaluation', {
				url: '/evaluation',
				templateUrl: 'views/evaluation/evaluation/evaluation-list.html',
				controller: 'EvaluationController'
			})
			.state('EvaluationDetail', {
				url: '/evaluationDetail',
				templateUrl: 'views/evaluation/evaluation/evaluation-detail.html',
				controller: 'EvaluationDetailController'
			})
			.state('EvaluationProblemFeedback', {
				url: '/evaluationProblemFeedback/:guid/:agreeGroupNo',
				templateUrl: 'views/evaluation/evaluation/evaluation-problem-feedback.html',
				controller: 'EvaluationProblemFeedbackController'
			})
			.state('BulkConfirmedEvaluation', {
				url: '/bulkConfirmedEvaluation',
				templateUrl: 'views/evaluation/evaluation/bulk-confirmed-evaluation.html',
				controller: 'BulkConfirmedEvaluationController'
			})
		$urlRouterProvider.otherwise('/evaluation');
	}
]);

function toggleSuccess() {
	console.log('toggle callback ok');
}

function toggleError(errMsg) {
	console.log(errMsg);
}
PMPMobileApp.run(["GlobalInterceptorHandler", "$rootScope", '$ionicPlatform', '$location', '$timeout',
	function(GlobalInterceptorHandler, $rootScope, $ionicPlatform, $location, $timeout) {
		GlobalInterceptorHandler.registerResponseHandling($rootScope);
		$ionicPlatform.registerBackButtonAction(function(e) {
			console.log("监听到返回键");
			console.log("当前地址", $location.path());
			/*先捕获异常，禁止使用ionic中自带的处理机制，根据不同的页面的后缀，进行不同的页面的跳转处理*/
			e.preventDefault();
			//如果是考核模块首页 按返回键回到平台
			if ($location.path() == "/evaluation") {
				var exec = cordova.require("cordova/exec");
				exec(toggleSuccess, toggleError, 'TogglePlugin', 'toggle', [-3]);

			}else {
				//其他状态自行按历史返回
				$rootScope.$viewHistory.backView.go();
			}
			return false;
		}, 101);
	}
]);