angular.module('PMPMobile.controller').controller('BulkConfirmedEvaluationController', ['$rootScope', "$scope", '$ionicModal', '$ionicPopup', '$ionicScrollDelegate', '$timeout', 'EvaluationApiServices', '$location',
	function($rootScope, $scope, $ionicModal, $ionicPopup, $ionicScrollDelegate, $timeout, EvaluationApiServices, $location) {
		init();

		function init() {
			$scope.title = "批量审批";
			$scope.isFirstIn = true;
			$scope.noMoreItemsAvailable = true;
			$scope.timer = '';
			$scope.supplier = JSON.parse(window.localStorage.getItem("supplier"));
			initDataFun();
		}
		$scope.$on("bulk-confirmed-evaluation-timeReceiver", function(event, data) {
			console.log(data.data);
			if (data.data == '全部时间') {
				$scope.timer = '';
			} else {
				$scope.timer = data.data.replace("-", "");
			}
			initDataFun();
		});
		
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.openModalSubmit = function() {
			$scope.modal.show();
		};
		$scope.closeModal = function() {
			$scope.modal.hide();
		};
		$scope.openModal = function() {
			$scope.modalShow = "0";
			$scope.openModalSubmit();
		};
		
		function initDataFun(type) {
			$scope.bulkConfirmedEvaluationData = [];
			$scope.selectData = [];
			initPager($scope);
			getDataList(type);
		}

		function getDataList(type) {
			EvaluationApiServices.getBulkEvaluationList($scope.supplier.lifnr, $scope.timer, $scope.pageObj.pageSize, $scope.pageObj.page).then(function(res) {
				console.log(res);
				if (res.Flag == "1") {
					for (var i = 0; i < res.Result.length; i++) {
						res.Result[i].status = res.Result[i].show.status;
						res.Result[i].caseScore = res.Result[i].show.caseScore;
						delete res.Result[i].show.status;
						delete res.Result[i].show.caseScore;
						res.Result[i].showItems = objtoarray(res.Result[i].show);
						$scope.bulkConfirmedEvaluationData.push(res.Result[i]);
					}
					$scope.noMoreItemsAvailable = res.totalCount == $scope.bulkConfirmedEvaluationData.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					refreshData(type, res.Result.length);
				}
			});
		}

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}

		/*下拉刷新*/
		$scope.onRefresh = function() {
			initDataFun("refresh");
		};

		/*上拉加载更多*/
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) {
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) {
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.pageObj.page++;
				getDataList("loadMore");
			}
		};

		$scope.changeStatus = function(item) {
			item.isSelect = !item.isSelect;
			if (item.isSelect) {
				$scope.selectData.push(item);
			} else {
				for (var i = 0; i < $scope.selectData.length; i++) {
					if (item.hide.guid == $scope.selectData[i].hide.guid) {
						$scope.selectData.splice(i, 1);
					}
				}
			}
		}

		$scope.selectAll = function() {
			$scope.selectData = [];
			for (var i = 0; i < $scope.bulkConfirmedEvaluationData.length; i++) {
				$scope.bulkConfirmedEvaluationData[i].isSelect = true;
				$scope.selectData.push($scope.bulkConfirmedEvaluationData[i]);
			}
		}

		$scope.clearAll = function() {
			$scope.selectData = [];
			for (var i = 0; i < $scope.bulkConfirmedEvaluationData.length; i++) {
				$scope.bulkConfirmedEvaluationData[i].isSelect = false;
			}
		}

		$scope.approvalSubmit = function() {
			console.log($scope.selectData);
			var selectId = [];
			for (var i = 0; i < $scope.selectData.length; i++) {
				selectId.push($scope.selectData[i].hide.guid);
			}
			if (selectId.length > 0) {
				var idStr = selectId.join(",");
				idStr = "ids=" + idStr;
				console.log(idStr);
				EvaluationApiServices.returnTobeconfirmedEvaluationIds(idStr).then(function(res) {
					for (var i = $scope.bulkConfirmedEvaluationData.length - 1; i >= 0; i--) {
						if ($scope.bulkConfirmedEvaluationData[i].isSelect) {
							$scope.bulkConfirmedEvaluationData.splice(i, 1);
						}
					}
					$scope.selectData = [];
					$scope.openModal();
					$timeout(function(){
						$scope.closeModal();
						$location.path('/evaluation');
					},700);
					
				});
			} else {
				$ionicPopup.alert({
					title: "<p  class='network-error'>请至少选择一条！</p>"
				});
			}

		}

	}
]);