angular.module('PMPMobile.controller').controller('EvaluationDetailController', ['$rootScope', "$scope", "$stateParams", "$location", '$ionicModal', '$ionicScrollDelegate', '$ionicPopup', '$timeout', 'DetailDisposeServices', 'EvaluationApiServices',
	function($rootScope, $scope, $stateParams, $location, $ionicModal, $ionicScrollDelegate, $ionicPopup, $timeout, DetailDisposeServices, EvaluationApiServices) {

		$scope.title = "考核详情";
		$scope.supplier = JSON.parse(window.localStorage.getItem("supplier"));
		$scope.evaluationListItem = DetailDisposeServices.getEvaluationListItem();
		$scope.tobeconfirmed = $scope.evaluationListItem.status == "待确认" ? true : false;

		function initData() {
			switch ($scope.evaluationListItem.status) {
				case "待确认":
					$scope.evaluationStatusClass = "to-be-confirmed";
					break;
				case "待发送":
					$scope.evaluationStatusClass = "pending";
					break;
				case "有异议	":
					$scope.evaluationStatusClass = "objection";
					break;
				case "问题确认有误":
					$scope.evaluationStatusClass = "confirmed-mistake";
					break;
				case "审批中":
					$scope.evaluationStatusClass = "pending";
					break;
				case "归档":
					$scope.evaluationStatusClass = "archive";
					break;
				case "撤回":
					$scope.evaluationStatusClass = "withdraw";
					break;
				case "驳回":
					$scope.evaluationStatusClass = "reject";
					break;
				case "ECP确认有误":
					$scope.evaluationStatusClass = "ecp-confirmed-mistake";
					break;
				default:
					$scope.evaluationStatusClass = "to-be-confirmed";
					break;
			}
			$scope.items = [];
			EvaluationApiServices.getEvaluationDetailByAgreeGroupNo($scope.evaluationListItem.show.agreeGroupNo,$scope.evaluationListItem.show.examineDate).then(function(res) {
				console.log(res);
				if (res.Flag == "1") {
					for (var j = 0; j < res.Result.length; j++) {
						var item = {};
						item.targetType = res.Result[j].typeName;
						if(Number(res.Result[j].typeWeight) > 0){
							item.targetWeight = res.Result[j].typeWeight;
						}else{
							item.targetWeight = "-";
						}
						item.targetTypeScore = res.Result[j].typeScore;
						item.showText = "展开";
						item.data = [];
						item.index = j;
						var detailQuotaWeight = "";
						for (var i = 0; i < res.Result[j].showDetail.length; i++) {
							if(Number(res.Result[j].showDetail[i].quotaWeight) == 0){
								detailQuotaWeight = "-";
							}else{
								detailQuotaWeight = res.Result[j].showDetail[i].quotaWeight;
							}
							item.data.push({
								"EVALUATION_NAME": res.Result[j].showDetail[i].quotaName,
								"EVALUATION_WEIGHT": detailQuotaWeight,
								"TARGET_SCORE": res.Result[j].showDetail[i].quotaScore
							});
						}
						$scope.items.push(item);
					}
				}
			});

		}
		initData();

		function searchUpdate(item) {
			$.fn.bsgrid.init('evaluationDetailTable' + item.index, {
				localData: item.data,
				stripeRows: true,
				pageSizeSelect: true,
				pageAll: true,
				rowSelectedColor: false,
				isProcessLockScreen: false,
				displayPagingToolbarOnlyMultiPages: true
			});
			setTimeout(function() {
				$ionicScrollDelegate.resize();
			}, 50);
		};
		$scope.openShow2 = function(item) {
			if (item.showText == "展开") {
				item.showText = "收起";
			} else {
				item.showText = "展开";
			}
			$("#evaluationTable" + item.index).toggle();
			$("#evaluationTriangle" + item.index).toggle();
			searchUpdate(item);
		}

		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});

		$ionicModal.fromTemplateUrl('views/evaluation/evaluation/evaluation-problem.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modalp = modal;
		});
		$scope.closeModal = function() {
			$scope.modalp.hide();
		}
		$scope.confirmed = function() {
			$scope.modalShow = "2";
			$scope.deleteAlert = "你是否需要确认考核？";
			$scope.modal.show();
		}
		$scope.questionFeedback = function() {
			console.log("问题反馈");
			$location.path('/evaluationProblemFeedback/' + $scope.evaluationListItem.hide.guid + "/" + $scope.evaluationListItem.show.agreeGroupNo);
		}

		$scope.examineProblem = function() {
			$scope.modalp.show();
		}

		$scope.deleteInvoice = function() {
			var idStr = "ids=" + $scope.evaluationListItem.hide.guid;
			EvaluationApiServices.returnTobeconfirmedEvaluationIds(idStr).then(function(res) {
				if (res.Flag == '1') {
					$scope.modalShow = "0";
					setTimeout(function() {
						$scope.modal.hide();
						$location.path("/evaluation");
					}, 700);
				}
			});

		}
		$scope.cancelInvoice = function() {
			$scope.modal.hide();
		}
	}
]);