angular.module('PMPMobile.controller').controller('EvaluationController', ['$rootScope', "$scope", "$stateParams", "$location", '$ionicModal', '$ionicScrollDelegate', '$ionicPopup', '$timeout', 'EvaluationApiServices',
	function($rootScope, $scope, $stateParams, $location, $ionicModal, $ionicScrollDelegate, $ionicPopup, $timeout, EvaluationApiServices) {
		$scope.backLogin = function() {
			var exec = cordova.require("cordova/exec");
				exec(callbackok,callbackerr,'TogglePlugin', 'toggle', [3]);
		};
		function callbackok(){
			console.log('callback ok');
		}
		function callbackerr(result) {
			console.log("error!");
		}
		$scope.tabs = [{
			title: '待确认考核'
		}, {
			title: '历史考核'
		}];
//		$scope.supplier = JSON.parse(window.localStorage.getItem("supplier"));
		$scope.isShow = true;
		$scope.currentTab = '待确认考核';
		$ionicScrollDelegate.scrollTop(false);
		$scope.onClickTab = function(tab) {
			$ionicScrollDelegate.scrollTop(false);
			if ($scope.currentTab != tab.title) {
				$scope.currentTab = tab.title;
				$scope.isShow = !$scope.isShow;
			}
			init();
		}
		$scope.isActiveTab = function(tabTitle) {
			return tabTitle == $scope.currentTab;
		}

		/*获取登录信息回调函数*/
		function supplierSuccess(str){
			setLocalStorage(str);	// 存入缓存
			$scope.supplier = JSON.parse(window.localStorage.getItem("supplier"));
			if ($scope.isShow) {
				//待确认考核
				$scope.tobeconfirmedTimer = '';
				$scope.tobeconfirmedEvaluationData = [];
				initPager($scope);
				getTobeconfirmedEvaluationDataList();
			} else {
				//历史考核
				$scope.historyTimer = '';
				$scope.historyEvaluationData = [];
				initPager($scope);
				getHistoryEvaluationDataList();
			}
			
		}
		/*获取登录信息回调函数*/
		function supplierError(errMsg){
			console.log(errMsg);
		}
		
		init();
		function init() {
			/*从插件获取登录信息*/
			var exec = cordova.require("cordova/exec");
			exec(supplierSuccess, supplierError, 'SupplierPlugin', 'supplier', []);
			
			$scope.isFirstIn = true;
			$scope.noMoreItemsAvailable = true;
			/*if ($scope.isShow) {
				//待确认考核
				$scope.tobeconfirmedTimer = '';
				$scope.tobeconfirmedEvaluationData = [];
				initPager($scope);
				getTobeconfirmedEvaluationDataList();
			} else {
				//历史考核
				$scope.historyTimer = '';
				$scope.historyEvaluationData = [];
				initPager($scope);
				getHistoryEvaluationDataList();
			}*/
		}

		$scope.$on("tobeconfirm-evaluation-timeReceiver", function(event, data) {
			console.log(data.data);
			if (data.data == '全部考核时间') {
				$scope.tobeconfirmedTimer = '';
			} else {
				$scope.tobeconfirmedTimer = data.data.replace("-", "");
				console.log($scope.tobeconfirmedTimer);
			}
			$scope.tobeconfirmedEvaluationData = [];
			initPager($scope);
			getTobeconfirmedEvaluationDataList();
			$ionicScrollDelegate.scrollTop(false);
		});
		$scope.$on("history-evaluation-timeReceiver", function(event, data) {
			console.log(data.data);
			if (data.data == '全部考核时间') {
				$scope.historyTimer = '';
			} else {
				$scope.historyTimer = data.data.replace("-", "");
			}
			$scope.historyEvaluationData = [];
			initPager($scope);
			getHistoryEvaluationDataList();
		});
        //待确认考核
		function getTobeconfirmedEvaluationDataList(type) {
			EvaluationApiServices.getTobeconfirmedEvaluationList($scope.supplier.lifnr,$scope.tobeconfirmedTimer, $scope.pageObj.pageSize, $scope.pageObj.page).then(function(res){
				console.log(res);
				if(res.Flag == "1"){//请求成功
					$scope.tobeconfirmedEvaluationData = $scope.tobeconfirmedEvaluationData.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.tobeconfirmedEvaluationData.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					refreshData(type, res.Result.length);
				}else{
					$ionicPopup.alert({
						template: "<p >" + "提示信息" + "</p>"
					});
				}
			});
		}

		function getHistoryEvaluationDataList(type) {
			EvaluationApiServices.getHistoryEvaluationList($scope.supplier.lifnr, $scope.historyTimer, $scope.pageObj.pageSize, $scope.pageObj.page).then(function(res){
				console.log(res);
				if(res.Flag == '1'){
					$scope.historyEvaluationData = $scope.historyEvaluationData.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.historyEvaluationData.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					refreshData(type, res.Result.length);
				}else{
					$ionicPopup.alert({
						template: "<p >" + "提示信息" + "</p>"
					});
				}
			});
		}

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}

		/*下拉刷新*/
		$scope.onRefresh = function() {
			if ($scope.isShow) {
				//待确认考核
				$scope.tobeconfirmedEvaluationData = [];
				initPager($scope);
				getTobeconfirmedEvaluationDataList("refresh");
			} else {
				//历史考核
				$scope.historyEvaluationData = [];
				initPager($scope);
				getHistoryEvaluationDataList("refresh");
			}
		};

		/*上拉加载更多*/
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) {
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) {
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.pageObj.page++;
				if ($scope.isShow) {
					getTobeconfirmedEvaluationDataList("loadMore");
				} else {
					getHistoryEvaluationDataList("loadMore");
				}
			}
		};
		
		$scope.bulkClick = function() {
			$location.path("/bulkConfirmedEvaluation");
		};
		
	}
]);