angular.module('PMPMobile.services').factory('EvaluationApiServices', ["$http", "Global", "$q",
	function($http, Global, $q) {
		var getPromise = function(p) {
			var defer = $q.defer();
			p.success(function(response) {
				return defer.resolve(response);
			}).error(function() {
				return defer.reject();
			});
			return defer.promise;
		};
		return {
			//待确认考核列表
			getTobeconfirmedEvaluationList: function(supplierCode, examineDate,pageSize,showPage) {
				var url = Global.apiPath + '/pmp/supp/app/examine/queryExamine.ht?examineDate='+examineDate+'&pageSize='+pageSize+'&page='+showPage;
				return getPromise($http.get(url));
			},
			//历史考核列表
			getHistoryEvaluationList: function(supplierCode, examineDate,pageSize,showPage) {
				var url = Global.apiPath + '/pmp/supp/app/examine/historyExamine.ht?examineDate='+examineDate+'&pageSize='+pageSize+'&page='+showPage;
				return getPromise($http.get(url));
			},
			//批量审批考核列表
			getBulkEvaluationList: function(supplierCode, examineDate, pageSize, showPage) {
				var url = Global.apiPath + '/pmp/supp/app/examine/getWaitExamine.ht?examineDate='+examineDate+'&pageSize='+pageSize+'&page='+showPage;
				return getPromise($http.get(url));
			},
			getEvaluationDetailByAgreeGroupNo: function(agreeGroupNo,examineDate){
				var url = Global.apiPath + '/pmp/supp/app/examine/detail.ht?agreeGroupNo='+agreeGroupNo+'&examineDate='+examineDate;
				return getPromise($http.get(url));
			},
			//确认审核
			returnTobeconfirmedEvaluationIds:function(ids){
				var url = Global.apiPath + '/pmp/supp/app/examine/reviewExamine.ht';
				return getPromise($http.post(url, ids));
			},
			//问题反馈
			feedbackDetail:function(detail){
				var url = Global.apiPath + '/pmp/supp/app/examine/examineProblem.ht';
				return getPromise($http.post(url, detail));
			}
		};
	}
]);