var isExit = false;
var PMPMobileApp = angular.module('PMPMobile', [
	'ionic',
	'PMPMobile.common',
	'PMPMobile.controller',
	'PMPMobile.directive',
	'PMPMobile.services',
	'PMPMobile.filters',
	'PMPMobile.global'
]);
angular.module("PMPMobile.common", []);
angular.module("PMPMobile.controller", []);
angular.module("PMPMobile.directive", []);
angular.module("PMPMobile.services", []);
angular.module("PMPMobile.filters", []);
angular.module("PMPMobile.global", []);


PMPMobileApp.config(function($compileProvider) {
	$compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|tel):/);
}).config(function($httpProvider) {
	$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
});


PMPMobileApp.config(['$stateProvider', '$urlRouterProvider',
	function($stateProvider, $urlRouterProvider) {
		$stateProvider
			.state('Assets', {
				url: '/assets',
				templateUrl: 'views/property/assets/assets-list.html',
				controller: 'AssetsListController'
			})
			.state('NewAssets', {
				url: '/newAssets/:type/:assetApplyId/:requestNote',
				templateUrl: 'views/property/assets/new-assets.html',
				controller: 'NewAssetsController'
			})
			.state('AssetsSearch', {
				url: '/assetsSearch',
				templateUrl: 'views/property/assets/assets-search.html',
				controller: 'AssetsSearchController'
			})
			.state('AssetsBatch', {
				url: '/assetsBatch',
				templateUrl: 'views/property/assets/assets-batch.html',
				controller: 'AssetsBatchController'
			})
			.state('Goods', {
				url: '/goods',
				templateUrl: 'views/property/goods/goods-list.html',
				controller: 'GoodsListController'
			})
			.state('GoodsBatch', {
				url: '/goodsBatch/:tabType',
				templateUrl: 'views/property/goods/goods-list-batch.html',
				controller: 'GoodsBatchController'
			})
			.state('GoodsSearch', {
				url: '/goodsSearch/:tabType',
				templateUrl: 'views/property/goods/goods-list-search.html',
				controller: 'GoodsSearchController'
			})
			.state('ReceiveConfirm', {
				url: '/receiveConfirm',
				templateUrl: 'views/property/goods/receive-confirm.html',
				controller: 'ReceiveConfirmController'
			})
			.state('GoodsChoose', {
				url: '/goodsChoose/:searchType',
				templateUrl: 'views/common/goods-choose.html',
				controller: 'GoodsChooseController'
			})
			.state('Materiels', {
				url: '/materiels',
				templateUrl: 'views/property/materiels/materiels-list.html',
				controller: 'MaterielsListController'
			})
			.state('MaterielsDetails', {
				url: '/materielsDetails/:type/:materielApplyId',
				templateUrl: 'views/property/materiels/materiels-details.html',
				controller: 'MaterielsDetailsController'
			})
			.state('MaterielsBatch', {
				url: '/materielsBatch',
				templateUrl: 'views/property/materiels/materiels-list-batch.html',
				controller: 'MaterielsBatchController'
			})
			.state('MaterielsSearch', {
				url: '/materielsSearch',
				templateUrl: 'views/property/materiels/materiels-list-search.html',
				controller: 'MaterielsSearchController'
			})
		$urlRouterProvider.otherwise('/assets');
	}
]);

function toggleSuccess() {
	console.log('toggle callback ok');
}

function toggleError(errMsg) {
	console.log(errMsg);
}
PMPMobileApp.run(["GlobalInterceptorHandler", "$rootScope", '$ionicPlatform', '$location', '$timeout',
	function(GlobalInterceptorHandler, $rootScope, $ionicPlatform, $location, $timeout) {
		GlobalInterceptorHandler.registerResponseHandling($rootScope);
		$ionicPlatform.registerBackButtonAction(function(e) {
			console.log("监听到返回键");
			console.log("当前地址", $location.path());
			/*先捕获异常，禁止使用ionic中自带的处理机制，根据不同的页面的后缀，进行不同的页面的跳转处理*/
			e.preventDefault();
			//如果是模块首页 按返回键回到平台
			if ($location.path() == "/assets"||$location.path() == "/goods"||$location.path() == "/materiels") {
				var exec = cordova.require("cordova/exec");
				exec(toggleSuccess, toggleError, 'TogglePlugin', 'toggle', [-3]);

			}else {
				//其他状态自行按历史返回
				$rootScope.$viewHistory.backView.go();
			}
			return false;
		}, 101);
	}
]);