angular.module('PMPMobile.controller').controller('AssetsBatchController', ['$rootScope', "$scope", '$ionicScrollDelegate', '$location','$timeout', '$ionicModal', '$ionicPlatform', 'FooterServices', 'AssetsApiServices',
	function($rootScope, $scope, $ionicScrollDelegate, $location, $timeout, $ionicModal, $ionicPlatform, FooterServices, AssetsApiServices) {
		FooterServices.hide();
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});

	    $scope.maMulSelArr = [];	//批量操作中保存所有选中的items的数组
		$scope.timeFilterOpt = [{name:"本周", val:"1"},{name:"两周内", val:"2"},{name:"三周内", val:"3"},{name:"四周内", val:"4"}];
		$scope.timeFilterOpt[0].isRadio = true;	//初始化timeFilterOption默认第一项为选中状态。
		$scope.timeFilter = $scope.timeFilterOpt[0];	//物料申请-批量-时间段筛选字段
		$scope.showTimeFilter = false;	//标识是否显示timefilter的下拉列表
		

		init();	
		getDataList();

		function init(){
			$scope.items = [];
			$scope.page = 1;
			$scope.pageSize = 8;
			$scope.noMoreItemsAvailable = true;
			$scope.isFirstIn = true;				
		}


		function getDataList(type) {
				//批量操作中数据只显示“未提交”状态的单，所以请求的时候要注意请求
			AssetsApiServices.getAssetsListBatch($scope.pageSize, $scope.page, $scope.timeFilter.val, "00", "").then(function(res) {	
				//var list = AssetsApiServices.getAssetsList();
				console.log("batch res: ",res);
				if(res.Flag == "1"){
					$scope.tmpItems = res.Result;
					for (var i = 0; i < $scope.tmpItems.length; i++) {
						$scope.tmpItems[i].showkey = objtoarray($scope.tmpItems[i].show);
					}
					$scope.items = $scope.items.concat($scope.tmpItems);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.items.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					refreshData(type, res.Result.length);
				}else{
					$scope.modalShow = "4";			
					$scope.remind = res.Result.errmsg;
					$scope.modal.show();
				}
			});
		}

		//上拉加载更多
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) {
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) {
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.page++;
				getDataList("loadMore");
			}
		};

		//下拉刷新
		$scope.onRefresh = function() {
			init();
			getDataList("refresh");
			$scope.maMulSelArr = [];
		};

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}
			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}

		/*list-batch*/
		//物料申请列表批量操作-全选
		$scope.listBatchSelAll = function(){
			$scope.maMulSelArr = [];
			for(selAllIndex in $scope.items){
				$scope.items[selAllIndex].isSelect = true;
				$scope.maMulSelArr.push($scope.items[selAllIndex]);
			}
			console.log("select all",$scope.maMulSelArr);
		};
		//物料申请列表批量操作-清空所选
		$scope.listBatchCancelSel = function(){
			for(cancelSel in $scope.maMulSelArr){
				for(cancelist in $scope.items){
					if($scope.maMulSelArr[cancelSel].show.requestNote == $scope.items[cancelist].show.requestNote){
						$scope.items[cancelist].isSelect = false;
						break;
					}
				}
			}
			$scope.maMulSelArr = [];
			console.log("cancel all",$scope.maMulSelArr);
		};
		//物料申请列表批量操作-删除所选
		var modalType = "";
		$scope.listBatchDel = function(){
			if($scope.maMulSelArr.length == 0){
				$scope.modalShow = "6";
				$scope.alertMsg = "您未选择任何选项";
				$scope.modal.show();
				$timeout(function() {
					$scope.modal.hide();
				}, 2000);
			}else{
				modalType = 'del';
				$scope.modalShow = "2";
				$scope.deleteAlert = "您是否删除这些申请？";
				$scope.modal.show();
			}
		};
		//物料申请列表批量操作-确定删除
		$scope.deleteInvoice = function(){
			$scope.modal.hide();
			if(modalType == 'del'){
				var delId = "";
				for(mulSelIndex in $scope.maMulSelArr){	//根据隐藏的申请id批量删除申请订单
					 delId = delId + $scope.maMulSelArr[mulSelIndex].hide.assetApplyId + ',';
				}
				delId = delId.slice(0,delId.length - 1);
				console.log("del id:",delId);
				AssetsApiServices.assetsDel("assetApplyId="+delId).then(function(res) {
					if(res.Flag == "1"){
						$scope.maMulSelArr = [];
						$scope.modalShow = "6";
						$scope.alertMsg = "删除成功";
						$scope.modal.show();
						$timeout(function() {
							$scope.modal.hide();
						}, 700);
						//批量删除成功后，根据上面筛选框的filter字段重新请求剩余数据
						$ionicScrollDelegate.scrollTop(false);
						init();
						getDataList();
					}else{
						$ionicScrollDelegate.scrollTop(false);
						init();
						getDataList();
						$scope.modalShow = "4";			
						$scope.remind = res.Result.errmsg;
						$scope.modal.show();
					}
				});
			}else if(modalType == 'submit'){
				var submitId = "";
				for(mulSelIndex in $scope.maMulSelArr){	//根据隐藏的申请id批量提交申请订单
					 submitId = submitId + $scope.maMulSelArr[mulSelIndex].hide.assetApplyId + ',';
				}
				submitId = submitId.slice(0,submitId.length - 1);
				console.log("submitId:",submitId);
				AssetsApiServices.assetsMultiSubmit("assetApplyId="+submitId).then(function(res) {
					if(res.Flag == "1"){
						$scope.maMulSelArr = [];
						$scope.modalShow = "6";
						$scope.alertMsg = "提交成功";
						$scope.modal.show();
						$timeout(function() {
							$scope.modal.hide();
						}, 700);
						//批量提交成功后，根据上面筛选框的filter字段重新请求剩余数据
						$ionicScrollDelegate.scrollTop(false);
						init();
						getDataList();
					}else{
						$ionicScrollDelegate.scrollTop(false);
						init();
						getDataList();
						$scope.modalShow = "4";			
						$scope.remind = res.Result.errmsg;
						$scope.modal.show();
					}
				});
			}
			
		};
		//物料申请列表批量操作-取消删除
		$scope.cancelInvoice = function(){
			$scope.modal.hide();
		}
		//modal-2-btn
		$scope.hide = function(){
			$scope.modal.hide();
		};
		//物料申请列表批量操作-提交所选
		$scope.listBatchSubmit = function(){
			console.log("now select : ",$scope.maMulSelArr);
			if($scope.maMulSelArr.length == 0){
				$scope.modalShow = "6";
				$scope.alertMsg = "您未选择任何选项";
				$scope.modal.show();
				$timeout(function() {
					$scope.modal.hide();
				}, 2000);
			}else{
				modalType = 'submit';
				$scope.modalShow = "2";
				$scope.deleteAlert = "您是否提交这些申请？";
				$scope.modal.show();
			}
		};
		//点击timeFilter的option事件
		$scope.timeFilOptClk = function(opt){
			if(opt.isRadio == undefined){	//若opt.isRadio之前没有被点过，则初始化为false。
				opt.isRadio = false;
			}
			for(o in $scope.timeFilterOpt){	//控制单选
				$scope.timeFilterOpt[o].isRadio = false;
			}
			opt.isRadio = true;
			$scope.timeFilter = opt;
			/* when timefilter changed
			 * to do here
			*/
			$ionicScrollDelegate.scrollTop(false);
			init();
			getDataList();
			$scope.showTimeFilter = false;
			console.log("you've select filter:",$scope.timeFilterOpt);
		};
		//timeFilter的toggle事件
		$scope.timeFilterToggle = function(){
			$scope.showTimeFilter = !$scope.showTimeFilter;
		};
		/*END list-batch*/

}]);