angular.module('PMPMobile.controller').controller('AssetsSearchController', ['$rootScope', "$scope", '$ionicScrollDelegate', '$timeout', '$location', 'FooterServices', 'AssetsApiServices',
	function($rootScope, $scope, $ionicScrollDelegate, $timeout, $location, FooterServices, AssetsApiServices) {
		FooterServices.hide();
		//初始化变量
		$scope.searchTypeDesc = "查找编号";
		$scope.data = {};
		$scope.data.keyWords = "";
		$scope.items = [];
		//是否是编号查找
		$scope.isNumber = false;
		//状态筛选
		$scope.statusSelector = getAssetsStatusSelector();
		$scope.TimeSelector = getAssetsTimeSelector();
		//默认状态
		$scope.statusSelectorVal = "";	//全部状态
		$scope.TimeSelectorVal = "1";	//本周
		
		initPager($scope);
		getAssetsArray("", $scope.statusSelectorVal, $scope.TimeSelectorVal);

		//获取数据
		function getAssetsArray(type, assetStatus, assetTimeStatus) {
			var data = "";
			if ($scope.isNumber) {
				data = "&requestNote=" + $scope.data.keyWords;
			} else {
				data = "&orderStatusNum=" + assetStatus + "&weekDate=" + assetTimeStatus;
			}
			AssetsApiServices.getAssetsList(data,$scope.pageObj).then(function(res) {
				console.log(res);
				if (res.Flag == "1") {
					$scope.tmpItems = res.Result;
					for (var i = 0; i < $scope.tmpItems.length; i++) {
						$scope.tmpItems[i].showkey = objtoarray($scope.tmpItems[i].show);
					}
					$scope.items = $scope.items.concat($scope.tmpItems);
					$scope.noMoreItemsAvailable = $scope.items.length == res.totalCount;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					if (type == "refresh") {
						if (res.Result.length > 0) {
							$scope.refresherData = "已经为您更新" + res.Result.length + "条数据";
							$(".refresher-data").show();
							$timeout(function() {
								$(".refresher-data").hide();
							}, 2000);
						}
					} else if (type == "loadMore") {
						if (res.Result.length > 0) {
							$scope.infiniteData = "已经为您加载" + res.Result.length + "条数据";
							$(".infinite-data").show();
							$timeout(function() {
								$(".infinite-data").hide();
							}, 2000);
						}
					}
					NoData(res.Result.length,"您当前选择的条件没有数据");
				} else {
					$scope.modalShow = "4";
					$scope.remind = res.Result.errmsg;
					$scope.modal.show();
				}

			});
		}

		//返回到上一页
		$scope.back = function() {
			$rootScope.$viewHistory.backView.go();
		};

		//改变搜索方式
		$scope.changeSearchType = function() {
			$scope.isNumber = !$scope.isNumber;
			if($scope.isNumber){
				$scope.searchTypeDesc = "条件查询";
				$scope.data.keyWords = "";
			}else{
				$scope.searchTypeDesc = "查找编号";
				//初始化回默认状态
				$scope.statusSelector = getAssetsStatusSelector();
				$scope.TimeSelector = getAssetsTimeSelector();
				$scope.statusSelectorVal = "";	//全部状态
				$scope.TimeSelectorVal = "1";	//本周				
				initPager($scope);
				getAssetsArray("", $scope.statusSelectorVal, $scope.TimeSelectorVal);
			}
		};

		//接收selector的值
		$scope.$on("assetstatusReceiver", function(event, data) {
			$scope.statusSelectorVal = data.data;
			$scope.items = [];
			initPager($scope);
			getAssetsArray("", $scope.statusSelectorVal, $scope.TimeSelectorVal);
		});
		$scope.$on("assetTimestatusReceiver", function(event, data) {
			$scope.TimeSelectorVal = data.data;
			$scope.items = [];
			initPager($scope);
			getAssetsArray("", $scope.statusSelectorVal, $scope.TimeSelectorVal);
		});

		//确定搜索
		$scope.search = function() {
			$scope.items = [];
			initPager($scope);
			getAssetsArray("", "", "");
		};

		/*上拉刷新*/
		$scope.onRefresh = function() {
			initPager($scope);
			$scope.items = [];
			getAssetsArray("refresh", $scope.statusSelectorVal, $scope.TimeSelectorVal);
		};

		/*下拉加载更多*/
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) {
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) {
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');

				return;
			} else {
				$scope.isFirstIn = true;
				$scope.pageObj.page++;
				getAssetsArray("loadMore", $scope.statusSelectorVal, $scope.TimeSelectorVal);
			}
		};
	}
]);