angular.module('PMPMobile.controller').controller('NewAssetsController', ['$rootScope', "$scope", '$ionicScrollDelegate', '$ionicListDelegate', '$ionicPopup', '$stateParams', '$ionicModal', '$location', 'FooterServices', 'AssetsApiServices',
	function($rootScope, $scope, $ionicScrollDelegate, $ionicListDelegate, $ionicPopup, $stateParams, $ionicModal, $location, FooterServices, AssetsApiServices) {
		FooterServices.hide();
		$scope.data = {};

		//计算资产总录入数
		$scope.calTotal = function() {
			var total = 0;
			for (var i = 0; i < $scope.data.assetsArray.length; i++) {
				total = parseInt(total) + parseInt($scope.data.assetsArray[i].requestAmount);
			}
			if (parseInt(total) > 0) {
				$scope.data.total = "总计:" + total;
				$scope.newAssetTotalClass = "new-asset-total";
			} else {
				$scope.data.total = "资产总量不可为0";
				$scope.newAssetTotalClass = "new-asset-total-zero";
			}
		};

		//初始化数据
		function init() {
			$scope.assets = {};
			$scope.assets.remarks = "";
			$("#assetsReasonTextArea").bind("click", showNum)
				.bind("keyup", showNum);
			$scope.isShowBatchDelete = false;
			$scope.data = {
				"networkCode": "",
				"networkName": "",
				"remarks": "",
				"total": "资产总量不可为0",
				"assetsArray": [],
				"status": "",
				"applyDate": "",
				"applyNo": "",
				"submitDate": "",
				"orgid": "",
				"assetApplyId": ""
			};
			$scope.calTotal();
		};

		//初始化编辑数据
		function getEditData() {
			var data = "assetApplyId=" + $stateParams.assetApplyId;
			AssetsApiServices.getEditData(data).then(function(res) {
				console.log(res);
				if (res.Flag == "1") {
					var show = res.Result.show;
					var hide = res.Result.hide;
					$scope.data.networkCode = show.networkCode;
					$scope.data.networkName = show.networkName;
					$scope.data.remarks = show.remarks == null ? "" : show.remarks;
					for (var i = 0; i < show.propertyInfo.length; i++) {
						var property = {};
						property.show = {};
						property.hide = {};
						property.show.wareId = show.propertyInfo[i].materielNo;
						property.show.wareName = show.propertyInfo[i].materielName;
						property.show.wareType = show.propertyInfo[i].typeName;
						property.requestAmount = show.propertyInfo[i].requestAmount;
						property.hide.assetDetailId = show.propertyInfo[i].assetDetailId;
						$scope.data.assetsArray.push(property);
					}
					$scope.data.status = show.orderStatus;
					$scope.data.applyDate = show.requestDate;
					$scope.data.applyNo = $stateParams.requestNote;
					$scope.data.orgid = show.orgId;
					$scope.data.submitDate = show.sendDate == null ? "" : show.sendDate;
					$scope.data.assetApplyId = hide.assetApplyId;
					$scope.calTotal();
					showNum();
				} else {
					$ionicPopup.alert({
						template: "<p >" + res.Result.errmsg + "</p>"
					});
				}
			});
		};

		//判断是新建还是编辑
		console.log($stateParams);
		if ($stateParams.type == "add") {
			$scope.title = "新建申请";
			init();
		} else if ($stateParams.type == "edit") {
			$scope.title = "编辑资产";
			$scope.isEdit = true;
			init();
			getEditData();
		} else {
			$scope.title = "资产详情";
			$scope.isDetail = true;
			init();
			getEditData();
		}

		//模态对话框窗口初始化
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.openModal = function() {
			$scope.modal.show();
		};
		$scope.closeModal = function() {
			$scope.modal.hide();
		};

		//判断字数
		function showNum() {
			var num = $scope.data.remarks.length;
			$("#reason-limit").html(num);
		};

		// 显示/关闭批量删除
		$scope.showBatchDelete = function() {
			$scope.isShowBatchDelete = !$scope.isShowBatchDelete;
			if ($scope.isShowBatchDelete) {
				$scope.newAssetsItemDiv = "new-assets-item-div";
			} else {
				$scope.newAssetsItemDiv = "";
			}
		};

		//减一
		$scope.minus = function(item) {
			if (!(parseInt(item.requestAmount) - 1 < 0)) {
				item.requestAmount = parseInt(item.requestAmount) - 1;
				$scope.calTotal();
			}
		};

		//加一
		$scope.add = function(item) {
			item.requestAmount = parseInt(item.requestAmount) + 1;
			$scope.calTotal();
		};

		//侧滑删除一条资产
		$scope.deleteAssetsLocal = function(index) {
			$scope.data.assetsArray.splice(index, 1);
			$scope.calTotal();
		};

		$scope.applyNumValid = function(){
			for(assInx in $scope.data.assetsArray){
				if(parseInt($scope.data.assetsArray[assInx].requestAmount) <= 0){
					return false;
				}				
			}
			return true;			
		}

		//保存资产申请
		$scope.saveAssets = function() {
			if ($scope.data.networkCode == "") {
				$ionicPopup.alert({
					template: "<p >请选择网点！</p>"
				});
			} else if ($scope.data.assetsArray.length == 0) {
				$ionicPopup.alert({
					template: "<p >资产总量不能为0！</p>"
				});
			} else if(!$scope.applyNumValid()){
				$ionicPopup.alert({
					template: "<p >申请数量不能为0！</p>"
				});
			} else {
				$scope.modalShow = "5";
				$scope.explain = "是否保存申请";
				$scope.ok = "保存";
				$scope.no = "取消";
				$scope.modalType = "save";
				$scope.openModal();
			}

		};

		//提交资产申请
		$scope.submit = function() {
			if ($scope.data.networkCode == "") {
				$ionicPopup.alert({
					template: "<p >请选择网点！</p>"
				});
			} else if ($scope.data.assetsArray.length == 0) {
				$ionicPopup.alert({
					template: "<p >请添加物料！</p>"
				});
			} else if(!$scope.applyNumValid()){
				$ionicPopup.alert({
					template: "<p >申请数量不能为0！</p>"
				});
			} else {
				$scope.modalShow = "5";
				$scope.explain = "是否提交申请";
				$scope.ok = "提交";
				$scope.no = "取消";
				$scope.modalType = "submit";
				$scope.openModal();
			}

		};

		//删除申请
		$scope.deleteAssets = function() {
			$scope.modalShow = "5";
			$scope.explain = "是否删除申请";
			$scope.ok = "删除";
			$scope.no = "取消";
			$scope.modalType = "deleteAssets";
			$scope.openModal();
		}

		//点击多选框checkBox事件
		$scope.changeStatus = function(item) {
			if (typeof(item.isSelect) == "undefined" || !item.isSelect) {
				item.isSelect = true;
			} else {
				item.isSelect = false;
			}
		};

		//递归批量删除
		function deleteAssetsArray(i) {
			if (!(typeof($scope.data.assetsArray[i]) == "undefined") && $scope.data.assetsArray[i].isSelect) {
				$scope.data.assetsArray.splice(i, 1);
				deleteAssetsArray(i);
			}
		}

		//拼json
		function getSubmitJson(flag) {
			var data = {};
			data.networkCode = $scope.data.networkCode;
			data.networkName = $scope.data.networkName;
			data.remarks = $scope.data.remarks;
			data.assetFlag = $stateParams.type == "edit" ? "3" : flag;
			if ($stateParams.type == "edit") {
				data.assetApplyId = $scope.data.assetApplyId;
			}
			data.orgid = $scope.data.orgid;
			data.propertyInfo = [];
			for (var i = 0; i < $scope.data.assetsArray.length; i++) {
				data.propertyInfo.push({
					"materielNo": $scope.data.assetsArray[i].show.wareId,
					"materielName": $scope.data.assetsArray[i].show.wareName,
					"requestAmount": $scope.data.assetsArray[i].requestAmount,
					"assetDetailId": $scope.data.assetsArray[i].hide.assetDetailId
				});
			}
			return data;
		}

		function saveAssetsSubmit(flag) {
			var data = "assetApply=" + JSON.stringify(getSubmitJson(flag));
			AssetsApiServices.submitAssetsAplly(data).then(function(res) {
				console.log(res);
				if (res.Flag == "1") {
					$scope.modalShow = "6";
					$scope.alertMsg = flag == 1 ? "保存成功" : "提交成功";
					$scope.openModal();
					window.setTimeout(function() {
						$scope.closeModal();
						$location.path('/assets');
					}, 1000);
				} else {
					$ionicPopup.alert({
						template: "<p >" + res.Result.errmsg + "</p>"
					});
				}

			});
		}

		//模态对话框点击确定或者取消
		$scope.isRevoke = function(isTrue) {
			if (!isTrue) {
				$scope.closeModal();
				if ($scope.ok == "是") {
					$location.path('/assets');
				}
			} else if ($scope.modalType == "deleteAssetsArray") {
				for (var i = 0; i < $scope.data.assetsArray.length; i++) {
					if ($scope.data.assetsArray[i].isSelect) {
						deleteAssetsArray(i);
					}
				}
				$scope.calTotal();
				$scope.closeModal();
			} else if ($scope.modalType == "save") {
				if ($scope.explain = "退出前是否需要保存") {
					if ($scope.data.networkCode == "") {
						$scope.closeModal();
						$ionicPopup.alert({
							template: "<p >请选择网点！</p>"
						});
					} else if ($scope.data.assetsArray.length == 0) {
						$scope.closeModal();
						$ionicPopup.alert({
							template: "<p >请添加物料！</p>"
						});
					} else if(!$scope.applyNumValid()){
						$scope.closeModal();
						$ionicPopup.alert({
							template: "<p >申请数量不能为0！</p>"
						});
					} else {
						saveAssetsSubmit(1);
					}
				} else {
					saveAssetsSubmit(1);
				}
			} else if ($scope.modalType == "submit") {
				saveAssetsSubmit(2);
			} else if ($scope.modalType == "deleteAssets") {
				AssetsApiServices.assetsDel("assetApplyId=" + $scope.data.assetApplyId).then(function(res) {
					if (res.Flag == "1") {
						$scope.modalShow = "6";
						$scope.alertMsg = "删除成功";
						$scope.openModal();
						window.setTimeout(function() {
							$scope.closeModal();
							$location.path('/assets');
						}, 1000);
					} else {
						$ionicPopup.alert({
							template: "<p >" + res.Result.errmsg + "</p>"
						});
					}
				});
			}
		};

		//删除所选
		$scope.deleteSelect = function() {
			$scope.modalShow = "5";
			$scope.explain = "是否删除所选";
			$scope.ok = "删除";
			$scope.no = "取消";
			$scope.modalType = "deleteAssetsArray";
			$scope.openModal();
		};

		//全选或者取消全选
		$scope.selectAll = function(bool) {
			for (var i = 0; i < $scope.data.assetsArray.length; i++) {
				$scope.data.assetsArray[i].isSelect = bool;
			}
		};

		//返回退出
		$scope.backToAssets = function() {
			if ($stateParams.type == "add") {
				$scope.modalShow = "5";
				$scope.explain = "退出前是否需要保存";
				$scope.ok = "是";
				$scope.no = "否";
				$scope.modalType = "save";
				$scope.openModal();
			} else {
				$location.path('/assets');
			}
		};

		function isExistInAssetsArray(assetDetailId) {
			var isIsExist = false;
			for (var i = 0; i < $scope.data.assetsArray.length; i++) {
				console.log($scope.data.assetsArray[i].hide.assetDetailId);
				console.log(assetDetailId);
				if ($scope.data.assetsArray[i].hide.assetDetailId == assetDetailId) {
					isIsExist = true;
					break;
				}
			}
			return isIsExist;
		}

		//接收网点选择
		$scope.$on("netWorkReceiver", function(event, data) {
			$scope.data.networkCode = data.show.networkCode;
			$scope.data.networkName = data.show.networkName;
			$scope.data.orgid = data.hide.networkId;
		});

		//接收资产信息
		$scope.$on("assetsSelect", function(event, data) {
			console.log(data);
			var stringAssetsArray = JSON.stringify($scope.data.assetsArray);
			for (var i = 0; i < data.length; i++) {
				if (!isExistInAssetsArray(data[i].hide.assetDetailId)) {
					data[i].requestAmount = 1;
					$scope.data.assetsArray.push(data[i]);
				}
			}
			$scope.calTotal();
			$ionicScrollDelegate.resize();
		});

	}
]);