angular.module("PMPMobile.directive").directive('assetsList', ['$rootScope', '$ionicModal', '$location', '$ionicScrollDelegate', 'AssetsApiServices',
	function($rootScope, $ionicModal, $location, $ionicScrollDelegate, AssetsApiServices) {
		return {
			restrict: 'E',
			replace: true,
			scope: {
				data: '=',
				isall: '=',
				selectedArr: '='
			},
			templateUrl: 'views/property/assets/assets-list.html-item.html',
			link: function(scope) {
				//是否显示提交按钮
				scope.data.tobeconfirmed = scope.data.hide.orderStatusNum == '00' || scope.data.hide.orderStatusNum == '04' ? true : false;
				//是否显示删除按钮
				scope.data.isShowDelete = scope.data.hide.orderStatusNum == '00' || scope.data.hide.orderStatusNum == '04' || scope.data.hide.orderStatusNum == '03' ? true : false;
				//是否批量
				scope.isbatch = scope.isall ? "all" : "";
				//判断状态，改变class
				switch (scope.data.hide.orderStatusNum) {
					case "00":
						scope.data.statusColor = "unsubmit";
						break;
					case "01":
						scope.data.statusColor = "to-be-confirmed";
						break;
					case "02":
						scope.data.statusColor = "archive";
						break;
					case "03":
						scope.data.statusColor = "reject";
						break;
					case "04":
						scope.data.statusColor = "objection";
						break;
					default:
						scope.data.statusColor = "to-be-confirmed";
						break;
				}

				//提交
				function SubmitAssets() {
					AssetsApiServices.assetsMultiSubmit("assetApplyId=" + scope.data.hide.assetApplyId).then(function(res) {
						if (res.Flag == "1") {
							scope.modalShow = "6";
							scope.alertMsg = "提交成功";
							scope.openModalSubmit();
							//$("#" + scope.data.hide.assetApplyId).hide();
							window.setTimeout(function() {
								scope.closeModal();
							}, 1000);
							scope.$parent.$parent.$parent.init();
						}else{
							$scope.modalShow = "4";	
							$scope.remind = res.Result.errmsg;
							$scope.modal.show();
						}
					});

				};

				//删除
				function DeleteAsset() {
					AssetsApiServices.assetsDel("assetApplyId=" + scope.data.hide.assetApplyId).then(function(res) {
						if (res.Flag == "1") {
							scope.modalShow = "6";
							scope.alertMsg = "删除成功";
							scope.openModalSubmit();
							//$("#" + scope.data.hide.assetApplyId).hide();
							window.setTimeout(function() {
								scope.closeModal();
							}, 1000);
							scope.$parent.$parent.$parent.init();
						}else{
							$scope.modalShow = "4";
							$scope.remind = res.Result.errmsg;
							$scope.modal.show();
						}
					});

				};

				//初始化模态对话框窗口
				$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.modal = modal;
				});
				scope.openModalSubmit = function() {
					scope.modal.show();
				};
				scope.closeModal = function() {
					scope.modal.hide();
				};

				//点击多选框checkBox事件
				scope.changeStatus = function() {
					if (scope.data.isSelect == undefined) {
						scope.data.isSelect = false;
					}
					scope.data.isSelect = !scope.data.isSelect;
					if (scope.data.isSelect) { //若选中
						scope.selectedArr.push(scope.data);
					} else {
						for (selArrIndex in scope.selectedArr) {
							if (scope.data.show.requestNote == scope.selectedArr[selArrIndex].show.requestNote) {
								scope.selectedArr.splice(selArrIndex, 1);
								break;
							}
						}
					}
					console.log("scope.selectedArr", scope.selectedArr);
				};
				scope.confirm = function() {
					scope.modalShow = "5";
					scope.explain = "您是否提交该申请";
					scope.ok = "提交";
					scope.no = "取消";
					scope.openModalSubmit();
				};
				scope.isRevoke = function(isTrue) {
					if (!isTrue) {
						scope.closeModal();
					} else if (scope.ok == "提交") {
						SubmitAssets();
					} else if (scope.ok == "删除") {
						DeleteAsset();
					} else if (scope.ok == "进行补充") {
						$location.path('newAssets/edit');
						scope.closeModal();
					}
				};
				scope.goIntoDetail = function() {
					if (scope.data.tobeconfirmed) {
						$location.path('newAssets/edit/' + scope.data.hide.assetApplyId + '/' + scope.data.show.requestNote);
					} else {
						$location.path('newAssets/detail/' + scope.data.hide.assetApplyId + '/' + scope.data.show.requestNote);
					}

				};
				scope.delete = function() {
					scope.modalShow = "5";
					scope.explain = "您是否删除该申请";
					scope.ok = "删除";
					scope.no = "取消";
					scope.openModalSubmit();
				}
			}
		};
	}
]);