angular.module('PMPMobile.services').factory('AssetsApiServices', ["$http", "Global", "$q",
	function($http, Global, $q) {
		var getPromise = function(p) {
			var defer = $q.defer();
			p.success(function(response) {
				return defer.resolve(response);
			}).error(function() {
				return defer.reject();
			});
			return defer.promise;
		};
		return {
			getAssetsList: function(data, pageObj) {
				var url = Global.apiPath + '/pmp/asset/app/assetApply/list.ht?page=' + pageObj.page + '&pageSize=' + pageObj.pageSize + data;
				return getPromise($http.get(url));
			},
			getEditData: function(data) {
				var url = Global.apiPath + '/pmp/asset/app/assetApply/edit.ht';
				return getPromise($http.post(url, data));
			},
			getNetSearchList: function(data) {
				var url = Global.apiPath + '/pmp/materiel/app/selectNet/assetForNet.ht';
				return getPromise($http.post(url, data));
			},
			//批量列表接口
			getAssetsListBatch: function(pageSize, page, weekDate, orderStatusNum, requestNote) {
				var url = Global.apiPath + "/pmp/asset/app/assetApply/list.ht";
				var data = "page=" + page + "&pageSize=" + pageSize + "&weekDate=" + weekDate + "&requestNote=" + requestNote + "&orderStatusNum=" + orderStatusNum;
				return getPromise($http.post(url, data));
			},
			//资产申请删除接口
			assetsDel: function(data) {
				var url = Global.apiPath + '/pmp/asset/app/assetApply/del.ht';
				return getPromise($http.post(url, data));
			},
			//资产申请批量提交接口
			assetsMultiSubmit: function(data) {
				var url = Global.apiPath + '/pmp/asset/app/assetApply/toEcp.ht';
				return getPromise($http.post(url, data));
			},
			//提交资产申请
			submitAssetsAplly: function(data) {
				var url = Global.apiPath + '/pmp/asset/app/assetApply/save.ht';
				return getPromise($http.post(url, data));
			}
		};
	}
]);