angular.module('PMPMobile.controller').controller('GoodsBatchController', ['$rootScope', "$scope", '$stateParams', '$ionicScrollDelegate', '$location', '$timeout', '$ionicModal', 'FooterServices', 'GoodsApiServices',
	function($rootScope, $scope, $stateParams, $ionicScrollDelegate, $location, $timeout, $ionicModal, FooterServices, GoodsApiServices) {
		FooterServices.hide();
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.title = "批量操作";

		//获取批量操作的数据类型
		$scope.currentTab = $stateParams.tabType;
		//存储批量选择的数组
		$scope.goodsBatchArr = [];
		//全部时间期限数组
		$scope.timeFilterOpt = [{
			"name": "本周",
			"select": false
		}, {
			"name": "两周内",
			"select": false
		}, {
			"name": "三周内",
			"select": false
		}, {
			"name": "四周内",
			"select": false
		}];
		$scope.timeFilterOpt[0].select = true; //初始化timeFilterOption默认第一项为选中状态。
		$scope.timeFilter = $scope.timeFilterOpt[0].name; //物料申请-搜索-时间段筛选字段
		$scope.showTimeFilter = false; //标识是否显示timefilter的下拉列表
		//所有状态数组
		$scope.statusFilterOpt = [{
			"name": '全部状态',
			"select": false
		}, {
			"name": '已发放',
			"select": false
		}, {
			"name": '部分确认',
			"select": false
		}];
		$scope.statusFilterOpt[0].select = true;
		$scope.statusFilter = $scope.statusFilterOpt[0].name;
		$scope.showStatusFilter = false;
		//展开状态列表
		$scope.statusFilterToggle = function() {
			if($scope.showTimeFilter){
				$scope.showTimeFilter = !$scope.showTimeFilter;
			}
			$scope.showStatusFilter = !$scope.showStatusFilter;
		};
		$scope.statusFilOptClk = function(option) { //选择状态
			//单选控制
			_.each($scope.statusFilterOpt, function(optItem) {
				optItem.select = false;
			})
			option.select = true;
			//更新当前选择
			$scope.statusFilter = option.name;
			switch (option.name) {
				case '全部状态':
					$scope.status = '1,2';
					//清空数据
					dataChangesInit();
					getDataList();
					break;
				case '已发放':
					$scope.status = '1';
					dataChangesInit();
					getDataList();
					break;
				case '部分确认':
					$scope.status = '2';
					dataChangesInit();
					getDataList();
					break;
				default:
					break;
			}
			//关闭下拉选择
			$scope.showStatusFilter = false;

		};
		//timeFilter的toggle事件
		$scope.timeFilterToggle = function() {
			if($scope.showStatusFilter){
				$scope.showStatusFilter = !$scope.showStatusFilter;
			}
			$scope.showTimeFilter = !$scope.showTimeFilter;
		};
		$scope.timeFilOptClk = function(option) { //选择时间
			//单选控制
			_.each($scope.timeFilterOpt, function(optItem) {
				optItem.select = false;
			})
			option.select = true;
			$scope.timeFilter = option.name;
			switch (option.name) {
				case "本周":
					$scope.time = 1;
					dataChangesInit();
					getDataList();
					break;
				case "两周内":
					$scope.time = 2;
					dataChangesInit();
					getDataList();
					break;
				case "三周内":
					$scope.time = 3;
					dataChangesInit();
					getDataList();
					break;
				case "四周内":
					$scope.time = 4;
					dataChangesInit();
					getDataList();
					break;
				default:
					break;
			}
			$scope.showTimeFilter = false;

		};

		//数据初始化
		initDataFun();

		function init() {
			if ($scope.currentTab == "物资确认") { //初始化页面类型
				console.log("批量确认的是" + $scope.currentTab);
				$scope.isShow = true;
			} else if ($scope.currentTab == "劳保确认") {
				console.log("批量确认的是" + $scope.currentTab);
				$scope.isShow = false;
			}
			$scope.pageType = "batch";
			$scope.time = 1;
			$scope.status = '1,2';
			// $scope.search = {
			// 	searchWord : ''
			// }
			dataChangesInit();
			//$scope.timeFilter = $scope.timeFilterOpt[0].name; //筛选条件初始化
			//$scope.statusFilter = $scope.statusFilterOpt[0].name;
		}

		function dataChangesInit(){
			$scope.dataGoods = [];
			$scope.dataLabor = [];
			$scope.page = 1;
			$scope.pageSize = 8;
			$scope.noMoreItemsAvailable = true;
			$scope.isFirstIn = true;
		}

		function initDataFun(type) {
			init();
			$ionicScrollDelegate.scrollTop(true);
			getDataList(type);
		}

		function getDataList(type) {
			var list = [];
			if ($scope.currentTab == "物资确认") { //页面数据类型
				//list = GoodsApiServices.getGoodsList($scope.pageSize, $scope.page, $scope.status, "");
				//$scope.dataGoods = $scope.dataGoods.concat(list);
				GoodsApiServices.goodsSearch($scope.pageSize, $scope.page, $scope.status, $scope.time, "").then(function(res) {
					//list = GoodsApiServices.getGoodsList($scope.pageSize, $scope.page, $scope.status, "");
					for (var i = 0; i < res.Result.length; i++) {
						res.Result[i].show = objtoarray(res.Result[i].show);
						res.Result[i].show1 = objtoarray(res.Result[i].show1);
					}
					$scope.dataGoods = $scope.dataGoods.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.dataGoods.length;
					//停止刷新
					cancelScrollInitFunction($scope);
					//停止加载
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					refreshData(type, res.Result.length);
				});
			} else if ($scope.currentTab == "劳保确认") {
				//list = GoodsApiServices.getLaborList($scope.pageSize, $scope.page, $scope.status, "");
				//$scope.dataLabor = $scope.dataLabor.concat(list);
				GoodsApiServices.laborSearch($scope.pageSize, $scope.page, $scope.status, $scope.time, "").then(function(res) {
					for (var i = 0; i < res.Result.length; i++) {
						res.Result[i].show = objtoarray(res.Result[i].show);
						res.Result[i].show1 = objtoarray(res.Result[i].show1);
					}
					$scope.dataLabor = $scope.dataLabor.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.dataLabor.length;
					//停止刷新
					cancelScrollInitFunction($scope);
					//停止加载
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					refreshData(type, res.Result.length);
				});
			}
			
		}

		//上拉加载更多
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) { //没有更多数据时
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) { //第一次进来
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.page++;
				getDataList("loadMore");
			}
		};

		//下拉刷新
		$scope.onRefresh = function() {
			dataChangesInit();
			getDataList("refresh");
		};

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}
		$scope.selectItem = function(item) {
				if(item.isSelected == undefined){
					item.isSelected = false;
				}
				item.isSelected = !item.isSelected;
				// if(item.isSelected){
				// 	$scope.goodsBatchArr.push(item);
				// }else{
				// 	for(batchIndex in $scope.goodsBatchArr){
				// 		if($scope.goodsBatchArr[batchIndex].show.mblnr == item.show.mblnr){
				// 			$scope.goodsBatchArr.splice(batchIndex, 1);
				// 		}
				// 	}
				// }
				console.log(item.isSelected);
			}
			//全选
		$scope.listBatchSelAll = function() {
			$scope.goodsBatchArr = [];
				if ($scope.currentTab == "物资确认") {
					_.each($scope.dataGoods, function(item) {
						item.isSelected = true;
						// $scope.goodsBatchArr.push(item);
					});
					// $scope.goodsBatchArr = [];
				} else if ($scope.currentTab == "劳保确认") {
					_.each($scope.dataLabor, function(item) {
						item.isSelected = true;
						// $scope.goodsBatchArr.push(item);
					});
					// $scope.goodsBatchArr = [];
				}
			}
			//清空所选
		$scope.listBatchCancelSel = function() {
				if ($scope.currentTab == "物资确认") {
					_.each($scope.dataGoods, function(item) {
						item.isSelected = false;
					});
					$scope.goodsBatchArr = [];
				} else if ($scope.currentTab == "劳保确认") {
					_.each($scope.dataLabor, function(item) {
						item.isSelected = false;
					});
					// $scope.goodsBatchArr = [];
				}
			}

	}
]);