angular.module('PMPMobile.controller').controller('GoodsListController', ['$rootScope', "$scope", '$ionicScrollDelegate', '$location', '$timeout', 'FooterServices', 'GoodsApiServices',
	function($rootScope, $scope, $ionicScrollDelegate, $location, $timeout, FooterServices, GoodsApiServices) {
		FooterServices.activeItemByIndex(2);
		$scope.tabs = [{
			title: '物资确认'
		}, {
			title: '劳保确认'
		}];
		//默认物资确认列表
		$scope.isShow = true;
		$scope.currentTab = '物资确认';
		//切换标签
		$scope.onClickTab = function(tab) {
				//$ionicScrollDelegate.scrollTop(true);
				if ($scope.currentTab != tab.title) {
					$scope.currentTab = tab.title;
					$scope.isShow = !$scope.isShow;
				}
				initDataFun();
			}
			//标签状态
		$scope.isActiveTab = function(tabTitle) {
			return tabTitle == $scope.currentTab;
		}
		//刷新页面
		$scope.$on("backList", function(event, data) {
			initDataFun();
		});

		//数据初始化
		initDataFun();

		function init() {
			if ($scope.currentTab == "物资确认") { //初始化页面类型
				console.log("这里是" + $scope.currentTab);
				$scope.dataGoods = [];
				$scope.isShow = true;
			} else if ($scope.currentTab == "劳保确认") {
				console.log("这里是" + $scope.currentTab);
				$scope.dataLabor = [];
				$scope.isShow = false;
			}
			$scope.pageType = "list";
			// $scope.status = 'ALL';	
			$scope.page = 1;
			$scope.pageSize = 8;
			$scope.noMoreItemsAvailable = true;
			$scope.isFirstIn = true;
		}


		function initDataFun(type) {
			init();
			$ionicScrollDelegate.scrollTop(true);
			getDataList(type);
		}

		function getDataList(type) {
			//var list = [];
			if ($scope.currentTab == "物资确认") { //页面数据类型
				GoodsApiServices.getGoodsList($scope.pageSize, $scope.page).then(function(res) {
					//list = GoodsApiServices.getGoodsList($scope.pageSize, $scope.page, "", "");
					console.log("wuzi: ", res);
					for (var i = 0; i < res.Result.length; i++) {
						res.Result[i].show = objtoarray(res.Result[i].show);
						res.Result[i].show1 = objtoarray(res.Result[i].show1);
					}
					$scope.dataGoods = $scope.dataGoods.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.dataGoods.length;
					//停止刷新
					cancelScrollInitFunction($scope);
					//停止加载
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					//刷新数据
					refreshData(type, res.Result.length);
				});
			} else if ($scope.currentTab == "劳保确认") {
				GoodsApiServices.getLaborList($scope.pageSize, $scope.page).then(function(res) {
					//list = GoodsApiServices.getLaborList($scope.pageSize, $scope.page, $scope.status, "");
					console.log("laobao: ", res);
					for (var i = 0; i < res.Result.length; i++) {
						res.Result[i].show = objtoarray(res.Result[i].show);
						res.Result[i].show1 = objtoarray(res.Result[i].show1);
					}
					$scope.dataLabor = $scope.dataLabor.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.dataLabor.length;
					//停止刷新
					cancelScrollInitFunction($scope);
					//停止加载
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					//刷新数据
					refreshData(type, res.Result.length);
				});
			}
			//var count = 5; //假设最多只有5页数据

			// //停止刷新
			// cancelScrollInitFunction($scope);
			// //停止加载
			// $scope.$broadcast('scroll.infiniteScrollComplete');
			// $ionicScrollDelegate.resize();

		}

		//上拉加载更多
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) { //没有更多数据时
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) { //第一次进来
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.page++;
				getDataList("loadMore");
			}
		};

		//下拉刷新
		$scope.onRefresh = function() {
			init();
			getDataList("refresh");
		};

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}

		$scope.listBatch = function() {
			$location.path("/goodsBatch/" + $scope.currentTab);
		}

		//侧滑出菜单
		$scope.slideMenu = function() {
			var exec = cordova.require("cordova/exec");
			exec(callbackok, callbackerr, 'TogglePlugin', 'toggle', [4]);
		}

		function callbackok() {
			console.log('callback ok');
		}

		function callbackerr(result) {
			console.log("error!");
		}

		//搜索
		$scope.search = function() {
			console.log("搜索：" + $scope.currentTab);
			$location.path("/goodsSearch/" + $scope.currentTab);
		}
	}
]);