angular.module('PMPMobile.controller').controller('GoodsSearchController', ['$rootScope', "$scope", '$stateParams', '$ionicScrollDelegate', '$location', '$timeout', '$ionicModal', 'FooterServices', 'GoodsApiServices',
	function($rootScope, $scope, $stateParams, $ionicScrollDelegate, $location, $timeout, $ionicModal, FooterServices, GoodsApiServices) {
		FooterServices.hide();
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.currentTab = $stateParams.tabType;
		$scope.changeCase=function(){
			if($scope.searchCase=="查找编号"){
				$scope.searchCase="条件查询";
				$scope.time = "";
				$scope.status = "";
				$scope.search.searchWord = '';
				dataChangesInit();
				getDataList();
			}	else{
				$scope.searchCase="查找编号"
				$scope.time = 1;
				$scope.status = "";
				$scope.search.searchWord = '';
				_.each($scope.timeFilterOpt, function(optItem) {
					optItem.select = false;
				})
				$scope.timeFilterOpt[0].select = true;
				$scope.timeFilter = $scope.timeFilterOpt[0].name;
				_.each($scope.statusFilterOpt, function(optItem) {
					optItem.select = false;
				})
				$scope.statusFilterOpt[0].select = true;
				$scope.statusFilter = $scope.statusFilterOpt[0].name;
				dataChangesInit();
				getDataList();
			}
			$scope.searchId=!$scope.searchId;
		}
		//全部时间期限数组
		$scope.timeFilterOpt = [{
			"name": "本周",
			"select": false
		}, {
			"name": "两周内",
			"select": false
		}, {
			"name": "三周内",
			"select": false
		}, {
			"name": "四周内",
			"select": false
		}];
		$scope.timeFilterOpt[0].select = true; //初始化timeFilterOption默认第一项为选中状态。
		$scope.timeFilter = $scope.timeFilterOpt[0].name; //物料申请-搜索-时间段筛选字段
		$scope.showTimeFilter = false; //标识是否显示timefilter的下拉列表
		//所有状态数组
		$scope.statusFilterOpt = [{
			"name": '全部状态',
			"select": false
		}, {
			"name": '已发放',
			"select": false
		}, {
			"name": '部分确认',
			"select": false
		}, {
			"name": '已确认',
			"select": false
		}];
		$scope.statusFilterOpt[0].select = true;
		$scope.statusFilter = $scope.statusFilterOpt[0].name;
		$scope.showStatusFilter = false;
		//展开状态列表
		$scope.statusFilterToggle = function() {
			if($scope.showTimeFilter){
				$scope.showTimeFilter = !$scope.showTimeFilter;
			}
			$scope.showStatusFilter = !$scope.showStatusFilter;
		};
		$scope.statusFilOptClk = function(option) { //选择状态
			//单选控制
			_.each($scope.statusFilterOpt, function(optItem) {
				optItem.select = false;
			})
			option.select = true;
			//更新当前选择
			$scope.statusFilter = option.name;
			switch (option.name) {
				case '全部状态':
					$scope.status = '';
					//清空数据
					// $scope.dataGoods = [];
					// $scope.dataLabor = [];
					// $scope.noMoreItemsAvailable = true;
					dataChangesInit();
					getDataList();
					break;
				case '已发放':
					$scope.status = '1';
					// $scope.dataGoods = [];
					// $scope.dataLabor = [];
					// $scope.noMoreItemsAvailable = true;
					dataChangesInit();
					getDataList();
					break;
				case '部分确认':
					$scope.status = '2';
					// $scope.dataGoods = [];
					// $scope.dataLabor = [];
					// $scope.noMoreItemsAvailable = true;
					dataChangesInit();
					getDataList();
					break;
				case '已确认':
					$scope.status = '3';
					// $scope.dataGoods = [];
					// $scope.dataLabor = [];
					// $scope.noMoreItemsAvailable = true;
					dataChangesInit();
					getDataList();
					break;
				default:
					break;
			}
			//关闭下拉选择
			$scope.showStatusFilter = false;

		};
		//timeFilter的toggle事件
		$scope.timeFilterToggle = function() {
			if($scope.showStatusFilter){
				$scope.showStatusFilter = !$scope.showStatusFilter;
			}
			$scope.showTimeFilter = !$scope.showTimeFilter;
		};
		$scope.timeFilOptClk = function(option) { //选择时间
			//单选控制
			_.each($scope.timeFilterOpt, function(optItem) {
				optItem.select = false;
			})
			option.select = true;
			$scope.timeFilter = option.name;
			switch (option.name) {
				case "本周":
					$scope.time = 1;
					dataChangesInit();
					getDataList();
					break;
				case "两周内":
					$scope.time = 2;
					dataChangesInit();
					getDataList();
					break;
				case "三周内":
					$scope.time = 3;
					dataChangesInit();
					getDataList();
					break;
				case "四周内":
					$scope.time = 4;
					dataChangesInit();
					getDataList();
					break;
				default:
					break;
			}
			$scope.showTimeFilter = false;

		};
		//数据初始化
		initDataFun();

		function init() {
			$scope.searchCase="查找编号";
			$scope.searchId=false;
			if ($scope.currentTab == "物资确认") { //初始化页面类型
				console.log("搜索数据类型" + $scope.currentTab);
				$scope.isShow = true;
			} else if ($scope.currentTab == "劳保确认") {
				console.log("搜索数据类型" + $scope.currentTab);
				$scope.isShow = false;
			}
			$scope.pageType = "list";
			$scope.status = '';
			$scope.time = 1;
			$scope.search = {
				searchWord : ''
			}
			dataChangesInit();
		}

		function dataChangesInit(){
			$scope.dataGoods = [];
			$scope.dataLabor = [];
			$scope.page = 1;
			$scope.pageSize = 8;
			$scope.noMoreItemsAvailable = true;
			$scope.isFirstIn = true;
			$ionicScrollDelegate.scrollTop(false);
		}

		function initDataFun(type) {
			init();
			$ionicScrollDelegate.scrollTop(true);
			getDataList(type);
		}

		function getDataList(type) {
			if ($scope.currentTab == "物资确认") { //页面数据类型
				GoodsApiServices.goodsSearch($scope.pageSize, $scope.page, $scope.status, $scope.time, $scope.search.searchWord).then(function(res) {
					//list = GoodsApiServices.getGoodsList($scope.pageSize, $scope.page, $scope.status, "");
					console.log("search: ",res);
					for (var i = 0; i < res.Result.length; i++) {
						res.Result[i].show = objtoarray(res.Result[i].show);
						res.Result[i].show1 = objtoarray(res.Result[i].show1);
					}
					$scope.dataGoods = $scope.dataGoods.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.dataGoods.length;
					//停止刷新
					cancelScrollInitFunction($scope);
					//停止加载
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					refreshData(type, res.Result.length);
				});
			} else if ($scope.currentTab == "劳保确认") {
				//list = GoodsApiServices.getLaborList($scope.pageSize, $scope.page, $scope.status, "");
				//$scope.dataLabor = $scope.dataLabor.concat(list);
				GoodsApiServices.laborSearch($scope.pageSize, $scope.page, $scope.status, $scope.time, $scope.search.searchWord).then(function(res) {
					for (var i = 0; i < res.Result.length; i++) {
						res.Result[i].show = objtoarray(res.Result[i].show);
						res.Result[i].show1 = objtoarray(res.Result[i].show1);
					}
					$scope.dataLabor = $scope.dataLabor.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.dataLabor.length;
					//停止刷新
					cancelScrollInitFunction($scope);
					//停止加载
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					refreshData(type, res.Result.length);
				});
			}
		}

		//上拉加载更多
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) { //没有更多数据时
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) { //第一次进来
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.page++;
				getDataList("loadMore");
			}
		};

		//下拉刷新
		$scope.onRefresh = function() {
			dataChangesInit();
			getDataList("refresh");
		};

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}

		$scope.submit = function() {
			if ($scope.currentTab == "物资确认") { //页面数据类型
				dataChangesInit();
				getDataList();
				//$scope.dataGoods = GoodsApiServices.getGoodsById($scope.searchWord);
			} else if ($scope.currentTab == "劳保确认") {
				dataChangesInit();
				getDataList();
				//$scope.dataLabor = GoodsApiServices.getLaborById($scope.searchWord);
			}
		}
		$scope.back = function() {
			$location.path("/goods");
		}

	}
]);