angular.module('PMPMobile.controller').controller('ReceiveConfirmController', ['$rootScope', "$scope", '$stateParams', '$ionicScrollDelegate', '$location', '$timeout', '$ionicModal', 'FooterServices', 'GoodsApiServices',
	function($rootScope, $scope, $stateParams, $ionicScrollDelegate, $location, $timeout, $ionicModal, FooterServices, GoodsApiServices) {
		$ionicModal.fromTemplateUrl('views/property/goods/receive-confirm.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.confirmModal = modal;
		});
		//模态对话框窗口初始化
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		$scope.title = "领用确认";
		$scope.confirmList = [];

		/*页面关闭时销毁弹出框*/
		$scope.$on('$destroy', function() {
			$scope.modal.remove();
			$scope.confirmModal.remove();
		});

		function goodsConfirmCountInit(item) { //物资确认数量字段处理
			if (item.show1[3].value != null) {
				item.confirmCount = item.show1[3].value;
			} else {
				item.confirmCount = "请填写领用数量";
			}
		}

		function laborConfirmCountInit(item) { //劳保确认数量字段处理
				if (item.show1[5].value != null) {
					item.confirmCount = item.show1[5].value;
				} else {
					item.confirmCount = "请填写领用数量";
				}
			}
			//单个确认
		$scope.goConfirm = function(item, type) {
				$scope.currentTab = type;
				if (type == "物资确认") {
					goodsConfirmCountInit(item);
					$scope.confirmList.push(item);
					$scope.confirmGoods = true;
					$scope.confirmModal.show();
				} else if (type == "劳保确认") {
					laborConfirmCountInit(item);
					$scope.confirmList.push(item);
					$scope.confirmGoods = false;
					$scope.confirmModal.show();
				}
			}
			//批量确认
		$scope.listBatchSubmit = function() {
				if ($scope.currentTab == "物资确认") { //页面数据展示为物资
					_.each($scope.dataGoods, function(item) {
						if (item.isSelected) {
							goodsConfirmCountInit(item);
							$scope.confirmList.push(item);
						}
					});
					$scope.confirmGoods = true;
					$scope.confirmModal.show();
				} else if ($scope.currentTab == "劳保确认") { //页面数据展示为劳保
					_.each($scope.dataLabor, function(item) {
						if (item.isSelected) {
							laborConfirmCountInit(item);
							$scope.confirmList.push(item);
						}
					})
					$scope.confirmGoods = false;
					$scope.confirmModal.show();
				}
			}
			//退出领用确认模态框
		$scope.back = function() {
				//清空确认列表数据
				$scope.confirmList = [];
				$scope.confirmModal.hide();
			}
			//确认领用按钮
		$scope.submitConfirm = function() {
				$scope.modalShow = "5";
				$scope.explain = "是否确认领用？";
				$scope.ok = "是";
				$scope.no = "否";
				$scope.modal.show();
			}
			//确认领用校验确认数量大于前确认数量小于领用量
		$scope.confirmNumValid = function(item, index) {
				if (item.confirmCount == "") {
					item.confirmCount = 0;
				}
				if ($scope.currentTab == "物资确认") { //物资确认校验
					//校验确认量必须在初始值与领用总量之间(包含)
					console.log(item.confirmCount);
					console.log(item.show1[3].value);
					console.log(item.show1[2].value);
					if (parseInt(item.confirmCount) >= parseInt(item.show1[3].value) && parseInt(item.confirmCount) <= parseInt(item.show1[2].value)) {
						item.ifConfirmNumValid = true;
					} else {
						item.ifConfirmNumValid = false;
						$scope.modalShow = "4";
						$scope.remind = "确认数量不能超出申请数量，确认数量需介于已确认数量"+item.show1[3].value+"和总数量"+item.show1[2].value+"之间！";		
						item.confirmCount = item.show1[3].value;
						$scope.modal.show();
					}
				} else { //劳保确认量校验
					if (parseInt(item.confirmCount) >= parseInt(item.show1[5].value) && parseInt(item.confirmCount) <= parseInt(item.show1[4].value)) {
						item.ifConfirmNumValid = true;
					} else {
						item.ifConfirmNumValid = false;
						$scope.modalShow = "4";
						$scope.remind = "确认数量不能超出申请数量，确认数量需介于已确认数量"+item.show1[5].value+"和总数量"+item.show1[4].value+"之间！";
						item.confirmCount = item.show1[5].value;
						$scope.modal.show();
					}
				}
			}
			//只允许输入数字
		$scope.onlyNum = function(item, index) {
			var re = /^[0-9]*[1-9][0-9]*$/;
			var temp = item.confirmCount;
			item.confirmCount = "";
			if (re.test(temp)) { //是正整数
				item.confirmCount = temp;
				console.log(item.confirmCount);
			} else {
				item.confirmCount = parseInt(temp);
				console.log(item.confirmCount);
			}


		}
		$scope.hide = function() {
			$scope.modal.hide();
		};

		//领用确认模态对话框点击确定或者取消
		$scope.isRevoke = function(isTrue) {
			if (isTrue) { //是按钮
				$scope.modal.hide();
				var idArr = []; //确认列表id数组
				var confirmCountArr = []; //确认数量数组
				_.each($scope.confirmList, function(item) { //遍历确认列表数据
					if (item.confirmCount == 0) { //如果有已发放未填写确认量的 提示
						$scope.modalShow = "4";
						$scope.remind = "请填写完所有已发放的确认量！";
						$scope.modal.show();
						$scope.confirmOk = false; //是否可以请求确认
					} else {
						$scope.confirmOk = true;
						idArr.push(item.hide.id);
						confirmCountArr.push(parseInt(item.confirmCount));
					}
				});
				var idStr = idArr.join(",");
				var confirmCountStr = confirmCountArr.join(",");
				if ($scope.confirmOk) { //可以向后台请求
					if ($scope.currentTab == "物资确认") { //物资确认
						GoodsApiServices.goodsConfirm(idStr, confirmCountStr).then(function(res) {
							console.log(idStr);
							console.log(confirmCountStr);
							console.log("请求物资确认");
							console.log(res);
							if (res.Flag == 1) {
								$scope.confirmList = [];
								$scope.confirmModal.hide();
								$scope.$emit("backList", "");
								//$location.path("/goods");
							}
						})
					} else { //劳保确认
						GoodsApiServices.laborComfirm(idStr, confirmCountStr).then(function(res) {
							console.log(idStr);
							console.log(confirmCountStr);
							console.log("请求劳保确认");
							console.log(res);
							if (res.Flag == 1) {
								$scope.confirmList = [];
								$scope.confirmModal.hide();
								$scope.$emit("backList", "");
								//$location.path("/goods");
							}
						})
					}

				}
			} else { //否按钮
				$scope.modal.hide();
			}
		}
	}
]);