angular.module('PMPMobile.services').factory('GoodsApiServices', ["$http", "Global", "$q",
	function($http, Global, $q) {
		var getPromise = function(p) {
			var defer = $q.defer();
			p.success(function(response) {
				return defer.resolve(response);
			}).error(function() {
				return defer.reject();
			});
			return defer.promise;
		};
		var pageCount = 5;
		return {
			//获取物资数据
			getGoodsList: function(pageSize, page) {//按条件分页获取数据 
				var url = Global.apiPath + "/pmp/materiel/app/wareData/list.ht";
				var data = "page=" + page + "&pageSize=" + pageSize + "&status="+ "" + "&time="+ "" + "&keyword=" + "";
				return getPromise($http.post(url,data));
			},
			
			//获取劳保数据
			getLaborList: function(pageSize, page) {//按条件分页获取数据 

				var url = Global.apiPath + "/pmp/materiel/app/labourData/list.ht";
				var data = "page=" + page + "&pageSize=" + pageSize + "&status="+ "" + "&time="+ "" + "&keyword=" + "";
				return getPromise($http.post(url,data));
			},
			//物资搜索接口/批量操作
			goodsSearch:function(pageSize, page, status, time, keyword){
				var url = Global.apiPath + "/pmp/materiel/app/wareData/list.ht";
				var data = "page=" + page + "&pageSize=" + pageSize + "&status="+ status + "&time="+ time + "&keyword=" + keyword;
				return getPromise($http.post(url,data));
			},
			//劳保搜索接口/批量操作
			laborSearch:function(pageSize, page, status, time, keyword){
				var url = Global.apiPath + "/pmp/materiel/app/labourData/list.ht";
				var data = "page=" + page + "&pageSize=" + pageSize + "&status="+ status + "&time="+ time + "&keyword=" + keyword;
				return getPromise($http.post(url,data));
			},
			goodsConfirm:function(idStr,confirmCountStr){
				var url = Global.apiPath + "/pmp/materiel/app/wareData/confirm.ht";
				var data = "id=" + idStr + "&realRefmg=" + confirmCountStr;
				return getPromise($http.post(url,data));
			},
			//劳保单条确认
			laborComfirm:function(idStr, confirmCountStr){
				var url = Global.apiPath + "/pmp/materiel/app/labourData/confirm.ht";
				var data = "id=" + idStr + "&realRefmg=" + confirmCountStr;
				return getPromise($http.post(url,data));
			}
			//以申请单编号查找物资数据
			// getGoodsById:function(goodsId){
			// 	var res=[];
			// 	return res;
			// },
			//已申请单编号查找劳保数据
			// getLaborById:function(laborId){
			// 	var res=[];
			// 	return res;
			// }
		};
	}
]);