angular.module('PMPMobile.controller').controller('MaterielsListController', ['$rootScope', "$scope", '$ionicScrollDelegate', '$location','$timeout', '$ionicModal', 'FooterServices', 'MaterielsApiServices',
	function($rootScope, $scope, $ionicScrollDelegate, $location, $timeout, $ionicModal, FooterServices, MaterielsApiServices) {
		FooterServices.activeItemByIndex(1);
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});
		
		initDataFun();

		function init(){
			$scope.materielsArr = [];
			$scope.page = 1;
			$scope.pageSize = 8;
			$scope.noMoreItemsAvailable = true;
			$scope.isFirstIn = true;
		}

		function initDataFun(type) {
			init();			
			getDataList(type);
		}

		function getDataList(type) {
			MaterielsApiServices.getMaterielsListDatas($scope.pageSize, $scope.page).then(function(res) {
				if(res.Flag == "1"){
					$scope.materielsArr = $scope.materielsArr.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.materielsArr.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					refreshData(type, res.Result.length);
				}else{
					$scope.modalShow = "4";
					$scope.remind = res.Result.errmsg;
					$scope.modal.show();
				}
				
			});
		}
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) {
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) {
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.page++;
				getDataList("loadMore");
			}
		};

		$scope.onRefresh = function() {
			init();
			getDataList("refresh");
		};

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}
		$scope.addNew = function(){
			$location.path("/materielsDetails/new/");
		};
		$scope.listBatch = function(){
			$location.path("/materielsBatch");
		};
		$scope.goMaSearch = function(){
			$location.path("/materielsSearch");
		};
		$scope.hide = function(){
			$scope.modal.hide();
		};
		var opId = "";
		var opIndex = "";
		var opType = "";
		$scope.operateList = function(type,index,data){
			opId = data;
			opIndex = index;
			opType = type;
			$scope.modalShow = "3";
			$scope.ok = "确定";
			$scope.no = "取消";
			if(type == 'submit'){				
				$scope.explain = "是否确定提交此项？";				
				$scope.modal.show();
			}else if(type == 'del'){
				$scope.explain = "是否确定删除此项？";				
				$scope.modal.show();
			}
			
		};
		$scope.isBatch = function(flag){
			$scope.modal.hide();
			if(flag){
				if(opType == 'submit'){
					MaterielsApiServices.materielsMultiSubmit("materielApplyId="+opId).then(function(res) {
						if(res.Flag == "1"){
							$scope.modalShow = "6";
							$scope.alertMsg = "提交成功";
							$scope.modal.show();
							$timeout(function() {
								$scope.modal.hide();
							}, 2000);
							$ionicScrollDelegate.scrollTop(false);
							init();
							getDataList();
						}else{
							$scope.modalShow = "4";
							$scope.remind = res.Result.errmsg;
							$scope.modal.show();
							
						}
					});
				}else if(opType == 'del'){
					console.log("del:");
					console.log("opId:",opId);
					console.log("opIndex:",opIndex);
					console.log("opType:",opType);
					MaterielsApiServices.materielsApplyDel(opId).then(function(res) {
						console.log("del req:",res);
						if(res.Flag == "1"){
							$scope.materielsArr.splice(opIndex,1);
							$scope.modalShow = "6";
							$scope.alertMsg = "删除成功";
							$scope.modal.show();
							$timeout(function() {
								$scope.modal.hide();
							}, 2000);
						}else{
							$scope.modalShow = "4";
							$scope.remind = res.Result.errmsg;
							$scope.modal.show();
						}
						
					});
				}		

			}else{
				console.log("no");
			}
		};
		$scope.backLogin = function() {
			var exec = cordova.require("cordova/exec");
			exec(callbackok, callbackerr, 'TogglePlugin', 'toggle', [4]);
		}

		function callbackok() {
			console.log('callback ok');
		}

		function callbackerr(result) {
			console.log("error!");
		}

}]);
