angular.module('PMPMobile.controller').controller('MaterielsSearchController', ['$rootScope', "$scope", '$ionicModal', '$ionicScrollDelegate', '$location','$timeout', 'FooterServices', 'MaterielsApiServices',
	function($rootScope, $scope, $ionicModal, $ionicScrollDelegate, $location, $timeout, FooterServices, MaterielsApiServices) {
		FooterServices.hide();
		$ionicModal.fromTemplateUrl('views/common/my-modal.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
		});

		$scope.mSearch = {
			'keyword':""
		};
		initFilter();
		initDataFun();		
		$scope.ifSearchById = false;
		$scope.searchBtnName = "查找编号";

		function initFilter(){
			$scope.timeFilterOpt = [{"name":"本周","val":"1"},{"name":"两周内","val":"2"},{"name":"三周内","val":"3"},{"name":"四周内","val":"4"}];
			$scope.timeFilterOpt[0].isRadio = true;
			$scope.timeFilter = $scope.timeFilterOpt[0];
			$scope.showTimeFilter = false;
			$scope.stateFilterOpt = [{"name":"全部状态","val":""},{"name":"未提交","val":"00"},{"name":"审批中","val":"01"},{"name":"归档","val":"02"}];
			$scope.stateFilterOpt[0].isRadio = true;
			$scope.stateFilter = $scope.stateFilterOpt[0];
			$scope.showStateFilter = false;
			$scope.mSearch.keyword = "";
		}		

		function init(){
			$scope.materielsArr = [];
			$scope.page = 1;
			$scope.pageSize = 8;
			$scope.noMoreItemsAvailable = true;
			$scope.isFirstIn = true;
		}

		function initDataFun(type) {
			init();		
			getDataList(type);
		}

		function getDataList(type) {
			MaterielsApiServices.materielsListSearch($scope.pageSize, $scope.page, $scope.timeFilter.val, $scope.stateFilter.val, $scope.mSearch.keyword).then(function(res) {
				if(res.Flag == "1"){
					$scope.materielsArr = $scope.materielsArr.concat(res.Result);
					$scope.noMoreItemsAvailable = res.totalCount == $scope.materielsArr.length;
					cancelScrollInitFunction($scope);
					$scope.$broadcast('scroll.infiniteScrollComplete');
					$ionicScrollDelegate.resize();
					refreshData(type, res.Result.length);
				}else{

				}
				
			});
		}
		$scope.loadMore = function() {
			if ($scope.noMoreItemsAvailable) {
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			}
			if ($scope.isFirstIn) {
				$scope.isFirstIn = false;
				$scope.$broadcast('scroll.infiniteScrollComplete');
				return;
			} else {
				$scope.isFirstIn = true;
				$scope.page++;
				getDataList("loadMore");
			}
		};
		$scope.onRefresh = function() {
			init();
			getDataList("refresh");
		};

		function refreshData(type, length) {
			if (type == "refresh") {
				if (length > 0) {
					$scope.refresherData = "已经为您更新" + length + "条数据";
					$(".refresher-data").show();
					$timeout(function() {
						$(".refresher-data").hide();
					}, 700);
				}

			} else if (type == "loadMore") {
				if (length > 0) {
					$scope.infiniteData = "已经为您加载" + length + "条数据";
					$(".infinite-data").show();
					$timeout(function() {
						$(".infinite-data").hide();
					}, 700);
				}
			}
			NoData(length, "您当前选择的条件没有数据");
		}
		$scope.backLogin = function(){
			$location.path("/materiels");
		};
		$scope.timeFilOptClk = function(opt){
			if(opt.isRadio == undefined){
				opt.isRadio = false;
			}
			for(o in $scope.timeFilterOpt){
				$scope.timeFilterOpt[o].isRadio = false;
			}
			opt.isRadio = true;
			$scope.timeFilter = opt;
			$ionicScrollDelegate.scrollTop(false);
			init();
			getDataList();
			$scope.showTimeFilter = false;
		};
		$scope.timeFilterToggle = function(){
			if($scope.showStateFilter){
				$scope.showStateFilter = !$scope.showStateFilter;
			}
			$scope.showTimeFilter = !$scope.showTimeFilter;
		};
		$scope.stateFilOptClk = function(opt){
			if(opt.isRadio == undefined){
				opt.isRadio = false;
			}
			for(o in $scope.stateFilterOpt){
				$scope.stateFilterOpt[o].isRadio = false;
			}
			opt.isRadio = true;
			$scope.stateFilter = opt;
			$ionicScrollDelegate.scrollTop(false);
			init();
			getDataList();
			$scope.showStateFilter = false;
		};
		$scope.stateFilterToggle = function(){
			if($scope.showTimeFilter){
				$scope.showTimeFilter = !$scope.showTimeFilter;
			}
			$scope.showStateFilter = !$scope.showStateFilter;
		};
		function searchById(){
			$scope.searchBtnName = "条件查询";
			$scope.timeFilter = {"name":"","val":""};
			$scope.stateFilter = {"name":"","val":""};
			$scope.mSearch.keyword = "";
		}
		$scope.searchBy = function(){
			$scope.ifSearchById = !$scope.ifSearchById;
			if($scope.ifSearchById){
				searchById();
			}else if(!$scope.ifSearchById){
				$scope.searchBtnName = "查找编号";
				initFilter();
			}
			
		};
		$scope.searchComplete = function(){
			$ionicScrollDelegate.scrollTop(false);
			init();
			getDataList();
		};
		var opId = "";
		var opIndex = "";
		var opType = "";
		$scope.operateList = function(type,index,data){
			opId = data;
			opIndex = index;
			opType = type;
			$scope.modalShow = "3";
			$scope.ok = "确定";
			$scope.no = "取消";
			if(type == 'submit'){				
				$scope.explain = "是否确定提交此项？";				
				$scope.modal.show();
			}else if(type == 'del'){
				$scope.explain = "是否确定删除此项？";				
				$scope.modal.show();
			}
			
		};
		$scope.isBatch = function(flag){
			$scope.modal.hide();
			if(flag){
				if(opType == 'submit'){
					MaterielsApiServices.materielsMultiSubmit("materielApplyId="+opId).then(function(res) {
						if(res.Flag == "1"){
							$scope.modalShow = "6";
							$scope.alertMsg = "提交成功";
							$scope.modal.show();
							$timeout(function() {
								$scope.modal.hide();
							}, 2000);
							$ionicScrollDelegate.scrollTop(false);
							init();
							getDataList();
						}else{
							$scope.modalShow = "4";
							$scope.remind = res.Result.errmsg;
							$scope.modal.show();
							
						}
					});
				}else if(opType == 'del'){
					MaterielsApiServices.materielsApplyDel(opId).then(function(res) {
						if(res.Flag == "1"){
							$scope.materielsArr.splice(opIndex,1);
							$scope.modalShow = "6";
							$scope.alertMsg = "删除成功";
							$scope.modal.show();
							$timeout(function() {
								$scope.modal.hide();
							}, 2000);
						}else{
							$scope.modalShow = "4";
							$scope.remind = res.Result.errmsg;
							$scope.modal.show();
						}
						
					});
				}
			}else{
			}
		};


}]);