angular.module('PMPMobile.services').factory('MaterielsApiServices', ["$http", "Global", "$q",
	function($http, Global, $q) {
		var getPromise = function(p) {
			var defer = $q.defer();
			p.success(function(response) {
				return defer.resolve(response);
			}).error(function() {
				return defer.reject();
			});
			return defer.promise;
		};
		return {
			//获取物料申请列表页数据
			getMaterielsListDatas:function(pageSize, page){
				var url = Global.apiPath + "/pmp/materiel/app/materielApply/list.ht";
				var data = "page=" + page + "&pageSize=" + pageSize + "&weekDate="+ "" + "&requestNote="+"" + "&orderStatus=" + "";
				return getPromise($http.post(url,data));				
			},
			//物料申请列表搜索/物料申请列表批量
			materielsListSearch:function(pageSize, page, weekDate, orderStatus, requestNote){				
				var url = Global.apiPath + "/pmp/materiel/app/materielApply/list.ht";
				var data = "page=" + page + "&pageSize=" + pageSize + "&weekDate="+ weekDate + "&requestNote="+ requestNote + "&orderStatusNum=" + orderStatus;
				return getPromise($http.post(url,data));				
			},
			//通过物料申请id获取详情
			getMaterielsDetail:function(materielApplyId){				
				var url = Global.apiPath + "/pmp/materiel/app/materielApply/edit.ht";
				var data = "materielApplyId=" + materielApplyId;
				return getPromise($http.post(url,data));				
			},
			//通过申请id删除物料申请
			materielsApplyDel:function(materielApplyId){
				var url = Global.apiPath + "/pmp/materiel/app/materielApply/del.ht";
				var data = "materielApplyId=" + materielApplyId;
				return getPromise($http.post(url,data));
			},
			//物料详情新增提交
			materielsNewSubmit:function(data){				
				var url = Global.apiPath + "/pmp/materiel/app/materielApply/save.ht";
				var param = "materielApply=" + JSON.stringify(data);
				return getPromise($http.post(url,param));			
			},
			//物料网点搜索接口
			getMaterielsNetSearchList: function(data) {
				var url = Global.apiPath + '/pmp/materiel/app/selectNet/materielForNet.ht';
				return getPromise($http.post(url,data));
			},
			//物料申请删除接口
			materielsDel: function(data) {
				var url = Global.apiPath + '/pmp/materiel/app/materielApply/del.ht';
				return getPromise($http.post(url,data));
			},
			//物料申请批量提交接口
			materielsMultiSubmit: function(data) {
				var url = Global.apiPath + '/pmp/materiel/app/materielApply/toEpse.ht';
				return getPromise($http.post(url,data));
			}
		};
	}
]);